IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfBusinessCardCreate')
	BEGIN
		PRINT 'Dropping Procedure adfBusinessCardCreate'
		DROP  Procedure  adfBusinessCardCreate
	END

GO

PRINT 'Creating Procedure adfBusinessCardCreate'
GO
/******************************************************************************
**		File: 
**		Name: adfBusinessCardCreate
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		07.03.13	SAP				  OPENXML
*******************************************************************************/
CREATE Procedure adfBusinessCardCreate
	@doc			Xml,
	@XPathRoot		nvarchar(256),
	@ID				TIdentifier,
	@Class			TClass,
	@State			TState,
	@FileAs			TName,
	@Comments		TNotes,
	@CompanyID		TIdentifier,
	@PositionID		TIdentifier,
	@ExternalID		TExternalIdentifier
AS
	DECLARE @result INT
			
	SET NOCOUNT ON
	SET QUOTED_IDENTIFIER ON

	INSERT INTO [BusinessCard]
		([ID], [Class], [Flag], [State], [FileAs], [Comments], [CompanyID], [PositionID], [ExternalID])
	VALUES
		(@ID, @Class, 0, @State, @FileAs, @Comments, @CompanyID, @PositionID, @ExternalID)
	IF @@error != 0
		RETURN 1
	
	IF @XPathRoot = '/adfEmployeeGet'
	BEGIN
				
		INSERT INTO [Phone] 
			([BusinessCardID], [BusinessCardClass], [PhoneTypeID], [Phone])
		SELECT
			@ID,
			@Class,
			T.c.value('PhoneTypeID[1]','int'),
			T.c.value('Phone[1]','varchar(50)')
		FROM
			@doc.nodes('/adfEmployeeGet/Phone') AS T(c)
			
				
		IF @@error != 0
			RETURN 1
			
		INSERT INTO [Address]
			([BusinessCardID], [BusinessCardClass], [AddressTypeID], [Street], [City], [Region], 
			[PostalCode], [Country], [Mail])
		SELECT
			@ID,
			@Class,
			T.c.value('AddressTypeID[1]','int'),
			T.c.value('Street[1]','nvarchar(256)'),
			T.c.value('City[1]','nvarchar(50)'),
			T.c.value('Region[1]','nvarchar(256)'),
			T.c.value('PostalCode[1]','varchar(50)'),
			T.c.value('Country[1]','nvarchar(256)'),
			(CASE 
				WHEN T.c.value('Mail[1]','varchar(5)')='false' THEN 0 
				ELSE 1 
			END)
		FROM
			@doc.nodes('/adfEmployeeGet/Address') AS T(c)
			
		IF @@error != 0
			RETURN 1

		INSERT INTO [Email]
			([BusinessCardID], [BusinessCardClass], [EmailTypeID], [Email], [DisplayAs])
		SELECT
			@ID,
			@Class,
			T.c.value('EmailTypeID[1]','int'),
			T.c.value('Email[1]','nvarchar(256)'),
			T.c.value('Email[1]','nvarchar(256)')
		FROM
			@doc.nodes('/adfEmployeeGet/Email') AS T(c)
			
		IF @@error != 0
			RETURN 1
	END
	ELSE IF @XPathRoot = '/adfCompanyGet'
	BEGIN
		INSERT INTO [Phone] 
			([BusinessCardID], [BusinessCardClass], [PhoneTypeID], [Phone])
		SELECT
			@ID,
			@Class,
			T.c.value('PhoneTypeID[1]','int'),
			T.c.value('Phone[1]','varchar(50)')
		FROM
			@doc.nodes('/adfCompanyGet/Phone') AS T(c)
			
				
		IF @@error != 0
			RETURN 1
			
		INSERT INTO [Address]
			([BusinessCardID], [BusinessCardClass], [AddressTypeID], [Street], [City], [Region], 
			[PostalCode], [Country], [Mail])
		SELECT
			@ID,
			@Class,
			T.c.value('AddressTypeID[1]','int'),
			T.c.value('Street[1]','nvarchar(256)'),
			T.c.value('City[1]','nvarchar(50)'),
			T.c.value('Region[1]','nvarchar(256)'),
			T.c.value('PostalCode[1]','varchar(50)'),
			T.c.value('Country[1]','nvarchar(256)'),
			(CASE 
				WHEN T.c.value('Mail[1]','varchar(5)')='false' THEN 0 
				ELSE 1 
			END)
		FROM
			@doc.nodes('/adfCompanyGet/Address') AS T(c)
			
		IF @@error != 0
			RETURN 1

		INSERT INTO [Email]
			([BusinessCardID], [BusinessCardClass], [EmailTypeID], [Email], [DisplayAs])
		SELECT
			@ID,
			@Class,
			T.c.value('EmailTypeID[1]','int'),
			T.c.value('Email[1]','nvarchar(256)'),
			T.c.value('Email[1]','nvarchar(256)')
		FROM
			@doc.nodes('/adfCompanyGet/Email') AS T(c)
			
		IF @@error != 0
			RETURN 1
	END

	RETURN 0
GO

