IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfPropertyUpdate')
	BEGIN
		PRINT 'Dropping Procedure adfPropertyUpdate'
		DROP  Procedure  adfPropertyUpdate
	END

GO

PRINT 'Creating Procedure adfPropertyUpdate'
GO

/******************************************************************************
**		File: 
**		Name: adfPropertyUpdate
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**     ----------							-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:				Description:
**		--------		--------				-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfPropertyUpdate
	@ID TIdentifier,
	@Name TName,
	@Format TCode,
	@Description TNotes
AS
	SET NOCOUNT ON

	DECLARE @Lang TLanguage
	
	SET @Lang = dbo.adfGetLanguage()
	
	BEGIN TRANSACTION
	
	IF @Lang = 'ru'
	BEGIN
		UPDATE [Property]
		SET
			[Name] = @Name,
			[Format] = @Format,
			[Description] = @Description
		WHERE
			[ID] = @ID
	END
	
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	IF EXISTS(SELECT * FROM [PropertyGlobal] WHERE [ID] = @ID AND [Language] = @Lang)
	BEGIN
		UPDATE [PropertyGlobal]
		SET
			[Name] = @Name,
			[Format] = @Format,
			[Description] = @Description
		WHERE
			[ID] = @ID AND [Language] = @Lang
	END
	ELSE
	BEGIN
		INSERT INTO [PropertyGlobal] ([ID], [Language], [Name], [Format], [Description])
		VALUES (@ID, @Lang, @Name, @Format, @Description)
	END
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	COMMIT TRANSACTION
		
	RETURN 0
GO

GRANT EXEC ON adfPropertyUpdate TO PUBLIC
GO
