IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfPropertyValueGetText]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function adfPropertyValueGetText'
		DROP FUNCTION [dbo].[adfPropertyValueGetText]
	END

GO

PRINT 'Creating function adfPropertyValueGetText'
GO
/******************************************************************************
**		File: 
**		Name: adfPropertyValueGetText
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION adfPropertyValueGetText
	(@DocumentClass TClass, @DocumentID TIdentifier, @PropertyGuid TGuid)
RETURNS TPropertyValue
AS
BEGIN
	DECLARE @PropertyID TIdentifier, @PropertyValue TPropertyValue
	SELECT 
		@PropertyID = [ID]
	FROM
		[Property] 
	WHERE
		[Class] = @DocumentClass AND [Guid] = @PropertyGuid
	
	SELECT
		@PropertyValue = [Value]
	FROM
		[PropertyValue] 
	WHERE
		[DocumentClass] = @DocumentClass AND [DocumentID] = @DocumentID AND [PropertyID] = @PropertyID
	RETURN @PropertyValue
END
GO

 