IF EXISTS (SELECT * FROM sysobjects WHERE type = 'TR' AND name = 'adftrAttachmentInsert')
	BEGIN
		PRINT 'Dropping Trigger adftrAttachmentInsert'
		DROP  Trigger adftrAttachmentInsert
	END
GO

/******************************************************************************
**		File: 
**		Name: adftrAttachmentInsert
**		Desc: 
**
**		This template can be customized:
**              
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:				Description:
**		--------		--------				-------------------------------------------
**    
*******************************************************************************/

PRINT 'Creating Trigger adftrAttachmentInsert'
GO
CREATE Trigger adftrAttachmentInsert ON [Attachment] FOR INSERT
AS
	SET NOCOUNT ON
	UPDATE [Document]
	SET
		[AttachmentCount] = [AttachmentCount] + [I].[Count]
	FROM
		[Document] INNER JOIN (SELECT [DocumentClass], [DocumentID], COUNT(*) as [Count] FROM inserted GROUP BY [DocumentClass], [DocumentID]) as [I]
			ON ([Document].[ID] = [I].[DocumentID] AND [Document].[Class] = [I].[DocumentClass])
   
GO

