IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfCurrencyRateBrowse')
	BEGIN
		PRINT 'Dropping Procedure adfCurrencyRateBrowse'
		DROP  Procedure  adfCurrencyRateBrowse
	END

GO

PRINT 'Creating Procedure adfCurrencyRateBrowse'
GO
/******************************************************************************
**		File: 
**		Name: adfCurrencyRateBrowse
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfCurrencyRateBrowse
	@Code TCode,
	@StartDate TDate,
	@EndDate TDate
AS
	SET NOCOUNT ON

	SELECT
		[ID],
		[ToCurrencyCode],
		[ValidFrom],
		[ValidTo],
		[Rate]
	FROM
		[CurrencyRate]
	WHERE
		[FromCurrencyCode] = @Code
	AND
		(
		([ValidFrom] BETWEEN @StartDate AND @EndDate)
	OR
		([ValidTo] BETWEEN @StartDate AND @EndDate)
	OR
		(@StartDate BETWEEN [ValidFrom] AND [ValidTo])
	OR
		(@EndDate BETWEEN [ValidFrom] AND [ValidTo])
		)
	

	RETURN 0
GO

GRANT EXEC ON adfCurrencyRateBrowse TO PUBLIC
GO
