﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfMakeEntryPrivate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure adfMakeEntryPrivate'
		DROP PROCEDURE [dbo].[adfMakeEntryPrivate]
	END
GO

PRINT 'Creating procedure adfMakeEntryPrivate'
GO

/******************************************************************************
**		File: adfMakeEntryPrivate.sql
**		Name: adfMakeEntryPrivate
**		Desc: Процедура устанавливает или удаляет признак "Мой"
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      @ID			- ID записи			-----------
**		@Class		- класс записи
**		@Private	- признак "Мой"
**
**		Auth: Anton.Paramonov
**		Date: 28.11.11 15:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [adfMakeEntryPrivate]
	@ID			TIdentifier,
	@Class		TClass,
	@Private	TBool
AS
	DECLARE 
		@CurrentUserID TIdentifier
	
	SET @CurrentUserID = dbo.adfGetCurrentUserID()

	BEGIN TRANSACTION

	IF @Private = 1
	BEGIN
		IF NOT EXISTS(SELECT * FROM [UserContact] WHERE [UserID] = @CurrentUserID AND [BusinessCardClass] = @Class AND [BusinessCardID] = @ID)
		BEGIN
			INSERT INTO [UserContact] ([UserID], [BusinessCardClass], [BusinessCardID])
				VALUES(@CurrentUserID, @Class, @ID)
			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
	END
	ELSE
	BEGIN
		IF EXISTS(SELECT * FROM [UserContact] WHERE [UserID] = @CurrentUserID AND [BusinessCardClass] = @Class AND [BusinessCardID] = @ID)
		BEGIN
			DELETE [UserContact]
			WHERE [UserID] = @CurrentUserID AND [BusinessCardClass] = @Class AND [BusinessCardID] = @ID
			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
	END	

	COMMIT TRANSACTION

	RETURN 0
GO

GRANT EXECUTE ON [adfMakeEntryPrivate] TO PUBLIC
GO
 