IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfPriorityList')
	BEGIN
		PRINT 'Dropping Procedure adfPriorityList'
		DROP  Procedure  adfPriorityList
	END

GO

PRINT 'Creating Procedure adfPriorityList'
GO
/******************************************************************************
**		File: 
**		Name: adfPriorityList
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfPriorityList
AS
	SET NOCOUNT ON
	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()
	
	SELECT
		[Priority].[ID],
		[Priority].[Code],
		[DocumentGlobal].[FileAs] as [Name],
		[Priority].[State]
	FROM
		[Priority] INNER JOIN [DocumentGlobal]
			ON ([Priority].[Class] = [DocumentGlobal].[Class] AND
				[Priority].[ID] = [DocumentGlobal].[ID] AND
				[DocumentGlobal].[Language] = @Lang)
	
	RETURN 0
GO

GRANT EXEC ON adfPriorityList TO PUBLIC
GO
