IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfSeverityList')
	BEGIN
		PRINT 'Dropping Procedure adfSeverityList'
		DROP  Procedure  adfSeverityList
	END

GO

PRINT 'Creating Procedure adfSeverityList'
GO
/******************************************************************************
**		File: 
**		Name: adfSeverityList
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfSeverityList
AS
	SET NOCOUNT ON
	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()

	SELECT
		[Severity].[ID],
		[DocumentGlobal].[FileAs] as [Name],
		[Severity].[State]
	FROM
		[Severity] INNER JOIN [DocumentGlobal]
			ON ([Severity].[Class] = [DocumentGlobal].[Class]
				AND [Severity].[ID] = [DocumentGlobal].[ID]
				AND [DocumentGlobal].[Language] = @Lang)
	RETURN 0
GO

GRANT EXEC ON adfSeverityList TO PUBLIC
GO
