IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[adfGetClassName]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function adfGetClassName'
		DROP FUNCTION [dbo].[adfGetClassName]
	END
GO

PRINT 'Creating function adfGetClassName'
GO
/******************************************************************************
**		File: 
**		Name: adfGetClassName
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION adfGetClassName
	(@Class TClass)
RETURNS TName
AS
BEGIN
	DECLARE @Name TName

	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()

	SELECT
		@Name = ISNULL([ClassGlobal].[Name], [Class].[Name])
	FROM
		[Class] LEFT OUTER JOIN [ClassGlobal] 
			ON ([Class].[Class] = [ClassGlobal].[Class] AND [ClassGlobal].[Language] = @Lang)
	WHERE
		[Class].[Class] = @Class
	RETURN @Name
END
GO

GRANT EXEC ON adfGetClassName TO PUBLIC
GO
