IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].fnPjm7GetFormattedYearsBeforeEvent') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm7GetFormattedYearsBeforeEvent'
		DROP FUNCTION [dbo].fnPjm7GetFormattedYearsBeforeEvent
	END

GO

PRINT 'Creating Function fnPjm7GetFormattedYearsBeforeEvent'
GO
/******************************************************************************
**		File:	fnPjm7GetFormattedYearsBeforeEvent.sql
**		Name: 	fnPjm7GetFormattedYearsBeforeEvent
**		Desc:	returns 
*******************************************************************************
**		Date:		Author:		Description:
**		-----		-------		-------------
**    	29.11.11		ASA		first version
*******************************************************************************/

CREATE FUNCTION fnPjm7GetFormattedYearsBeforeEvent(@Eventdate datetime)
RETURNS varchar(20)
BEGIN
	DECLARE
		@EventThisYear datetime,
		@Years int,
		@Result varchar(20),
		@Language TCode,
		@Today datetime

	SET @Language = dbo.adfGetLanguage()
	SET @Today = GetDate()

	IF(isdate(datename(year,@Eventdate)+'0229') = 1 AND Datepart(month, @Eventdate) > 2)
	BEGIN
		SET @EventThisYear = Dateadd(day,datepart(dayofyear,@Eventdate)-2, datename(year,@Today))
	END
	ELSE
	BEGIN
		SET @EventThisYear = Dateadd(day,datepart(dayofyear,@Eventdate)-1, datename(year,@Today))
	END

	IF(Datepart(dayofyear, @Eventdate) < Datepart(dayofyear, GetDate()))
		SET @Years = Datediff(year,@Eventdate,@EventThisYear) + 1
	ELSE
		SET @Years = Datediff(year,@Eventdate,@EventThisYear)

	IF(@Language = 'en')
	BEGIN
		IF(@Years = 1)
		BEGIN
			SET @Result = '1 year'
		END
		ELSE 
		BEGIN
			SET @Result = CAST(@Years AS varchar(3)) + ' years'
		END
	END
	ELSE IF(@Language = 'ru')
	BEGIN
		IF((@Years % 10) IN (1))
		BEGIN
			SET @Result = CAST(@Years AS varchar(3)) + ' '
		END
		ELSE IF((@Years % 10) IN (2,3,4))
		BEGIN
			SET @Result = CAST(@Years AS varchar(3)) + ' '
		END
		ELSE
		BEGIN
			SET @Result = CAST(@Years AS varchar(3)) + ' '
		END
		IF(substring(Convert(nvarchar,@Years), len(Convert(nvarchar,@Years))-1,1)='1')
		BEGIN
			SET @Result = CAST(@Years AS varchar(3)) + ' '
		END
	END 
	IF(@Years = 0)
		SET @Result = ''
	RETURN @Result
END
GO

GRANT EXEC ON fnPjm7GetFormattedYearsBeforeEvent TO PUBLIC
GO
