IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfActionList')
	BEGIN
		PRINT 'Dropping Procedure adfActionList'
		DROP  Procedure  adfActionList
	END

GO

PRINT 'Creating Procedure adfActionList'
GO
/******************************************************************************
**		File: 
**		Name: adfActionList
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfActionList
AS
	SET NOCOUNT ON

	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()

	SELECT
		[Action].[ID],
		ISNULL([ActionGlobal].[Name], [Action].[Name]) as [Name]
	FROM
		[Action] LEFT OUTER JOIN [ActionGlobal]
			ON ([Action].[ID] = [ActionGlobal].[ID] AND [ActionGlobal].[Language] = @Lang)
		
	RETURN 0
GO

GRANT EXEC ON adfActionList TO PUBLIC
GO
