IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfRightList')
	BEGIN
		PRINT 'Dropping Procedure adfRightList'
		DROP  Procedure  adfRightList
	END

GO

PRINT 'Creating Procedure adfRightList'
GO
/******************************************************************************
**		File: 
**		Name: adfRightList
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfRightList
AS
	SET NOCOUNT ON

	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()

	SELECT
		[Right].[Name],
		ISNULL([RightGlobal].[DisplayName], [Right].[DisplayName]) as [DisplayName]
	FROM
		[Right] LEFT OUTER JOIN [RightGlobal]
			ON ([Right].[ID] = [RightGlobal].[ID] AND [RightGlobal].[Language] = @Lang)
	RETURN 0
GO

GRANT EXEC ON adfRightList TO PUBLIC
GO
