IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfLoginBrowse')
	BEGIN
		PRINT 'Dropping Procedure adfLoginBrowse'
		DROP  Procedure  adfLoginBrowse
	END

GO

PRINT 'Creating Procedure adfLoginBrowse'
GO
/******************************************************************************
**		File: 
**		Name: adfLoginBrowse
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfLoginBrowse
	@State INT
AS
	DECLARE @Class TClass
	SET NOCOUNT ON
	
	SET @Class = dbo.adfGetClassByName('Adf.Login')

	SELECT 
		sys.[syslogins].[sid] as [ID],
		@Class as [Class],
		sys.[syslogins].[loginname] as [Name],
		sys.[syslogins].[dbname],
		sys.[syslogins].[language],
		sys.[syslogins].[hasaccess],
		(CASE WHEN EXISTS(SELECT * FROM sysusers WHERE [sid]=sys.[syslogins].[sid]) THEN 1 ELSE 0 END) as hasdbaccess,
		CASE 
		WHEN sys.[syslogins].[isntname] = 0
			THEN 'Standard'
		ELSE
			CASE WHEN sys.[syslogins].[isntgroup] = 1 THEN 'NtGroup'
			WHEN sys.[syslogins].[isntuser] = 1 THEN 'NtUser'
			ELSE
				'Unknown'
			END
		END as [logintype],
		sys.[syslogins].[createdate] as [Created],
		sys.[syslogins].[updatedate] as [Modified],
		sys.[syslogins].[accdate] as [Accessed],
		(CASE WHEN EXISTS(SELECT * FROM sysusers WHERE [sid]=sys.[syslogins].[sid]) THEN 1 ELSE 2 END) as State
	FROM
		sys.[syslogins]
	WHERE
		@State = 0 OR (CASE WHEN EXISTS(SELECT * FROM sysusers WHERE [sid]=sys.[syslogins].[sid]) THEN 1 ELSE 2 END) = @State
	ORDER BY
		[logintype],
		sys.[syslogins].[loginname]
	
	RETURN 0
GO

GRANT EXEC ON adfLoginBrowse TO PUBLIC
GO
