IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfRoleMemberCreate')
	BEGIN
		PRINT 'Dropping Procedure adfRoleMemberCreate'
		DROP  Procedure  adfRoleMemberCreate
	END

GO

PRINT 'Creating Procedure adfRoleMemberCreate'
GO
/******************************************************************************
**		File: 
**		Name: adfRoleMemberCreate
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		26.06.13	SOV				     
*******************************************************************************/
CREATE Procedure adfRoleMemberCreate
	@RoleName TSysname,
	@UserName TSysname,
	@UserID TIdentifier = NULL
AS
	DECLARE @result INT
	
	SET NOCOUNT ON

	EXEC @result = adfAccessRightCheck 'ManageUsers'
	IF @result != 0
		RETURN @result
		
	IF @UserID IS NULL
		SET @UserID = dbo.adfGetUserID(@UserName);

	DECLARE @RoleID TIdentifier

	SELECT 
		@RoleID = [Role].[ID]
	FROM 
		[Role] INNER JOIN [Trustee]
			ON ([Role].[ID] = [Trustee].[ID])
	WHERE
		[Trustee].[Name] = @rolename AND [Active] = 1

	IF (@RoleID IS NOT NULL)
		INSERT INTO [UserRole]
			([RoleID], [UserID])
		VALUES
			(@RoleID, @UserID)

	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	RETURN 0
GO

GRANT EXEC ON adfRoleMemberCreate TO PUBLIC
GO
