IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfUserLicenseUnregister')
	BEGIN
		PRINT 'Dropping Procedure adfUserLicenseUnregister'
		DROP  Procedure  adfUserLicenseUnregister
	END

GO

PRINT 'Creating Procedure adfUserLicenseUnregister'
GO
/******************************************************************************
**		File: 
**		Name: adfUserLicenseUnregister
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfUserLicenseUnregister
	@ProductKey TName
AS
	DECLARE @result INT
	
	SET NOCOUNT ON

	UPDATE [User]
	SET
		[ProductKey] = NULL,
		[SerialNumber] = NULL,
		[IsPermanent] = 0,
		[ValidationData] = 'EMPTY'
	WHERE
		[Locked] = 1 AND
		[ProductKey] = @ProductKey
		
	IF @@ERROR != 0 
	BEGIN
		RETURN 1
	END
	
	RETURN 0
GO

GRANT EXEC ON adfUserLicenseUnregister TO PUBLIC
GO
