IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfwfDocumentStateChange')
	BEGIN
		PRINT 'Dropping Procedure adfwfDocumentStateChange'
		DROP  Procedure  adfwfDocumentStateChange
	END

GO

PRINT 'Creating Procedure adfwfDocumentStateChange'
GO
/******************************************************************************
**		File: 
**		Name: adfwfDocumentStateChange
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfwfDocumentStateChange
	@DocumentID TIdentifier,
	@TransitionTemplateID TIdentifier
AS
	DECLARE @result INT
	
	SET NOCOUNT ON

	BEGIN TRANSACTION
	
	EXEC @result = adfwfDocumentStateChangeInternal @DocumentID, @TransitionTemplateID
	
	IF @result != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @result
	END
	
	COMMIT TRANSACTION

	RETURN 0
GO

GRANT EXEC ON adfwfDocumentStateChange TO PUBLIC
GO
