IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'adfwfRunProcedure')
	BEGIN
		PRINT 'Dropping Procedure adfwfRunProcedure'
		DROP  Procedure  adfwfRunProcedure
	END

GO

PRINT 'Creating Procedure adfwfRunProcedure'
GO
/******************************************************************************
**		File: 
**		Name: adfwfRunProcedure
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE Procedure adfwfRunProcedure
	@ProcedureName TSysname,
	@DocumentID TIdentifier,
	@TransitionTemplateID TIdentifier
AS
	DECLARE @result INT,
			@sql nvarchar(4000),
			@rv INT
			
	SET NOCOUNT ON
	
	SELECT @sql = N'EXEC @result=' + @ProcedureName + N' @DocumentID, @TransitionTemplateID'
	
	EXEC @rv = sp_executesql @sql, N'@result INT OUTPUT, @DocumentID INT, @TransitionTemplateID INT', @result OUTPUT, @DocumentID, @TransitionTemplateID
	
	IF @rv != 0
	BEGIN
		RAISERROR('#ExecuteSqlFailed', 18, 1)
		RETURN @rv
	END
	
	RETURN @result
		
GO

