IF NOT EXISTS(SELECT * FROM dbo.syscolumns WHERE [name] = 'TotalWithoutDiscount' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Calculation')
	ALTER TABLE [Calculation] ADD [TotalWithoutDiscount] TMoney not null default 0
GO

IF NOT EXISTS(SELECT * FROM dbo.syscolumns WHERE [name] = 'TotalWithVATWithoutDiscount' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Calculation')
	ALTER TABLE [Calculation] ADD [TotalWithVATWithoutDiscount] TMoney not null default 0
GO

IF NOT EXISTS(SELECT * FROM dbo.syscolumns WHERE [name] = 'VATWithoutDiscount' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Calculation')
	ALTER TABLE [Calculation] ADD [VATWithoutDiscount] AS ([TotalWithVATWithoutDiscount] - [TotalWithoutDiscount])
GO

IF NOT EXISTS(SELECT * FROM dbo.syscolumns WHERE [name] = 'TotalWithoutDiscountPC' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Calculation')
	ALTER TABLE [Calculation] ADD [TotalWithoutDiscountPC] TMoney not null default 0
GO

IF NOT EXISTS(SELECT * FROM dbo.syscolumns WHERE [name] = 'TotalWithVATWithoutDiscountPC' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Calculation')
	ALTER TABLE [Calculation] ADD [TotalWithVATWithoutDiscountPC] TMoney not null default 0
GO

IF NOT EXISTS(SELECT * FROM dbo.syscolumns WHERE [name] = 'VATWithoutDiscountPC' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Calculation')
	ALTER TABLE [Calculation] ADD [VATWithoutDiscountPC] AS ([TotalWithVATWithoutDiscountPC] - [TotalWithoutDiscountPC])
GO

IF NOT EXISTS(SELECT * FROM dbo.syscolumns WHERE [name] = 'DiscountView' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Calculation')
	ALTER TABLE [Calculation] ADD [DiscountView] TBool not null default 0
GO

IF NOT EXISTS(SELECT * FROM dbo.syscolumns WHERE [name] = 'DiscountPC' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Calculation')
	ALTER TABLE [Calculation] ADD [DiscountPC] TAmount not null default 0
GO

IF NOT EXISTS(SELECT * FROM dbo.syscolumns WHERE [name] = 'DiscountPercent' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Calculation')
	ALTER TABLE [Calculation] ADD [DiscountPercent] TPercent not null default 0
GO

IF NOT EXISTS(SELECT * FROM dbo.syscolumns WHERE [name] = 'RatesWithVAT' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Calculation')
BEGIN
	ALTER TABLE [Calculation] ADD [RatesWithVAT] TBool not null default 0
	EXEC adfParameterSet 'RWVColumnAdded', 'ChangeScript', 1
END
GO

DECLARE @value TVariant, @RWVColumnAdded TBool
EXEC adfParameterGet 'RWVColumnAdded', 'ChangeScript', @Value = @value OUTPUT
SET @RWVColumnAdded = ISNULL(CAST(@value as bit), 0)
IF @RWVColumnAdded = 1
BEGIN
	ALTER TABLE [Calculation] DISABLE TRIGGER ALL
	UPDATE 
		[Calculation]
	SET
		[TotalWithoutDiscount] = [Total],
		[TotalWithVATWithoutDiscount] = [TotalWithVAT],
		[TotalWithoutDiscountPC] = [TotalPC],
		[TotalWithVATWithoutDiscountPC] = [TotalWithVATPC],
		[RatesWithVAT] = (SELECT [Project].[RatesWithVAT] FROM [Project] WHERE [Project].[ID] = [Calculation].[ProjectID])
	ALTER TABLE [Calculation] ENABLE TRIGGER ALL

	DELETE [F41AB0F8-FDF0-4FAD-9B71-8F17B4A51B53]
		WHERE [Name] = 'RWVColumnAdded' AND [Group] = 'ChangeScript'
END
GO

IF NOT EXISTS(SELECT * FROM dbo.syscolumns WHERE [name] = 'EditedInProjectCurrency' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Calculation')
	ALTER TABLE [Calculation] ADD [EditedInProjectCurrency] TBool not null default 0
GO

IF NOT EXISTS(SELECT * FROM dbo.syscolumns WHERE [name] = 'TotalWithoutDiscountAndAdvanced' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Calculation')
	ALTER TABLE [Calculation] ADD [TotalWithoutDiscountAndAdvanced] TMoney null
GO

IF NOT EXISTS(SELECT * FROM dbo.syscolumns WHERE [name] = 'TotalWithVATWithoutDiscountAndAdvanced' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Calculation')
	ALTER TABLE [Calculation] ADD [TotalWithVATWithoutDiscountAndAdvanced] TMoney null
GO

IF NOT EXISTS(SELECT * FROM dbo.syscolumns WHERE [name] = 'VATWithoutDiscountAndAdvanced' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Calculation')
	ALTER TABLE [Calculation] ADD [VATWithoutDiscountAndAdvanced] AS ([TotalWithVATWithoutDiscountAndAdvanced] - [TotalWithoutDiscountAndAdvanced])
GO

IF NOT EXISTS(SELECT * FROM dbo.syscolumns WHERE [name] = 'TotalWithoutDiscountAndAdvancedPC' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Calculation')
	ALTER TABLE [Calculation] ADD [TotalWithoutDiscountAndAdvancedPC] TMoney null 
GO

IF NOT EXISTS(SELECT * FROM dbo.syscolumns WHERE [name] = 'TotalWithVATWithoutDiscountAndAdvancedPC' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Calculation')
	ALTER TABLE [Calculation] ADD [TotalWithVATWithoutDiscountAndAdvancedPC] TMoney null 
GO

IF NOT EXISTS(SELECT * FROM dbo.syscolumns WHERE [name] = 'VATWithoutDiscountAndAdvancedPC' AND OBJECTPROPERTY(id, N'IsUserTable') = 1 AND OBJECT_NAME(id)='Calculation')
	ALTER TABLE [Calculation] ADD [VATWithoutDiscountAndAdvancedPC] AS ([TotalWithVATWithoutDiscountAndAdvancedPC] - [TotalWithoutDiscountAndAdvancedPC])
GO