DECLARE @ParameterName TName = 'UpdateTables_AddPrimaryKeys'

IF NOT EXISTS(SELECT * FROM [CustomScriptExecution] WHERE [ParameterName] = @ParameterName)
BEGIN
	--        -    Azure SQL
	ALTER TABLE [EmployeeTimeZone] ADD CONSTRAINT EmplyeeTimeZonePK primary key ([EmployeeID])

	ALTER TABLE [ProjectTemplate] ADD CONSTRAINT ProjectTemplatePK primary key ([ID])

	ALTER TABLE [ReminderDescription] ADD [ID] int IDENTITY
	ALTER TABLE [ReminderDescription] ADD CONSTRAINT ReminderDescriptionPK primary key ([ID])

	ALTER TABLE [SuperTimerHistory] ADD [ID] int IDENTITY
	ALTER TABLE [SuperTimerHistory] ADD CONSTRAINT SuperTimerHistoryPK primary key ([ID])

	ALTER TABLE [TaskRequestAssignment] ADD [ID] int IDENTITY
	ALTER TABLE [TaskRequestAssignment] ADD CONSTRAINT TaskRequestAssignmentPK primary key ([ID])

	DECLARE @DBVersion TVariant
	EXEC adfParameterGet 'DatabaseVersion', 'VersionInfo', @Value = @DBVersion OUTPUT
	
	INSERT INTO [CustomScriptExecution] ([ParameterName], [FromDBVersion], [ScriptName])
		VALUES (@ParameterName, @DBVersion, 'upgrade-addPrimaryKeys.sql')
END
GO