﻿if exists (select * from dbo.sysobjects where id = object_id(N'[exch].[UpdatePhone]') and objectproperty(id, N'IsProcedure') = 1)
begin
	print 'Dropping procedure UpdatePhone'
	drop procedure [exch].[UpdatePhone]
end
go

print 'Creating procedure UpdatePhone'
go

create procedure [exch].[UpdatePhone] @XContact xml, @Class TClass, @ID TIdentifier
as
begin
	set nocount on;

	update [dbo].[Phone]
	set
		[Phone] = [S].[Phone]
	from
		[dbo].[Phone] as [P] inner join (
		select
			@Class as [Class],
			@ID as [ID],
			T.C.value('(@TypeID)[1]', 'int') as [TypeID],
			T.C.value('(@Phone)[1]', 'nvarchar(256)') as [Phone]
		from
			@XContact.nodes('Contact/Phone') as T(C)) as [S]
		on ([P].[BusinessCardClass] = [S].[Class] and [P].[BusinessCardID]=[S].[ID] and [P].[PhoneTypeID] = [S].[TypeID])


	insert into [dbo].[Phone]	
		([BusinessCardClass], [BusinessCardID], [PhoneTypeID], [Phone])
	select
		@Class,
		@ID,
		T.C.value('(@TypeID)[1]', 'int'),
		T.C.value('(@Phone)[1]', 'nvarchar(256)')
	from
		@XContact.nodes('Contact/Phone') as T(C)
	where
		T.C.value('(@TypeID)[1]', 'int') not in (select [PhoneTypeID] from [Phone] 
												 where [BusinessCardClass] = @Class 
												 and [BusinessCardID] = @ID);
	return 0;
end
GO


