IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].fnPjm6GetBudgetObjectsOrder') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm6GetBudgetObjectsOrder'
		DROP FUNCTION [dbo].fnPjm6GetBudgetObjectsOrder
	END

GO

PRINT 'Creating function fnPjm6GetBudgetObjectsOrder'
GO
/******************************************************************************
**		File:	fnPjm6GetBudgetObjectsOrder.sql
**		Name: 	fnPjm6GetBudgetObjectsOrder
**		Desc:	returns formatted time interval
*******************************************************************************
**		Date:		Author:		Description:
**		-----		-------		-------------
**    	10.11.09		PAM		first version
*******************************************************************************/

CREATE FUNCTION fnPjm6GetBudgetObjectsOrder(
	@BudgetID	TIdentifier,
	@ObjectView	TName,
	@ObjectType	TName = NULL,
	@GroupType	TIdentifier = NULL,
	@GroupID	TIdentifier = NULL)
RETURNS TCount
BEGIN
	DECLARE
		@Order	TCount
		
	SELECT
		@Order = 
			(CASE @ObjectView
				WHEN 'Group' THEN
					ISNULL((SELECT MAX([Order]) FROM [BudgetLineGroup] WHERE [BudgetID] = @BudgetID AND
						[GroupTypeID] = @GroupType AND [State] != 2), 0) + 1
				WHEN 'WorkLine' THEN
					CASE @ObjectType
						WHEN 'Planned' THEN
							ISNULL((SELECT MAX([Order]) FROM [BudgetLineWork] WHERE BudgetID = @BudgetID AND [State] = 1 AND
								((@GroupID IS NOT NULL AND [BudgetLineGroupID] = @GroupID) OR
								(@GroupID IS NULL AND [BudgetLineGroupID] IS NULL))), 0) + 1
						WHEN 'Actual' THEN
							ISNULL((SELECT MAX([Order]) FROM [BudgetLineWork] WHERE BudgetID = @BudgetID AND
								((@GroupID IS NOT NULL AND [BudgetLineGroupID] = @GroupID) OR
								(@GroupID IS NULL AND [BudgetLineGroupID] IS NULL))), 0) + 1
					END
				WHEN 'ExpenseLine' THEN
					CASE @ObjectType
						WHEN 'Planned' THEN
							ISNULL((SELECT MAX([Order]) FROM [BudgetLineExpense] WHERE BudgetID = @BudgetID AND [State] = 1 AND
								((@GroupID IS NOT NULL AND [BudgetLineGroupID] = @GroupID) OR
								(@GroupID IS NULL AND [BudgetLineGroupID] IS NULL))), 0) + 1
						WHEN 'Actual' THEN
							ISNULL((SELECT MAX([Order]) FROM [BudgetLineExpense] WHERE BudgetID = @BudgetID AND
								((@GroupID IS NOT NULL AND [BudgetLineGroupID] = @GroupID) OR
								(@GroupID IS NULL AND [BudgetLineGroupID] IS NULL))), 0) + 1
					END
			END)
	RETURN @Order			
END
GO

GRANT EXEC ON fnPjm6GetBudgetObjectsOrder TO PUBLIC
GO