IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].fnPjm6GetBudgetVATForTotal') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm6GetBudgetVATForTotal'
		DROP FUNCTION [dbo].fnPjm6GetBudgetVATForTotal
	END

GO

PRINT 'Creating function fnPjm6GetBudgetVATForTotal'
GO
/******************************************************************************
**		File:	fnPjm6GetBudgetVATForTotal.sql
**		Name: 	fnPjm6GetBudgetVATForTotal
**		Desc:	returns formatted time interval
*******************************************************************************
**		Date:		Author:		Description:
**		-----		-------		-------------
**    	18.02.11		PAM		first version
*******************************************************************************/

CREATE FUNCTION fnPjm6GetBudgetVATForTotal(
	@VATRate			TPercent,
	@VATIsIncluded		TBool,
	@DiscountView		TBool,
	@DiscountPercent	TMoney,
	@DiscountTotal		TMoney,
	@Total				TMoney,
	@TotalWithVAT		TMoney)
RETURNS TMoney
BEGIN
	DECLARE
		@totalSum			TMoney
		
		SET @totalSum = 
			(CASE 
				WHEN @VATRate IS NOT NULL AND @VATIsIncluded = 1 THEN 
					dbo.fnPjm6GetVATForTotal(@TotalWithVAT + dbo.fnPjm6GetBudgetTotalDiscount(@DiscountView, @DiscountPercent, @DiscountTotal, @TotalWithVAT),
					@VATRate, @VATIsIncluded, 1)
				ELSE
					dbo.fnPjm6GetVATForTotal(@Total + dbo.fnPjm6GetBudgetTotalDiscount(@DiscountView, @DiscountPercent, @DiscountTotal, @Total),
					@VATRate, @VATIsIncluded, 1)
			END)
		
	RETURN @totalSum
END
GO

GRANT EXEC ON fnPjm6GetBudgetVATForTotal TO PUBLIC
GO