﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm7CompanyRelationshipGetAllChildrenOfTheOne]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm7CompanyRelationshipGetAllChildrenOfTheOne'
		DROP FUNCTION [dbo].[fnPjm7CompanyRelationshipGetAllChildrenOfTheOne]
	END

GO

PRINT 'Creating function fnPjm7CompanyRelationshipGetAllChildrenOfTheOne'
GO
/******************************************************************************
**		File: fnPjm7CompanyRelationshipGetAllChildrenOfTheOne
**		Name: fnPjm7CompanyRelationshipGetAllChildrenOfTheOne
**		Desc: Функция возвращает список IDшников всех дочерних компаний требуемой головной компании
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Nikita.Golyshev
**		Date: 11.09.2014 12:40:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm7CompanyRelationshipGetAllChildrenOfTheOne
(
	@CompanyID TIdentifier
)
RETURNS @TmpTable TABLE
	(
		[IDs] int
	)
AS
BEGIN

	INSERT INTO 
		@TmpTable ([IDs])
	VALUES
		(@CompanyID)

	WHILE 1=1
	BEGIN
		INSERT INTO 
			@TmpTable ([IDs])
		(
			SELECT 
				[SecondCompanyID]
			FROM 
				[CompanyRelationshipEntry]
			WHERE
				[FirstCompanyID] IN 
				(
					SELECT [IDs]
					FROM @TmpTable
				)
				AND [FileAs] = 'Дочерняя компания'
			EXCEPT
				SELECT [IDs]
				FROM @TmpTable
		)
		IF (@@ROWCOUNT = 0) 
		BEGIN
			BREAK
		END
	END

	RETURN
END
GO
