IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].fnPjm6GetVATForTotal') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm6GetVATForTotal'
		DROP FUNCTION [dbo].fnPjm6GetVATForTotal
	END

GO

PRINT 'Creating function fnPjm6GetVATForTotal'
GO
/******************************************************************************
**		File:	fnPjm6GetVATForTotal.sql
**		Name: 	fnPjm6GetVATForTotal
**		Desc:	returns formatted time interval
*******************************************************************************
**		Date:		Author:		Description:
**		-----		-------		-------------
**    	10.11.09		PAM		first version
*******************************************************************************/

CREATE FUNCTION fnPjm6GetVATForTotal(
	@Total				TMoney,
	@VATRate			TPercent,
	@VATIsIncluded		TBool,
	@ApplyVAT			TBool = 1)
RETURNS TMoney
BEGIN
	
	IF @VATRate IS NULL
		SET @ApplyVAT = 0
		
	IF @ApplyVAT = 0
		SET @VATRate = 0
	
	RETURN ROUND(@Total * @VATRate / (1 + @VATIsIncluded * @VATRate), 2)
END
GO

GRANT EXEC ON fnPjm6GetVATForTotal TO PUBLIC
GO