IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnPjm5IsProjectAdministrator]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnPjm5IsProjectAdministrator'
		DROP FUNCTION [dbo].[fnPjm5IsProjectAdministrator]
	END

GO

PRINT 'Creating function fnPjm5IsProjectAdministrator'
GO
/******************************************************************************
**		File: 
**		Name: fnPjm5IsProjectAdministrator
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnPjm5IsProjectAdministrator
	(@ProjectID TIdentifier, @EmployeeID TIdentifier)
RETURNS BIT
AS
BEGIN

	DECLARE @result BIT
	IF @EmployeeID IS NULL
		SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	IF EXISTS(
		SELECT * FROM vwAssignment 
		WHERE 
			[EmployeeID] = @EmployeeID AND 
			[ProjectID] = @ProjectID AND 
			[Administrator] = 1 AND
			[State] = 1)
		SET @result = 1
	ELSE
		SET @result = 0
	
	RETURN @result
END
GO

GRANT EXEC ON fnPjm5IsProjectAdministrator TO PUBLIC
GO
