IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnReportGetMonthNameByNumber]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnReportGetMonthNameByNumber'
		DROP FUNCTION [dbo].[fnReportGetMonthNameByNumber]
	END

GO

PRINT 'Creating function fnReportGetMonthNameByNumber'
GO
/******************************************************************************
**		File: 
**		Name: fnReport7GetMonthNameByNumber
**		Desc:        
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Sergey Pelevin
**		Date: 18.04.14
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnReportGetMonthNameByNumber(@MonthNumber int, @LangCode TCode3, @Short bit)
RETURNS varchar(50)
AS
BEGIN

	DECLARE 
		@MonthName varchar(50)
	
	IF(@LangCode IS NULL OR @LangCode NOT IN ('en', 'ru'))
		SET @LangCode = 'ru'	-- set to russian language as default


	IF @LangCode = 'ru'
	SET @MonthName =
		CASE WHEN @Short = 0
		THEN
			CASE @MonthNumber
				WHEN 1 THEN N''
				WHEN 2 THEN N''
				WHEN 3 THEN N''
				WHEN 4 THEN N''
				WHEN 5 THEN N''
				WHEN 6 THEN N''
				WHEN 7 THEN N''
				WHEN 8 THEN N''
				WHEN 9 THEN N''
				WHEN 10 THEN N''
				WHEN 11 THEN N''
				WHEN 12 THEN N''
			END
		ELSE
			CASE @MonthNumber
				WHEN 1 THEN N''
				WHEN 2 THEN N''
				WHEN 3 THEN N''
				WHEN 4 THEN N''
				WHEN 5 THEN N''
				WHEN 6 THEN N''
				WHEN 7 THEN N''
				WHEN 8 THEN N''
				WHEN 9 THEN N''
				WHEN 10 THEN N''
				WHEN 11 THEN N''
				WHEN 12 THEN N''
			END
		END


	IF @LangCode = 'en'
	SET @MonthName = 
		CASE WHEN @Short = 0
		THEN
			CASE @MonthNumber
				WHEN 1 THEN 'January'
				WHEN 2 THEN 'February'
				WHEN 3 THEN 'March'
				WHEN 4 THEN 'April'
				WHEN 5 THEN 'May'
				WHEN 6 THEN 'June'
				WHEN 7 THEN 'July'
				WHEN 8 THEN 'August'
				WHEN 9 THEN 'September'
				WHEN 10 THEN 'October'
				WHEN 11 THEN 'November'
				WHEN 12 THEN 'December'
			END
		ELSE
			CASE @MonthNumber
				WHEN 1 THEN 'Jan'
				WHEN 2 THEN 'Feb'
				WHEN 3 THEN 'Mar'
				WHEN 4 THEN 'Apr'
				WHEN 5 THEN 'May'
				WHEN 6 THEN 'Jun'
				WHEN 7 THEN 'Jul'
				WHEN 8 THEN 'Aug'
				WHEN 9 THEN 'Sep'
				WHEN 10 THEN 'Oct'
				WHEN 11 THEN 'Nov'
				WHEN 12 THEN 'Dec'
			END
		END
	

	RETURN @MonthName
END
GO

GRANT EXEC ON fnReportGetMonthNameByNumber TO PUBLIC
GO