﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[fnReportGetQuarterNameByNumber]') AND xtype IN (N'FN', N'IF', N'TF'))
	BEGIN
		PRINT 'Dropping function fnReportGetQuarterNameByNumber'
		DROP FUNCTION [dbo].[fnReportGetQuarterNameByNumber]
	END

GO

PRINT 'Creating function fnReportGetQuarterNameByNumber'
GO
/******************************************************************************
**		File: 
**		Name: fnReport7GetQuarterNameByNumber
**		Desc: Возвращает название квартала по его номеру в году
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Sergey Pelevin
**		Date: 16.12.14
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE FUNCTION fnReportGetQuarterNameByNumber(@QuarterNumber int, @LangCode TCode3)
RETURNS varchar(50)
AS
BEGIN

	DECLARE 
		@QuarterName varchar(50),
		@YearSuffix VARCHAR(2)
	
	IF(@LangCode IS NULL OR @LangCode NOT IN ('en', 'ru'))
		SET @LangCode = 'ru'	-- set to russian language as default


	IF @LangCode = 'ru'
	BEGIN
		SET @QuarterName =
			CASE @QuarterNumber
				WHEN 1 THEN N'1 квартал'
				WHEN 2 THEN N'2 квартал'
				WHEN 3 THEN N'3 квартал'
				WHEN 4 THEN N'4 квартал'
			END		
	END	

	IF @LangCode = 'en'
	BEGIN
		SET @QuarterName = 
			CASE @QuarterNumber
				WHEN 1 THEN N'1 quarter'
				WHEN 2 THEN N'2 quarter'
				WHEN 3 THEN N'3 quarter'
				WHEN 4 THEN N'4 quarter'
			END		
	END	
	
	RETURN @QuarterName
END
GO