IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'pjm6AssignmentCheckBudgetOverdraft')
	BEGIN
		PRINT 'Dropping Procedure pjm6AssignmentCheckBudgetOverdraft'
		DROP  Procedure  pjm6AssignmentCheckBudgetOverdraft
	END

GO

PRINT 'Creating Procedure pjm6AssignmentCheckBudgetOverdraft'
GO
/******************************************************************************
**		File: 
**		Name: pjm6AssignmentCheckBudgetOverdraft
**		Desc: 
**
**		This template can be customized:
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    06.10.09		syv				       
*******************************************************************************/
CREATE Procedure pjm6AssignmentCheckBudgetOverdraft
	@TaskID TIdentifier,
	@AssignmentID TIdentifier,
	@TimeEntryID TIdentifier,
	@NewDuration TCount
AS
	SET NOCOUNT ON
	DECLARE 
		@CheckBudgetOverdraft TBool,
		@ProjectManagerID TIdentifier,
		@Work TAmount,
		@RemainingWork TAmount,
		@FromID TIdentifier,
		@ToID TIdentifier,
		@Language TCode
	SET @FromID = dbo.adfGetCurrentUserID()
	SET @Language = dbo.adfGetLanguage()

	SELECT 
		@CheckBudgetOverdraft = [Project].[CheckTaskWorkOverdraft],
		@ProjectManagerID = [Project].[ProjectManagerEmployeeID]
	FROM
		[Task]
		INNER JOIN [Project]
			ON [Project].[ID] = [Task].[ProjectID]
	WHERE
		[Task].[ID] = @TaskID

	IF @CheckBudgetOverdraft = 0
		RETURN 0
	
--	IF @ProjectManagerID = dbo.adfGetCurrentEmployeeID()
--		RETURN 0
	
	SELECT
		@Work = [TaskAssignment].[Work]
	--	@RemainingWork = ISNULL([TaskAssignment].[RemainingWork], 0)
	FROM
		[TaskAssignment]
	WHERE
		[TaskAssignment].[TaskID] = @TaskID AND
		[TaskAssignment].[AssignmentID] = @AssignmentID

	DECLARE @ThisDuration TCount,
			@ThisOvertimeDuration TCount,
			@NewOvertimeDuration TCount,
			@ActualWork TCount,
			@OvertimeWork TCount,
			@ActualOvertimeWork TCount
	IF @TimeEntryID IS NOT NULL
	BEGIN
		SELECT @ToID = [UserID] FROM [Employee] WHERE [ID] = @ProjectManagerID
		IF @ToID IS NULL
			RETURN 0

		SELECT 
			@ThisDuration = CASE WHEN [TimeEntry].[Overtime] = 1 AND [Task].[MsTaskID] IS NOT NULL 
			THEN 0 ELSE [TimeEntry].[Duration] END,
			@ThisOvertimeDuration = CASE WHEN [TimeEntry].[Overtime] = 1 AND [Task].[MsTaskID] IS NOT NULL 
			THEN [TimeEntry].[Duration] ELSE 0 END	
		FROM
			[TimeEntry]
			INNER JOIN [Task]
				ON [Task].[ID] = [TimeEntry].[TaskID]
		WHERE
			[TimeEntry].[ID] = @TimeEntryID  AND
			[TimeEntry].[State] IN (1, 2)
		
		IF @NewDuration IS NULL
		BEGIN
			SET @ThisDuration = - @ThisDuration
			SET @ThisOvertimeDuration = - @ThisOvertimeDuration
		END
				
		IF EXISTS
		(
			SELECT *
			FROM
				[TimeEntry]
				INNER JOIN [Task]
					ON [Task].[ID] = [TimeEntry].[TaskID]
			WHERE
				[TimeEntry].[ID] = @TimeEntryID  AND
				[TimeEntry].[State] IN (1, 2) AND
				[TimeEntry].[Overtime] = 1 AND
				[Task].[MsTaskID] IS NOT NULL
		)
		BEGIN
			SET @NewOvertimeDuration = ISNULL(@NewDuration, 0)
			SET @NewDuration = 0	
		END	

		SELECT
			@OvertimeWork = SUM([BusyEntry].[OvertimeWork]),
			@ActualOvertimeWork = SUM([BusyEntry].[ActualOvertimeWork]),
			@ActualWork = SUM([BusyEntry].[ActualWork])
		FROM
			[BusyEntry]
		WHERE
			[BusyEntry].[TaskID] = @TaskID AND
			[BusyEntry].[AssignmentID] = @AssignmentID		
/*		IF 
		(
			ISNULL(@RemainingWork, 0) < (ISNULL(@NewDuration, 0) - ISNULL(@ThisDuration, 0))
			AND
			ISNULL(@ThisDuration, 0) < ISNULL(@NewDuration, 0)
		)
		OR
		(
			@NewDuration IS NULL
			AND
			ISNULL(@RemainingWork, 0) < ISNULL(@ThisDuration, 0)
		)
		OR
		(
			(ISNULL(@RemainingWork, 0) + 
			CASE WHEN ISNULL(@ThisDuration, 0) > @Work
				THEN @Work
				ELSE ISNULL(@ThisDuration, 0) END ) < ISNULL(@NewDuration, 0)
			AND
			ISNULL(@ThisDuration, 0) > ISNULL(@NewDuration, 0)
		)*/
		
		IF ((ISNULL(@ActualWork, 0) - ISNULL(@ThisDuration, 0) + ISNULL(@NewDuration, 0)) > ISNULL(@Work, 0))
			OR
			((ISNULL(@ActualOvertimeWork, 0) - ISNULL(@ThisOverTimeDuration, 0) + ISNULL(@NewOvertimeDuration, 0)) > ISNULL(@OvertimeWork, 0))
		BEGIN
			RAISERROR('#TaskBudgetOverdraft', 16, -1)
			RETURN 1
		END
	END	
	RETURN 0
GO

GRANT EXEC ON pjm6AssignmentCheckBudgetOverdraft TO PUBLIC
GO
