IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5AssignmentUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5AssignmentUpdate'
		DROP PROCEDURE [dbo].[pjm5AssignmentUpdate]
	END
GO

PRINT 'Creating procedure pjm5AssignmentUpdate'
GO

/******************************************************************************
**		File: pjm5AssignmentUpdate.sql
**		Name: pjm5AssignmentUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 13:18:25
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		28.01.10	SYV				  Rate     1,2,5
**		03.03.10	SYV				 Rate   pjm6RateAssignmentUpdate
**		07.03.13	SOV				 OpenXml  Xml
**		29.03.13	SOV				  -   ,
**									   : "   /" 
**									 "     ";
**									 ,    . -
**		02.04.13	SOV				  -  ,
**									   : " "
**		08.05.13	SOV				   " ", 
**									     ,
**									       
*******************************************************************************/
CREATE PROCEDURE pjm5AssignmentUpdate
	@Xml	XML
AS
	SET NOCOUNT ON
	DECLARE	@ID TIdentifier,
			@FileAs TName,
			@EmployeeID TIdentifier,
			@ProjectID TIdentifier,
			@QualificationID TIdentifier,
			@StandardRate TMoney,
			@OvertimeRate TMoney,
			@RateVisible TBool,
			@Approver TBool,
			@Administrator TBool,
			@FinanceManagement TBool,
			@TaskReport TBool,
			@IssueReport TBool,
			@Comments TNotes,
			@State TState,
			@doc int,
			@prevQualificationID int,
			@prevStandardRate TMoney,
			@prevOvertimeRate TMoney,
			@flag int,
			@InitState TState,
			@NewID TIdentifier,
			@rv int,
			@PrevEmployeeID TIdentifier,
			@AlwaysUseRate TBool,
			@IsMember TBool,
			@IsAssistant TBool,
			@IsAssignmentEditor TBool,
			@EqualEmployeeFileAs TBool,
			@prevAlwaysUseRate TBool


	SET @InitState = dbo.adfwfGetInitialState('7797bd53-86ce-415e-9e13-b11bcbd52359')
	
	SELECT 
		@ID = @Xml.value('(/pjm5AssignmentGet/Assignment/ID)[1]', 'int'),
		@State = @Xml.value('(/pjm5AssignmentGet/Assignment/State)[1]', 'int'),
		@FileAs = @Xml.value('(/pjm5AssignmentGet/Assignment/FileAs)[1]', 'nvarchar(256)'),
		@ProjectID = @Xml.value('(/pjm5AssignmentGet/Assignment/ProjectID)[1]', 'int'),
		@EmployeeID = @Xml.value('(/pjm5AssignmentGet/Assignment/EmployeeID)[1]', 'int'),
		@QualificationID = @Xml.value('(/pjm5AssignmentGet/Assignment/QualificationID)[1]', 'int'),
		@StandardRate = @Xml.value('(/pjm5AssignmentGet/Assignment/StandardRate)[1]', 'money'),
		@OvertimeRate = @Xml.value('(/pjm5AssignmentGet/Assignment/OvertimeRate)[1]', 'money'),
		@RateVisible = (CASE @Xml.value('(/pjm5AssignmentGet/Assignment/RateVisible)[1]', 'varchar(5)') WHEN 'false' THEN 0 ELSE 1 END),
		@Approver = (CASE @Xml.value('(/pjm5AssignmentGet/Assignment/Approver)[1]', 'varchar(5)') WHEN 'false' THEN 0 ELSE 1 END),
		@Administrator = (CASE @Xml.value('(/pjm5AssignmentGet/Assignment/Administrator)[1]', 'varchar(5)') WHEN 'false' THEN 0 ELSE 1 END),
		@FinanceManagement = (CASE @Xml.value('(/pjm5AssignmentGet/Assignment/FinanceManagement)[1]', 'varchar(5)') WHEN 'false' THEN 0 ELSE 1 END),
		@TaskReport = (CASE @Xml.value('(/pjm5AssignmentGet/Assignment/TaskReport)[1]', 'varchar(5)') WHEN 'false' THEN 0 ELSE 1 END),
		@IssueReport = (CASE @Xml.value('(/pjm5AssignmentGet/Assignment/IssueReport)[1]', 'varchar(5)') WHEN 'false' THEN 0 ELSE 1 END),
		@Comments = @Xml.value('(/pjm5AssignmentGet/Assignment/Comments)[1]', 'nvarchar(max)'),
		@AlwaysUseRate = (CASE @Xml.value('(/pjm5AssignmentGet/Assignment/AlwaysUseRate)[1]', 'varchar(5)') WHEN 'false' THEN 0 ELSE 1 END),
		@EqualEmployeeFileAs = (CASE @Xml.value('(/pjm5AssignmentGet/Assignment/EqualEmployeeFileAs)[1]', 'varchar(5)') WHEN 'false' THEN 0 ELSE 1 END)

	SELECT 
		@prevQualificationID = [Assignment].[QualificationID],
		@prevStandardRate = [Assignment].[StandardRate],
		@prevOvertimeRate = [Assignment].[OvertimeRate],
		@flag = [Assignment].[Flag],
		@PrevEmployeeID = [Assignment].[EmployeeID],
		@prevAlwaysUseRate = [Assignment].[AlwaysUseRate]
	FROM
		[vwAssignment] AS [Assignment]
	WHERE
		[ID]=@ID
	
	DECLARE 
		@CurrentEmployeeID int,
		@UserID int,
		@ProjectState TState,
		@IsPM TBool,
		@ViewFinance TBool,
		@ViewAllFinance TBool

	SET @UserID = dbo.fnPjm5GetEmployeeUserID(@EmployeeID)
	SET @ViewFinance = [dbo].[adfHasAccessRightByNameForUser]('ViewFinance', @UserID)
	SET @ViewAllFinance = [dbo].[adfHasAccessRightByNameForUser]('ViewAllFinance', @UserID)
	
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	IF dbo.fnPjm5IsProjectManager(@ProjectID, @CurrentEmployeeID) = 0 
		AND dbo.fnPjm7IsManagerAssistant(@ProjectID, @CurrentEmployeeID) = 0
	BEGIN
		SET @IsPM = dbo.adfHasAccessRight(dbo.adfGetRightID('ManageProjectTemplates'))
		SELECT @ProjectState = [State] FROM [Project] WHERE [ID] = @ProjectID
		
		SET @IsMember = dbo.fnPjm5IsProjectMember(@ProjectID, @CurrentEmployeeID)
		SET @IsAssistant = dbo.adfHasAccessRight(dbo.adfGetRightID('Assistant'))
		SET @IsAssignmentEditor = 
				(@IsAssistant | @IsMember) 
			& 
				(dbo.adfHasAccessRight(dbo.adfGetRightID('EditAssignment')) & dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllProjects')))
		IF	(
			NOT(
				(@ProjectState IN (5, 6) AND @IsPM = 1) OR
				(@ProjectState NOT IN (5, 6) AND @IsAssignmentEditor = 1)
				)
			)
		BEGIN
			RAISERROR('#accessdenied', 18, -1)
			RETURN 1
		END
	END

	IF (@ViewFinance=0 AND @ViewAllFinance=0 AND @FinanceManagement=1)
	BEGIN		SET @FinanceManagement = 0
	END

	IF @EmployeeID IS NOT NULL AND
		EXISTS (
		SELECT 
			*
		FROM
			[vwAssignment] AS [Assignment]
		WHERE
			[Assignment].[ProjectID]  = @ProjectID AND
			[Assignment].[EmployeeID]  = @EmployeeID AND
			[Assignment].[State] IN (@InitState, 3) AND
			[Assignment].[ID] != @ID
		) 
	BEGIN
		RAISERROR('#AssignmentAlreadyExist', 18, -1)
		RETURN 1
	END
	IF @PrevEmployeeID IS NOT NULL AND @EmployeeID != @PrevEmployeeID
	BEGIN
		IF EXISTS(
			SELECT *
			FROM
				[Assignment]
				INNER JOIN [TaskAssignment]
					ON [TaskAssignment].[AssignmentID] = [Assignment].[ID]
				INNER JOIN [TimeEntry]
					ON [TimeEntry].[TaskID] = [TaskAssignment].[TaskID] AND
						[TimeEntry].[AssignmentID] = [Assignment].[ID]
			WHERE
				[Assignment].[ID] = @ID
			)
		BEGIN
			RAISERROR('#AssignmentUsedInTasks', 18, -1)
			RETURN 1
		END
	END
	
	IF (dbo.fnPjm7IsManagerAssistant(@ProjectID, @EmployeeID) = 1)
	BEGIN
		SET @Approver=1
		SET @Administrator=1
		SET @TaskReport = 1
		SET @IssueReport = 1
	END

	IF (dbo.fnPjm7IsFinanceManager(@ProjectID, @EmployeeID) = 1)
		SET @FinanceManagement = 1

	BEGIN TRANSACTION
	UPDATE 
		[Assignment]
	SET
		[Assignment].[FileAs] = @FileAs,
		[Assignment].[QualificationID] = @QualificationID,
		[Assignment].[StandardRate] = ISNULL(@StandardRate, 0),
		[Assignment].[OvertimeRate] = ISNULL(@OvertimeRate, 0),
		[Assignment].[RateVisible] = @RateVisible,
		[Assignment].[Approver] = @Approver,
		[Assignment].[Administrator] = @Administrator,
		[Assignment].[FinanceManagement] = @FinanceManagement,
		[Assignment].[AlwaysUseRate] = @AlwaysUseRate,
		[Assignment].[ReceiveTaskStatusReports] = @TaskReport,
		[Assignment].[ReceiveIssueStatusReports] = @IssueReport,
		[Assignment].[Comments] = @Comments,
		[Assignment].[Modified] = GETDATE(),
		[Assignment].[ModifiedBy] = dbo.adfGetCurrentUserID(),
		[Assignment].[EqualEmployeeFileAs] = @EqualEmployeeFileAs
	WHERE
		[Assignment].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	IF @EmployeeID IS NULL
	BEGIN
		DELETE FROM [AssignmentEntry] WHERE [AssignmentID] = @ID 
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	ELSE
	BEGIN
		IF EXISTS (SELECT * FROM [AssignmentEntry] WHERE [AssignmentID] = @ID)
		BEGIN
			UPDATE
				[AssignmentEntry]
			SET
				[EmployeeID] = @EmployeeID
			WHERE
				[AssignmentID] = @ID
			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
		ELSE
		BEGIN
			INSERT INTO [AssignmentEntry] ([EmployeeID], [AssignmentID], [ValidFrom])
			VALUES (@EmployeeID, @ID, CAST('17530101' AS datetime))
			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
	END
	IF @State != 3 
		AND 
		(
			@StandardRate != @prevStandardRate 
			OR 
			@OvertimeRate != @prevOvertimeRate 
			OR 
			@AlwaysUseRate != @prevAlwaysUseRate
		)
	BEGIN
		EXEC pjm6RateAssignmentUpdate @ID, @prevStandardRate, @prevOvertimeRate, @prevAlwaysUseRate
		
		IF NOT(@StandardRate = @prevStandardRate AND @OvertimeRate = @prevOvertimeRate)
		BEGIN
			;
			WITH tasks ([ID]) as
			(
				SELECT
					[TaskAssignment].[TaskID]
				FROM
					[TaskAssignment]
				WHERE
					[TaskAssignment].[AssignmentID] = @ID
				GROUP BY 
					[TaskAssignment].[TaskID]
			),
			data ([TaskID], [Budget]) AS
			(
				SELECT
					[TaskAssignment].[TaskID],
					SUM([TaskAssignment].[Work] * [Assignment].[StandardRate] / 60.0)
				FROM
					[TaskAssignment]
					INNER JOIN [Assignment]
						ON [TaskAssignment].[AssignmentID] = [Assignment].[ID]
					INNER JOIN tasks as [Tasks]
						ON [Tasks].[ID] = [TaskAssignment].[TaskID]
				WHERE
					[TaskAssignment].[TaskID] = [Tasks].[ID]
				GROUP BY 
					[TaskAssignment].[TaskID]
			)
			UPDATE
				[Task]
			SET
				[Budget] = ISNULL(data.[Budget], 0)
			FROM 
				[Task]
				INNER JOIN data
					ON data.[TaskID] = [Task].[ID]
			WHERE
				[Task].[State] IN (2, 5, 8)
			IF @@ERROR != 0
			BEGIN
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
	END
	COMMIT TRANSACTION
	
	EXEC pjm5AssignmentGet @ID
	RETURN 0
GO

GRANT EXECUTE ON pjm5AssignmentUpdate TO PUBLIC
GO
