 IF EXISTS (SELECT * FROM sysobjects WHERE type = 'TR' AND name = 'pjm5trBaseCurrencyUpdate')
	BEGIN
		PRINT 'Dropping Trigger pjm5trBaseCurrencyUpdate'
		DROP  Trigger pjm5trBaseCurrencyUpdate
	END
GO

/******************************************************************************
**		File: 
**		Name: pjm5trBaseCurrencyUpdate
**		Desc: 
**
**		This template can be customized:
**              
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:				Description:
**		--------		--------				-------------------------------------------
**    
*******************************************************************************/

PRINT 'Creating Trigger pjm5trBaseCurrencyUpdate'
GO
CREATE TRIGGER pjm5trBaseCurrencyUpdate ON [F41AB0F8-FDF0-4FAD-9B71-8F17B4A51B53] FOR UPDATE
AS
	IF @@rowcount = 0 
		RETURN
	IF EXISTS(
		SELECT *
		FROM
			[inserted]
			INNER JOIN [deleted]
				ON [deleted].[Name] = [inserted].[Name] AND 
					[deleted].[Group] = [inserted].[Group]
		WHERE
			[inserted].[Name] = 'BaseCurrency' AND [inserted].[Group] = 'CommonBusiness' AND
			CAST([deleted].[Value] as varchar(3)) != CAST([inserted].[Value]as varchar(3))
		) AND
		(
			EXISTS (SELECT * FROM [Invoice] WHERE [State] IN (2, 5)) OR
			EXISTS (SELECT * FROM [Statement] WHERE [State] IN (2, 3)) OR
			EXISTS (SELECT * FROM [Payment] WHERE [State] IN (2, 3)) OR
			EXISTS (SELECT * FROM [CreditMemo] WHERE [State] = 2)
		)
	BEGIN
		RAISERROR('#CannotChangeBaseCurrency', 16, -1)
		ROLLBACK TRANSACTION
	END
	
	IF EXISTS(
		SELECT *
		FROM
			[inserted]
			INNER JOIN [deleted]
				ON [deleted].[Name] = [inserted].[Name] AND 
					[deleted].[Group] = [inserted].[Group]
		WHERE
			[inserted].[Name] = 'NationalCurrency' AND [inserted].[Group] = 'CommonBusiness' AND
			CAST([deleted].[Value] as varchar(3)) != CAST([inserted].[Value]as varchar(3))
		) AND
		(
			EXISTS (SELECT * FROM [Facture] WHERE [State] IN (1, 2))
		)
	BEGIN
		RAISERROR('#CannotChangeNationalCurrency', 16, -1)
		ROLLBACK TRANSACTION
	END
	RETURN
GO

   