﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm7BudgetLineWorkBrowseForProjectTemplate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm7BudgetLineWorkBrowseForProjectTemplate'
		DROP PROCEDURE [dbo].[pjm7BudgetLineWorkBrowseForProjectTemplate]
	END
GO

PRINT 'Creating procedure pjm7BudgetLineWorkBrowseForProjectTemplate'
GO

/******************************************************************************
**		File: pjm6BudgetLineWorkBrowseForProjectTemplate.sql
**		Name: pjm7BudgetLineWorkBrowseForProjectTemplate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
*******************************************************************************/
CREATE PROCEDURE pjm7BudgetLineWorkBrowseForProjectTemplate
	@BudgetID			TIdentifier
	
AS
	DECLARE
		@DocumentClass			TClass,
		@PlanningEmployee		TBool,
		@PlanningActivity		TBool,
		@PlanningQualification	TBool,
		@VATRate				TPercent,
		@VATIsIncluded			TBool,
		@MaxOrder				TCount,
		@Lang					TLanguage

	SET @Lang = dbo.adfGetLanguage()

	SET @MaxOrder = (SELECT MAX([Order]) FROM [BudgetLineGroup] WHERE [BudgetID] = @BudgetID AND
		[GroupTypeID] = 1)

	SELECT
		@VATRate = [Budget].[VATRate],
		@VATIsIncluded = [Budget].[VATIsIncluded],
		@PlanningEmployee = [Budget].[PlanningEmployeeForWork],
		@PlanningActivity = [Budget].[PlanningActivityForWork],
		@PlanningQualification = [Budget].[PlanningQualificationForWork]
	FROM
		[Budget]
	WHERE
		[Budget].[ID] = @BudgetID

	SELECT
		[BudgetLineWork].[ID],
		[BudgetLineWork].[Class],
		[BudgetLineWork].[State],
		[BudgetLineWork].[Flag],
		[BudgetLineWork].[FileAs],
		[BudgetLineWork].[BudgetID],
		[BudgetLineWork].[DocumentClass],
		[BudgetLineWork].[DocumentID],
		CASE WHEN [BudgetLineWork].[DocumentID] IS NOT NULL 
			THEN (SELECT TOP(1) [DocumentName] FROM adfGetDocumentIdentity([BudgetLineWork].[DocumentID], [BudgetLineWork].[DocumentClass])) ELSE
			NULL END  AS [DocumentName],
		[BudgetLineWork].[BudgetLineGroupID],
		[BudgetLineWork].[Order],
		dbo.fnPjm6GetSortedBudgetGroup(ISNULL([BudgetLineGroupGlobal].[FileAs], [BudgetLineGroup].[FileAs]), 
			[BudgetLineGroup].[Order], LEN(CAST(@MaxOrder AS nvarchar(max)))) AS [SortedGroupName],
		[BudgetLineWork].[StartDate],
		[BudgetLineWork].[EndDate],
		[BudgetLineWork].[Rate],
		[BudgetLineWork].[AssignmentID],
		[BudgetLineWork].[ActivityTypeID],
		[BudgetLineWork].[QualificationID],
		[BudgetLineWork].[PlannedManHour],
		[BudgetLineWork].[ActualManHour],
		(CASE WHEN @VATRate IS NOT NULL AND @VATIsIncluded = 1 THEN
		[BudgetLineWork].[TotalWithVATPCPlannedManHour] ELSE
		[BudgetLineWork].[TotalPCPlannedManHour] END) AS [TotalPlanned],
		(CASE WHEN @VATRate IS NOT NULL AND @VATIsIncluded = 1 THEN
		[BudgetLineWork].[TotalWithVATPCActualManHour] ELSE
		[BudgetLineWork].[TotalPCActualManHour] END) AS [TotalActual],
		[BudgetLineWork].[Comments],
		[BudgetLineWork].[Created],
		[BudgetLineWork].[CreatedBy],
		[BudgetLineWork].[Modified],
		[BudgetLineWork].[ModifiedBy],
		[BudgetLineWork].[Timestamp],
		~([BudgetLineWork].[Own]) AS [Own] 
	FROM
		[BudgetLineWork]
		LEFT OUTER JOIN [BudgetLineGroup]
			ON [BudgetLineGroup].[ID] = [BudgetLineWork].[BudgetLineGroupID]
		LEFT OUTER JOIN [BudgetLineGroupGlobal] 
			ON ([BudgetLineGroup].[ID] = [BudgetLineGroupGlobal].[ID]
				AND [BudgetLineGroupGlobal].[Language] = @Lang)
	WHERE
		[BudgetLineWork].[BudgetID] = @BudgetID

	RETURN 0
GO

GRANT EXECUTE ON pjm7BudgetLineWorkBrowseForProjectTemplate TO PUBLIC
GO