IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5CalculationAdvanceBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
BEGIN
	PRINT 'Dropping procedure pjm5CalculationAdvanceBrowse'
	DROP PROCEDURE [dbo].[pjm5CalculationAdvanceBrowse]
END
GO

PRINT 'Creating procedure pjm5CalculationAdvanceBrowse'
GO

/******************************************************************************
**		File: pjm5CalculationAdvanceBrowse.sql
**		Name: pjm5CalculationAdvanceBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 01/21/2005 15:47:39
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5CalculationAdvanceBrowse]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	DECLARE 
		@Lang TLanguage,
		@VAT TName
	SET @Lang = dbo.adfGetLanguage()
	IF @Lang = 'en'
		SET @VAT = ', VAT '
	ELSE
		SET @VAT = ',  '

	SELECT
		[Calculation].[Class],
		[Calculation].[ID],
		[Calculation].[State],
		[Calculation].[Date],
		[Calculation].[Number],
		[Calculation].[FileAs] + 
			', ' + CAST(ISNULL([Calculation].[TotalWithVATPC], 0.0) AS varchar(256)) +
			@VAT + CAST(ISNULL([Calculation].[VATPC], 0.0) AS varchar(256))
			AS [FileAs],
		[Calculation].[Created],
		[Calculation].[CreatedBy],
		[Calculation].[Modified],
		[Calculation].[ModifiedBy],
		[Calculation].[Timestamp],
		[Calculation].[CurrencyCode],
		ISNULL([Calculation].[TotalWithVATPC], 0.0) AS [Value],
		ISNULL([Calculation].[VATPC], 0.0) AS [VAT]
	FROM
		[Calculation]
	WHERE
		EXISTS (SELECT * FROM [CalculationAdvance] WHERE [AdvanceCalculationID] = [Calculation].[ID] AND [CalculationID] = @ID)
	RETURN 0
GO

GRANT EXECUTE ON [pjm5CalculationAdvanceBrowse] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5CalculationBrowseAdvanceSelectorDialog]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5CalculationBrowseAdvanceSelectorDialog'
		DROP PROCEDURE [dbo].[pjm5CalculationBrowseAdvanceSelectorDialog]
	END
GO

PRINT 'Creating procedure pjm5CalculationBrowseAdvanceSelectorDialog'
GO

/******************************************************************************
**		File: ServiceBrowseSelectorDialog.sql
**		Name: pjm5CalculationBrowseAdvanceSelectorDialog
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/18/2005 20:56:48
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		11/08/2011  ASA				Language selection added
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5CalculationBrowseAdvanceSelectorDialog]
	@CalculationID TIdentifier,
	@ProjectID TIdentifier,
	@PeriodStart TDate,
	@PeriodEnd TDate,
	@Category TName
AS
	SET NOCOUNT ON
	DECLARE
		@timeClass TClass,
		@expenseClass TClass,
		@phoneClass TClass,
		@statementClass TClass,
		@invoiceClass TClass,
		@requestClass TClass,
		@language TLanguage
		
	SET @language = dbo.adfGetLanguage()
		
	SELECT
		@statementClass = dbo.adfGetClassByName('Pjm5.Statement'),
		@invoiceClass = dbo.adfGetClassByName('Pjm5.Invoice'),
		@timeClass = dbo.adfGetClassByName('Pjm5.TimeEntry'),
		@expenseClass = dbo.adfGetClassByName('Pjm5.Expense'),
		@phoneClass = dbo.adfGetClassByName('Pjm5.PhoneCall'),
		@requestClass = dbo.adfGetClassByName('Pjm5.ServiceRequest')
	
	SELECT
		[Calculation].[Class],
		[Calculation].[ID],
		[Calculation].[State],
		CASE 
			WHEN [Calculation].[DocumentClass] = @timeClass AND @language = 'ru' THEN ''
			WHEN [Calculation].[DocumentClass] = @expenseClass AND @language = 'ru' THEN ''
			WHEN [Calculation].[DocumentClass] = @phoneClass AND @language = 'ru' THEN ' '
			WHEN [Calculation].[DocumentClass] = @requestClass AND @language = 'ru' THEN ''
			WHEN [Calculation].[DocumentClass] = @timeClass AND @language = 'en' THEN 'Time'
			WHEN [Calculation].[DocumentClass] = @expenseClass AND @language = 'en' THEN 'Expenses'
			WHEN [Calculation].[DocumentClass] = @phoneClass AND @language = 'en' THEN 'Phone Calls'
			WHEN [Calculation].[DocumentClass] = @requestClass AND @language = 'en' THEN 'Orders'
			ELSE NULL
		END AS [CalculationType],
		[Calculation].[Number],
		[Calculation].[FileAs],
		[Calculation].[Date],
		[Calculation].[CurrencyCode],
		[Calculation].[VATRate],
		[Calculation].[RatesWithVAT] AS [VATIsIncluded],
		
		[Calculation].[Total],
		[Calculation].[TotalWithVAT],
		[Calculation].[VAT],
		[Calculation].[TotalPC],
		[Calculation].[TotalWithVATPC],
		[Calculation].[VATPC]
	FROM
		[Calculation]
	WHERE
		[Calculation].[ProjectID] = @ProjectID AND
		[Calculation].[Date] BETWEEN @PeriodStart AND @PeriodEnd AND
		[Calculation].[State] = 2 AND
		[Calculation].[DocumentClass] IN (@expenseClass, @phoneClass) AND
		[Calculation].[ID] != @CalculationID AND
		(
			@Category IS NULL OR
			LEN(@Category) = 0 OR
			EXISTS(
				SELECT * 
				FROM [DocumentCategory] 
					INNER JOIN [Category]
						ON [Category].[ID] = [DocumentCategory].[CategoryID] 
				WHERE
					[DocumentCategory].[DocumentClass] = [Calculation].[Class] AND
					[DocumentCategory].[DocumentID] = [Calculation].[ID] AND
					[Category].[FileAs] LIKE @Category
			)
		)
	RETURN 0
GO

GRANT EXECUTE ON [pjm5CalculationBrowseAdvanceSelectorDialog] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5CalculationAdvanceAppend]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
BEGIN
	PRINT 'Dropping procedure pjm5CalculationAdvanceAppend'
	DROP PROCEDURE [dbo].[pjm5CalculationAdvanceAppend]
END
GO

PRINT 'Creating procedure pjm5CalculationAdvanceAppend'
GO

/******************************************************************************
**		File: pjm5CalculationAdvanceAppend.sql
**		Name: pjm5CalculationAdvanceAppend
**		Desc:    
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 01/21/2005 15:47:39
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5CalculationAdvanceAppend]
	@ID TIdentifier,
	@AdvanceCalculationID TIdentifier
AS
	SET NOCOUNT ON

	DECLARE 
		@State TState,
		@Total TMoney,
		@TotalWithVAT TMoney,
		@CalculationClass TClass
	SET @CalculationClass = dbo.adfGetClassByName('Pjm5.Calculation')

	SELECT
		@State = [State],
		@Total = [TotalPC],
		@TotalWithVAT = [TotalWithVATPC]
	FROM
		[Calculation]
	WHERE
		[ID] = @AdvanceCalculationID

	IF @State = 5
	BEGIN
		RAISERROR('#CalculationAlreadyLinked', 18, -1)
		RETURN 1
	END

	IF ISNULL((SELECT [State] FROM [Calculation] WHERE [ID] = @ID), 0) = 3
	BEGIN
		RAISERROR('#TransitionTemplateCouldNotBeFound', 18, -1)
		RETURN 1
	END
		
	BEGIN TRANSACTION

	INSERT INTO [CalculationAdvance]
		([CalculationID], [AdvanceCalculationID]) VALUES (@ID, @AdvanceCalculationID)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	UPDATE 
		[Calculation] 
	SET
		[TotalWithoutDiscount] = [TotalWithoutDiscount] + @Total,
		[TotalWithoutDiscountPC] = [TotalWithoutDiscountPC] + @Total,
		[TotalWithVATWithoutDiscount] = [TotalWithVATWithoutDiscount] + @TotalWithVAT,
		[TotalWithVATWithoutDiscountPC] = [TotalWithVATWithoutDiscountPC] + @TotalWithVAT,
		[Total] = [Total] + @Total,
		[TotalPC] = [TotalPC] + @Total,
		[TotalWithVAT] = [TotalWithVAT] + @TotalWithVAT,
		[TotalWithVATPC] = [TotalWithVATPC] + @TotalWithVAT,
		[Modified] = DEFAULT,
		[ModifiedBy] = DEFAULT
	WHERE 
		[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	UPDATE
		[Calculation]
	SET
		[State] = 5,
		[Modified] = DEFAULT,
		[ModifiedBy] = DEFAULT
	WHERE
		[ID] = @AdvanceCalculationID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	INSERT INTO [Attachment]
		(
		[DocumentClass], [DocumentID], [Name],
		[LinkDocumentClass], [LinkDocumentID], [AttachmentTypeID]
		)
	VALUES
		(
		@CalculationClass, @AdvanceCalculationID, '',
		@CalculationClass, @ID, 3
		)	
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	COMMIT TRANSACTION
	RETURN 0
GO

GRANT EXECUTE ON [pjm5CalculationAdvanceAppend] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5CalculationAdvanceRemove]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
BEGIN
	PRINT 'Dropping procedure pjm5CalculationAdvanceRemove'
	DROP PROCEDURE [dbo].[pjm5CalculationAdvanceRemove]
END
GO

PRINT 'Creating procedure pjm5CalculationAdvanceRemove'
GO

/******************************************************************************
**		File: pjm5CalculationAdvanceRemove.sql
**		Name: pjm5CalculationAdvanceRemove
**		Desc:    
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 01/21/2005 15:47:39
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		30.03.11	SYV				    
*******************************************************************************/
CREATE PROCEDURE [pjm5CalculationAdvanceRemove]
	@ID TIdentifier,
	@AdvanceCalculationID TIdentifier
AS
	SET NOCOUNT ON

	DECLARE 
		@Total TMoney,
		@TotalWithVAT TMoney,
		@CalculationClass TClass
	
	IF ISNULL((SELECT [State] FROM [Calculation] WHERE [ID] = @ID), 0) = 3
	BEGIN
		RAISERROR('#TransitionTemplateCouldNotBeFound', 18, -1)
		RETURN 1
	END

	SET @CalculationClass = dbo.adfGetClassByName('Pjm5.Calculation')
	
	SELECT
		@Total = [TotalPC],
		@TotalWithVAT = [TotalWithVATPC]
	FROM
		[Calculation]
	WHERE
		[ID] = @AdvanceCalculationID
		
	BEGIN TRANSACTION

	DELETE [CalculationAdvance] 
	WHERE [AdvanceCalculationID] = @AdvanceCalculationID AND [CalculationID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	UPDATE 
		[Calculation] 
	SET
		[TotalWithoutDiscount] = [TotalWithoutDiscount] - @Total,
		[TotalWithoutDiscountPC] = [TotalWithoutDiscountPC] - @Total,
		[TotalWithVATWithoutDiscount] = [TotalWithVATWithoutDiscount] - @TotalWithVAT,
		[TotalWithVATWithoutDiscountPC] = [TotalWithVATWithoutDiscountPC] - @TotalWithVAT,
		[Total] = [Total] - @Total,
		[TotalPC] = [TotalPC] - @Total,
		[TotalWithVAT] = [TotalWithVAT] - @TotalWithVAT,
		[TotalWithVATPC] = [TotalWithVATPC] - @TotalWithVAT,
		[Modified] = DEFAULT,
		[ModifiedBy] = DEFAULT
	WHERE 
		[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	UPDATE
		[Calculation]
	SET
		[State] = 2,
		[Modified] = DEFAULT,
		[ModifiedBy] = DEFAULT
	WHERE
		[ID] = @AdvanceCalculationID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	DELETE 
		[Attachment]
	WHERE
		[Attachment].[DocumentClass] = @CalculationClass AND
		[Attachment].[DocumentID] = @AdvanceCalculationID AND
		[Attachment].[LinkDocumentClass] = @CalculationClass AND 
		[Attachment].[LinkDocumentID] = @ID AND
		[AttachmentTypeID] = 3
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	COMMIT TRANSACTION
	RETURN 0
GO

GRANT EXECUTE ON [pjm5CalculationAdvanceRemove] TO PUBLIC
GO
