IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5CompanyStatusBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5CompanyStatusBrowse'
		DROP PROCEDURE [dbo].[pjm5CompanyStatusBrowse]
	END
GO

PRINT 'Creating procedure pjm5CompanyStatusBrowse'
GO

/******************************************************************************
**		File: pjm5CompanyStatusBrowse.sql
**		Name: pjm5CompanyStatusBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 03/11/2005 17:08:24
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5CompanyStatusBrowse]
	@StateSelector INT
AS
	SET NOCOUNT ON
	SELECT
		[CompanyStatus].[Class],
		[CompanyStatus].[ID],
		[CompanyStatus].[State],
		[CompanyStatus].[Flag],
		[CompanyStatus].[Code],
		[CompanyStatus].[FileAs],
		[CompanyStatus].[Comments],
		[CompanyStatus].[Created],
		[CompanyStatus].[CreatedBy],
		[CompanyStatus].[Modified],
		[CompanyStatus].[ModifiedBy],
		[CompanyStatus].[Timestamp]
	FROM
		[CompanyStatus]
	WHERE
		(
			(@StateSelector = 0) OR 
			(@StateSelector = 1 AND [CompanyStatus].[State] IN (1, 100)) OR
			(@StateSelector = 2 AND [CompanyStatus].[State] = 2)
		)
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5CompanyStatusBrowse] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5CompanyStatusGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5CompanyStatusGet'
		DROP PROCEDURE [dbo].[pjm5CompanyStatusGet]
	END
GO

PRINT 'Creating procedure pjm5CompanyStatusGet'
GO

/******************************************************************************
**		File: pjm5CompanyStatusGet.sql
**		Name: pjm5CompanyStatusGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 03/11/2005 17:08:24
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5CompanyStatusGet]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	SELECT
		[CompanyStatus].[Class],
		[CompanyStatus].[ID],
		[CompanyStatus].[State],
		[CompanyStatus].[Flag],
		[CompanyStatus].[Code],
		[CompanyStatus].[FileAs],
		[CompanyStatus].[Comments],
		[CompanyStatus].[Created],
		[CompanyStatus].[CreatedBy],
		[CompanyStatus].[Modified],
		[CompanyStatus].[ModifiedBy],
		[CompanyStatus].[Timestamp]
	FROM
		[CompanyStatus]
	WHERE
		[CompanyStatus].[ID] = @ID
	IF @@ROWCOUNT = 0
		RETURN 1
	RETURN 0
GO

GRANT EXECUTE ON [pjm5CompanyStatusGet] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5CompanyStatusCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5CompanyStatusCreate'
		DROP PROCEDURE [dbo].[pjm5CompanyStatusCreate]
	END
GO

PRINT 'Creating procedure pjm5CompanyStatusCreate'
GO

/******************************************************************************
**		File: pjm5CompanyStatusCreate.sql
**		Name: pjm5CompanyStatusCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 03/11/2005 17:08:24
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5CompanyStatusCreate]
	@Code TCode,
	@FileAs TName,
	@Comments TNotes
AS
	DECLARE @State TState,
			@ID TIdentifier
	
	SET NOCOUNT ON
	
	SET @State = dbo.adfwfGetInitialState('0611E1D2-3930-4338-BB6B-E9F8561A823D')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	INSERT INTO [CompanyStatus]
		([Flag], [State], [Code], [FileAs], [Comments])
	VALUES
		(0, @State, @Code, @FileAs, @Comments)
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()

	EXEC pjm5CompanyStatusGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5CompanyStatusCreate TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5CompanyStatusUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5CompanyStatusUpdate'
		DROP PROCEDURE [dbo].[pjm5CompanyStatusUpdate]
	END
GO

PRINT 'Creating procedure pjm5CompanyStatusUpdate'
GO

/******************************************************************************
**		File: pjm5CompanyStatusUpdate.sql
**		Name: pjm5CompanyStatusUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 03/11/2005 17:08:24
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5CompanyStatusUpdate
	@ID TIdentifier,
	@Code TCode,
	@FileAs TName,
	@Comments TNotes
AS
	
	SET NOCOUNT ON
	
	UPDATE 
		[CompanyStatus]
	SET
		[CompanyStatus].[Code] = @Code,
		[CompanyStatus].[FileAs] = @FileAs,
		[CompanyStatus].[Comments] = @Comments,
		[CompanyStatus].[Modified] = DEFAULT,
		[CompanyStatus].[ModifiedBy] = DEFAULT
	WHERE
		[CompanyStatus].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	EXEC pjm5CompanyStatusGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5CompanyStatusUpdate TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5CompanyStatusDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5CompanyStatusDelete'
		DROP PROCEDURE [dbo].[pjm5CompanyStatusDelete]
	END
GO

PRINT 'Creating procedure pjm5CompanyStatusDelete'
GO

/******************************************************************************
**		File: pjm5CompanyStatusDelete.sql
**		Name: pjm5CompanyStatusDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 03/11/2005 17:08:24
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5CompanyStatusDelete
	@ID TIdentifier
AS
	SET NOCOUNT ON
	
	DELETE FROM [CompanyStatus] WHERE [CompanyStatus].[ID] = @ID

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON pjm5CompanyStatusDelete TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5CompanyStatusChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5CompanyStatusChangeState'
		DROP PROCEDURE [dbo].[pjm5CompanyStatusChangeState]
	END
GO

PRINT 'Creating procedure pjm5CompanyStatusChangeState'
GO

/******************************************************************************
**		File: pjm5CompanyStatusChangeState.sql
**		Name: pjm5CompanyStatusChangeState
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 03/11/2005 17:08:24
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5CompanyStatusChangeState
	@ID TIdentifier,
	@ToState TState
AS
	DECLARE @FromState TState,
			@TransitionTemplateID TIdentifier,
			@RightID TIdentifier,
			@Class TClass
	
	SET NOCOUNT ON
	
	SELECT
		@Class = [CompanyStatus].[Class],
		@FromState = [CompanyStatus].[State]
	FROM
		[CompanyStatus]
	WHERE
		[CompanyStatus].[ID] = @ID
		
	IF @FromState = @ToState
	BEGIN
		RAISERROR('#invalidargument', 18, -1)
		RETURN 1
	END
	
	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#invalidoperation', 18, -1)
		RETURN 1
	END
	
	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())
	
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	UPDATE
		[CompanyStatus]
	SET
		[CompanyStatus].[State] = @ToState,
		[CompanyStatus].[Modified] = DEFAULT,
		[CompanyStatus].[ModifiedBy] = DEFAULT
	WHERE
		[CompanyStatus].[ID] = @ID
	AND
		[CompanyStatus].[State] = @FromState

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON pjm5CompanyStatusChangeState TO PUBLIC
GO
