IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ContractBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ContractBrowse'
		DROP PROCEDURE [dbo].[pjm5ContractBrowse]
	END
GO

PRINT 'Creating procedure pjm5ContractBrowse'
GO

/******************************************************************************
**		File: ContractBrowse.sql
**		Name: pjm5ContractBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 11:01:32
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ContractBrowse]
	@StateSelector INT,
	@CompanyID INT
AS
	SET NOCOUNT ON
	
	DECLARE
		@CurrentEmployeeID int,
		@ViewAllProjects bit
	SELECT 
		@CurrentEmployeeID = dbo.adfGetCurrentEmployeeID(),
		@ViewAllProjects = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllProjects'))
	
	SELECT
		[Project].[Class],
		[Project].[ID],
		[Project].[State],
		[Project].[Flag],
		[Project].[Date],
		[Project].[Number],
		[Project].[FileAs],
		[Project].[SupplierCompanyID],
		[Project].[ProjectManagerEmployeeID],
		[Project].[CustomerCompanyID],
		[Project].[ResponsiblePersonEmployeeID],
		[Project].[PriorityID],
		[Project].[EndDate],
		[Project].[CurrencyCode],
		[Project].[CostCenterID],
		[Project].[Budget],
		[Project].[Billable],
		[Project].[RoundingInterval],
		[Project].[RoundingMode],
		[Project].[ContractNumber],
		[Project].[ContractDate],
		[Project].[ContractSubject],
		[Project].[ServiceLevelID],
		[Project].[ApplyVAT],
		[Project].[InvoiceExpirationPeriod],
		[Project].[InvoiceExpirationPeriodType],
		[Project].[Comments],
		[Project].[Created],
		[Project].[CreatedBy],
		[Project].[Modified],
		[Project].[ModifiedBy],
		[Project].[Timestamp]
	FROM
		[Project]
	WHERE
		NOT EXISTS (SELECT [ID] FROM [ProjectTemplate] WHERE [ID] = [Project].[ID]) AND
		((@StateSelector = 0) OR (@StateSelector != 0 AND [Project].[State] = @StateSelector))
		AND
		((@CompanyID IS NULL) OR 
		(((SELECT [Own] FROM [Company] WHERE [ID] = @CompanyID) > 0) AND [Project].[SupplierCompanyID] = @CompanyID) OR
		(((SELECT [Own] FROM [Company] WHERE [ID] = @CompanyID) = 0) AND [Project].[CustomerCompanyID] = @CompanyID))
		AND
		(
			@ViewAllProjects = 1 OR
			[Project].[ProjectManagerEmployeeID] = @CurrentEmployeeID OR
			dbo.fnPjm5IsProjectMember([Project].[ID], @CurrentEmployeeID) = 1
		)
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ContractBrowse] TO PUBLIC
GO 