IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[pjm6fnCurrencyGetRate]') AND type in (N'FN', N'IF', N'TF', N'FS', N'FT'))
DROP FUNCTION [dbo].[pjm6fnCurrencyGetRate]
GO
/******************************************************************************
**		Name: pjm6fnCurrencyGetRate
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		03.07.15	SAP				   
**		07.09.15	SAP				   
*******************************************************************************/
CREATE FUNCTION pjm6fnCurrencyGetRate
(
	@CurrencyCode TCode3,
	@Date TDate,
	@ToCurrencyCode TCode3
)

RETURNS TMoney

AS
BEGIN

	DECLARE	
		@Rate TMoney

	SET @Date = CAST(CONVERT(varchar(8), @Date, 112) AS datetime)
	
	IF(@CurrencyCode != @ToCurrencyCode)
	BEGIN
		SET @Rate = (SELECT 
			TOP 1 (CASE WHEN [CurrencyRate].[FromCurrencyCode] = @CurrencyCode
			THEN [CurrencyRate].[Rate] ELSE 1/[CurrencyRate].[Rate] END)
		FROM
			[CurrencyRate]
		WHERE
			(
				(
					[CurrencyRate].[FromCurrencyCode] = @CurrencyCode
					AND 
					[CurrencyRate].[ToCurrencyCode] = @ToCurrencyCode
				)
				OR
				(
					[CurrencyRate].[FromCurrencyCode] = @ToCurrencyCode
					AND 
					[CurrencyRate].[ToCurrencyCode] = @CurrencyCode
				)
			)
			AND 
			(
				(@Date >= [ValidFrom] AND @Date <= [ValidTo])
				OR 
				@Date > [ValidTo]
			)
		ORDER BY [ValidFrom] DESC)
	END
	ELSE
		SET @Rate = 1

RETURN ISNULL(@Rate, 1)
END
GO

/******************************************************************************
**		Name: fnCurrencyGetExactRate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.svintsov
**		Date: 25/04/2011 14:07:25
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		25.04.11	SPV				First version
**    
*******************************************************************************/
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[fnCurrencyGetExactRate]') AND type in (N'FN', N'IF', N'TF', N'FS', N'FT'))
DROP FUNCTION [dbo].[fnCurrencyGetExactRate]
GO

CREATE FUNCTION fnCurrencyGetExactRate
(
	@CurrencyCode TCode3,
	@ToCurrencyCode TCode3,
	@Date TDate
)

RETURNS TMoney

AS
BEGIN
	IF @CurrencyCode = @ToCurrencyCode
		RETURN 1
	DECLARE	@Rate TMoney
	SET @Date = CAST(CONVERT(varchar(8), @Date, 112) AS datetime)
	
	IF(@CurrencyCode != @ToCurrencyCode)
	BEGIN
		SET @Rate = (
		SELECT TOP 1
			(CASE WHEN [CurrencyRate].[FromCurrencyCode] = @CurrencyCode THEN [CurrencyRate].[Rate]
			 ELSE -1.0 * [CurrencyRate].[Rate] END)
		FROM
			[CurrencyRate]
		WHERE
			([CurrencyRate].[FromCurrencyCode] = @CurrencyCode AND
			[CurrencyRate].[ToCurrencyCode] = @ToCurrencyCode OR
			[CurrencyRate].[FromCurrencyCode] = @ToCurrencyCode AND
			[CurrencyRate].[ToCurrencyCode] = @CurrencyCode) AND
			@Date BETWEEN [ValidFrom] AND [ValidTo]
		ORDER BY [ValidFrom] DESC)
	END
	RETURN @Rate
END
GO
