IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5DocumentCardChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5DocumentCardChangeState'
		DROP PROCEDURE [dbo].[pjm5DocumentCardChangeState]
	END
GO

PRINT 'Creating procedure pjm5DocumentCardChangeState'
GO

/******************************************************************************
**		File: pjm5DocumentCardChangeState.sql
**		Name: pjm5DocumentCardChangeState
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: vladislav.dremin
**		Date: 08/30/2005 12:32:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5DocumentCardChangeState
	@ID TIdentifier,
	@ToState TState
AS
	SET NOCOUNT ON

	DECLARE @FromState TState,
			@TransitionTemplateID TIdentifier,
			@RightID TIdentifier,
			@Class TClass,
			@DocumentItemState TState,
			@HasToBeSentBack TBool,
			@SentBackTime TDateTime,
			@DocumentSendBackTypeID TIdentifier
	
	SELECT
		@Class = [DocumentCard].[Class],
		@FromState = [DocumentCard].[State],
		@DocumentItemState = [DocumentItem].[State],
		@HasToBeSentBack = [DocumentCard].[HasToBeSentBack],
		@DocumentSendBackTypeID = [DocumentCard].[DocumentSendBackTypeID],
		@SentBackTime = [DocumentCard].[SentBackTime]
	FROM
		[DocumentCard]
		LEFT OUTER JOIN [DocumentItem]
			ON [DocumentItem].[DocumentCardID] = [DocumentCard].[ID]
	WHERE
		[DocumentCard].[ID] = @ID
		
	IF @FromState = @ToState
	BEGIN
		RAISERROR('#invalidargument', 18, -1)
		RETURN 1
	END
	
	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#invalidoperation', 18, -1)
		RETURN 1
	END
	
	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())
	
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	IF @FromState = 2 AND @ToState = 3 AND @DocumentItemState = 3
	BEGIN
		RAISERROR('#cannotapprovecheckedoutdocument', 18, -1)
		RETURN 1
	END
	
	IF @ToState = 3 AND @HasToBeSentBack = 1 AND
		(@DocumentSendBackTypeID IS NULL OR @SentBackTime IS NULL)
	BEGIN
		RAISERROR('#cannotapprovenotsentbackdocument', 18, -1)
		RETURN 1
	END


	BEGIN TRANSACTION

	UPDATE
		[DocumentCard]
	SET
		[DocumentCard].[State] = @ToState,
		[DocumentCard].[Modified] = DEFAULT,
		[DocumentCard].[ModifiedBy] = DEFAULT
	WHERE
		[DocumentCard].[ID] = @ID
	AND
		[DocumentCard].[State] = @FromState
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	IF @FromState = 1 AND @ToState = 2
		EXEC pjm5DocumentCardSendToApproveNotification @ID
	ELSE IF @FromState = 2 AND @ToState = 3
		EXEC pjm5DocumentCardApprovedNotification @ID
	ELSE IF @FromState IN (2, 3) AND @ToState = 1
		EXEC pjm5DocumentCardRecommitedNotification @ID
		
	COMMIT TRANSACTION
	RETURN 0
GO

GRANT EXECUTE ON pjm5DocumentCardChangeState TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5IncomingDocumentChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5IncomingDocumentChangeState'
		DROP PROCEDURE [dbo].[pjm5IncomingDocumentChangeState]
	END
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5OutgoingDocumentChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5OutgoingDocumentChangeState'
		DROP PROCEDURE [dbo].[pjm5OutgoingDocumentChangeState]
	END
GO

