﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6ExpenseForBudgetBrowseSelectorDialog]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6ExpenseForBudgetBrowseSelectorDialog'
		DROP PROCEDURE [dbo].[pjm6ExpenseForBudgetBrowseSelectorDialog]
	END
GO

PRINT 'Creating procedure pjm6ExpenseForBudgetBrowseSelectorDialog'
GO

/******************************************************************************
**		File: ExpenseForBudgetBrowseSelectorDialog.sql
**		Name: pjm6ExpenseForBudgetBrowseSelectorDialog
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.boruroev
**		Date: 01/20/2005 16:11:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6ExpenseForBudgetBrowseSelectorDialog]
	@ProjectID				TIdentifier,
	@CurrencyCode			TCode3,
	@ExpenseCodeSelector	TIdentifier
AS
	SET NOCOUNT ON

	SELECT
		[Expense].[ID],
		[Expense].[State],
		[Expense].[Date],
		[Expense].[FileAs],
		[Expense].[FromCurrencyCode],
		[ExpenseCode].[FileAs] AS [ExpenseCodeFileAs]
	FROM
		[Expense]
		LEFT OUTER JOIN [ExpenseCode]
		ON [Expense].[ExpenseCodeID] = [ExpenseCode].[ID]
	WHERE
		[Expense].[ProjectID] = @ProjectID AND
		([Expense].[FromCurrencyCode] = @CurrencyCode OR @CurrencyCode IS NULL) AND
		(@ExpenseCodeSelector = 0 OR (@ExpenseCodeSelector != 0 AND [Expense].[ExpenseCodeID] IS NOT NULL AND [Expense].[ExpenseCodeID] = @ExpenseCodeSelector))
	RETURN 0
GO

GRANT EXECUTE ON [pjm6ExpenseForBudgetBrowseSelectorDialog] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm7ExpenseForBudgetLineBrowseSelectorDialog]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm7ExpenseForBudgetLineBrowseSelectorDialog'
		DROP PROCEDURE [dbo].[pjm7ExpenseForBudgetLineBrowseSelectorDialog]
	END
GO

PRINT 'Creating procedure pjm7ExpenseForBudgetLineBrowseSelectorDialog'
GO

/******************************************************************************
**		File: ExpenseForBudgetBrowseSelectorDialog.sql
**		Name: pjm7ExpenseForBudgetLineBrowseSelectorDialog
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Maria.Bastrakova
**		Date: 05/03/2013 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**								
*******************************************************************************/
CREATE PROCEDURE [pjm7ExpenseForBudgetLineBrowseSelectorDialog]
	@ProjectID				TIdentifier,
	@CurrencyCode			TCode3,
	@PeriodStart			TDate,
	@PeriodEnd				TDate,
	@ExpenseCodeSelector	TIdentifier,
	@SentToApprove			TBool,
	@DocumentClass			TClass,
	@DocumentID				TIdentifier	= NULL,
	@EmployeeID				TIdentifier = NULL,
	@ContactClass			TClass		= NULL,
	@ContactID				TIdentifier = NULL,
	@Category				TName,
	@Flag					int			= NULL
	
AS
SET NOCOUNT ON

	DECLARE 
		@value TVariant,
		@VATRate TPercent,
		@FlagTask TBool,
		@FlagService TBool,
		@FlagFileAs TBool,
		@FlagComments TBool,
		@Separator1 TName,
		@Separator2 TName,
		@Separator3 TName,
		@TaskRequestSeparator TName,
		@ServiceRequestSeparator TName,
		@IssueSeparator TName,
		@FlagTaskRequest TBool,
		@FlagServiceRequest TBool,
		@FlagIssue TBool,
		@RatesWithVAT TBool,
		@PCurrencyCode TCode3,
		@UseTaskClass TBool = 0
		
	IF dbo.adfGetClassByName('Pjm5.Task') = @DocumentClass
		SET @UseTaskClass = 1

	SELECT
		@PCurrencyCode = [CurrencyCode]
	FROM
		[Project]
	WHERE
		[Project].[ID] = @ProjectID
	
	SELECT
		@PeriodStart = CAST(CONVERT(varchar(8), @PeriodStart, 112) AS datetime),
		@PeriodEnd = DATEADD(day, 1, CAST(CONVERT(varchar(8), @PeriodEnd, 112) AS datetime))

	SET @value = NULL
		EXEC adfParameterGet @Name='DocumentLineContainsTask', @Group='Pjm5', @Value = @value OUTPUT
		SET @FlagTask = ISNULL(CAST(@value as bit), 0)
			
		SET @value = NULL
		EXEC adfParameterGet @Name='DocumentLineContainsService', @Group='Pjm5', @Value = @value OUTPUT
		SET @FlagService = ISNULL(CAST(@value as bit), 0)

		SET @value = NULL
		EXEC adfParameterGet @Name='DocumentLineContainsFileAs', @Group='Pjm5', @Value = @value OUTPUT
		SET @FlagFileAs = ISNULL(CAST(@value as bit), 0)

		SET @value = NULL
		EXEC adfParameterGet @Name='DocumentLineContainsComments', @Group='Pjm5', @Value = @value OUTPUT
		SET @FlagComments = ISNULL(CAST(@value as bit), 0)
		
		SET @value = NULL
		EXEC adfParameterGet @Name='DocumentLineContainsServiceRequest', @Group='Pjm5', @Value = @value OUTPUT
		SET @FlagServiceRequest = ISNULL(CAST(@value as bit), 0)

		SET @value = NULL
		EXEC adfParameterGet @Name='DocumentLineContainsTaskRequest', @Group='Pjm5', @Value = @value OUTPUT
		SET @FlagTaskRequest = ISNULL(CAST(@value as bit), 0)

		SET @value = NULL
		EXEC adfParameterGet @Name='DocumentLineContainsIssue', @Group='Pjm5', @Value = @value OUTPUT
		SET @FlagIssue = ISNULL(CAST(@value as bit), 0)

		SELECT
			DISTINCT	
			[Expense].[ID],
			[Expense].[Class],	
			[Expense].[Date],
			[Employee].[FileAs] AS [Employee],
			[Expense].[FileAs],
			[Expense].[Amount],
			[Expense].[Price],

			(CASE
				WHEN [Expense].[VATIsIncluded] = 1 THEN 
					[Expense].[Price] * [Expense].[Amount] - [Expense].[VAT]
				WHEN [Expense].[VATIsIncluded] = 0 THEN
					[Expense].[Price] * [Expense].[Amount]
			END) AS [TotalWithoutVAT],

			(CASE
				WHEN [Project].[ApplyVAT] = 1 THEN
					(CASE
						WHEN [Expense].[VATIsIncluded] = 1 THEN
							[Expense].[Price] * [Expense].[Amount]
						WHEN [Expense].[VATIsIncluded] = 0 THEN
							[Expense].[Price] * [Expense].[Amount] + [Expense].[VAT]
					END)	
				WHEN [Project].[ApplyVAT] = 0 THEN	
					([Expense].[Price] * [Expense].[Amount])
			END) AS [Total],

			[Expense].[FromCurrencyCode] AS [CurrencyCode],
			[Expense].[TotalWithVATPC] AS [TotalPC],

			[Expense].[Comments],
			dbo.fnPjm5GetEntryDescription(
				CASE @FlagTask WHEN 1 THEN [Task].[FileAs] ELSE NULL END,
				NULL,
				CASE @FlagFileAs WHEN 1 THEN [Expense].[FileAs] ELSE NULL END,
				CASE @FlagComments WHEN 1 THEN [Expense].[Comments] ELSE NULL END,
				CASE @FlagIssue WHEN 1 THEN [Issue].[FileAs] ELSE NULL END,
				CASE @FlagServiceRequest WHEN 1 THEN [ServiceRequest].[FileAs] ELSE NULL END,
				CASE @FlagTaskRequest WHEN 1 THEN [TaskRequest].[FileAs] ELSE NULL END,				
				ISNULL(@Separator1, ' '),
				ISNULL(@Separator2, ' '),
				ISNULL(@Separator3, ' '),
				ISNULL(@IssueSeparator, ' '),
				ISNULL(@ServiceRequestSeparator, ' '),
				ISNULL(@TaskRequestSeparator, ' '),
				[Expense].[FileAs]
			) AS [Description],
			[BudgetLineWork].[ExpenseID],
			[BudgetLineExpense].[ExpenseID]
		FROM
			[Expense]
			INNER JOIN [Employee]
				ON [Employee].[ID] = [Expense].[EmployeeID]
			LEFT OUTER JOIN [Task]
				ON [Task].[ID] = [Expense].[TaskID]
			LEFT OUTER JOIN [ServiceRequest]
				ON [ServiceRequest].[Class] = [Expense].[DocumentClass] 
					AND [ServiceRequest].[ID] = [Expense].[DocumentID]
			LEFT OUTER JOIN [Issue]
				ON [Issue].[Class] = [Expense].[DocumentClass] 
					AND [Issue].[ID] = [Expense].[DocumentID]
			LEFT OUTER JOIN [TaskRequest]
				ON [TaskRequest].[Class] = [Expense].[DocumentClass] 
					AND [TaskRequest].[ID] = [Expense].[DocumentID]
			LEFT OUTER JOIN [DocumentContact]
				ON [Expense].[Class] = [DocumentContact].[DocumentClass] 
					AND [Expense].[ID] = [DocumentContact].[DocumentID]
			INNER JOIN [Project]
				ON [Expense].[ProjectID] = [Project].[ID]
			LEFT JOIN [BudgetLineWork]
				ON [BudgetLineWork].[ExpenseID] = [Expense].[ID]
			LEFT JOIN [BudgetLineExpense]
				ON [BudgetLineExpense].[ExpenseID] = [Expense].[ID]
		WHERE
			[BudgetLineWork].[ExpenseID] IS NULL AND
			[BudgetLineExpense].[ExpenseID] IS NULL AND
			(
				@Flag IS NULL OR
				[Expense].[Flag] = @Flag
			) AND
			(
				[Expense].[ProjectID] = @ProjectID
				
			) AND
			[Expense].[Date] >= @PeriodStart AND 
			[Expense].[Date] < @PeriodEnd AND
			([Expense].[ExpenseCodeID] IS NULL OR [Expense].[ExpenseCodeID] != 1) AND
			(
				[Expense].[State] = 3 OR
				@SentToApprove = 1 AND [Expense].[State] = 2
			) AND
			([Expense].[FromCurrencyCode] = @CurrencyCode OR @CurrencyCode IS NULL) AND
			NOT EXISTS(
				SELECT * FROM [Attachment] 
				WHERE 
					[DocumentClass] = [Expense].[Class] AND 
					[DocumentID] = [Expense].[ID] AND 
					[AttachmentTypeID] = 3 
			) AND
			(@EmployeeID IS NULL OR [Employee].[ID] = @EmployeeID) AND
			(
				@Category IS NULL OR 
				EXISTS (
					SELECT * 
					FROM
						[DocumentCategory]
						INNER JOIN [Category]
							ON ([DocumentCategory].[DocumentClass] = [Category].[DocumentClass] AND 
								[DocumentCategory].[CategoryID] = [Category].[ID])
					WHERE
						[DocumentCategory].[DocumentClass] = [Expense].[Class] AND 
						[DocumentCategory].[DocumentID] = [Expense].[ID] AND
						[Category].[FileAs] LIKE @Category
					)
			) AND
			(
				@DocumentID IS NULL OR
				((@UseTaskClass = 0) AND 
				([Expense].[DocumentID] = @DocumentID) AND 
				([Expense].[DocumentClass] = @DocumentClass)) 
				OR 
				((@UseTaskClass = 1) AND 
				([Expense].[TaskID] = @DocumentID))
			) AND
			(
				@ContactID IS NULL OR 
				([DocumentContact].[BusinessCardID] = @ContactID AND [DocumentContact].[BusinessCardClass] = @ContactClass)
			)

RETURN 0	
GO
	
GRANT EXECUTE ON [pjm7ExpenseForBudgetLineBrowseSelectorDialog] TO PUBLIC
GO

