IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5FolderCreateByCompany]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5FolderCreateByCompany'
		DROP PROCEDURE [dbo].[pjm5FolderCreateByCompany]
	END
GO

PRINT 'Creating procedure pjm5FolderCreateByCompany'
GO

/******************************************************************************
**		File: pjm5FolderCreateByCompany.sql
**		Name: pjm5FolderCreateByCompany
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 06/13/2006 16:59:46
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5FolderCreateByCompany]
	@CompanyID TIdentifier
AS
	SET NOCOUNT ON
	DECLARE 
		@ID TIdentifier,
		@State TState,
		@CaseState TState,
		@VersionControl TBool,
		@PublicationControl TBool,
		@Parameters xml,
		@UserID TIdentifier,
		@EmployeeID TIdentifier
	
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('CreateCompanyFolder')) = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	SET @State = dbo.adfwfGetInitialState('be2f5d0b-64aa-497f-b761-fff3e7394e02')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	SET @CaseState = dbo.adfwfGetInitialState('6043fc81-6f77-4e97-8a83-c4a60cd990f0')
	IF @CaseState IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
		
	SET @UserID = dbo.adfGetCurrentUserID()
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()

	IF EXISTS(SELECT * FROM [Folder] WHERE [CompanyID] = @CompanyID AND [FolderID] IS NULL)
	BEGIN
		RAISERROR('#companyfolderalreadyexists', 18, -1)
		RETURN 1
	END

	BEGIN TRANSACTION
	INSERT INTO [Folder]
		([State], [Flag], [CompanyID], [FolderID], [Code], [FileAs], [VersionControl], [PublicationControl], [Parameters])
	SELECT
		@State, 0, @CompanyID, NULL, 
		NULL, [Company].[FileAs], 
		1, 0, NULL
	FROM
		[Company]
	WHERE
		[ID] = @CompanyID
		
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	SET @ID = SCOPE_IDENTITY()

	INSERT INTO [FolderAccessControl] ([FolderID], [TrusteeID], [AccessRights]) VALUES(@ID, @UserID, 0x0028)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	INSERT INTO [CaseOfFolder] (FolderID, CaseID)
	SELECT
		[Folder].[ID], [Case].[ID]
	FROM
		[Folder]
		INNER JOIN [Case]
			ON [Case].[CompanyID] = [Folder].[CompanyID]
	WHERE
		[Case].[CompanyID] = @CompanyID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	COMMIT TRANSACTION
	RETURN 0
GO

GRANT EXECUTE ON pjm5FolderCreateByCompany TO PUBLIC
GO
 