IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5FolderGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5FolderGet'
		DROP PROCEDURE [dbo].[pjm5FolderGet]
	END
GO

PRINT 'Creating procedure pjm5FolderGet'
GO

/******************************************************************************
**		File: pjm5FolderGet.sql
**		Name: pjm5FolderGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 06/13/2006 16:59:46
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		27.06.11	SPV				Optimization
*******************************************************************************/
CREATE PROCEDURE [pjm5FolderGet]
	@ID TIdentifier,
	@Internal TBool = 0
AS
	SET NOCOUNT ON
	DECLARE @UserID TIdentifier
	SET @UserID = dbo.adfGetCurrentUserID()
	IF @Internal = 0
	BEGIN
		IF dbo.fnFolderHasRightAccess(@ID, @UserID, 'FolderVisible') != 1
		BEGIN
			RAISERROR('#accessdenied', 18, -1)
			RETURN 1
		END
	END
	
	DECLARE @Lang TLanguage
	SET @Lang = dbo.adfGetLanguage()

	SELECT
		[ID],
		[Class],
		[State],
		[Flag],
		[CompanyID],
		[Code],
		[FolderID],
		[SubfolderCount],
		[ItemCount],
		(
			SELECT
				COUNT(*)
			FROM
				[CaseOfFolder]
			 WHERE
				[CaseOfFolder].[FolderID] = [Folder].[ID] AND
				[CaseOfFolder].[CaseID] IN
				(
					SELECT [ID] FROM [Case] WHERE [State] = 1
				)
		) AS [CaseCount],
		CASE
			WHEN [ID] = 1 AND @Lang != 'ru' THEN 'Public Folders'
			ELSE [FileAs]
		END AS [FileAs],
		[VersionControl],
		[PublicationControl],
		[FileTemplate],
		[Parameters],
		[Created],
		[CreatedBy],
		[Modified],
		[ModifiedBy],
		CAST([Timestamp] AS bigint) AS [Timestamp]
	FROM
		[Folder]
	WHERE
		[Folder].[ID] = @ID
	IF @@ROWCOUNT = 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON [pjm5FolderGet] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6FolderGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6FolderGet'
		DROP PROCEDURE [dbo].[pjm6FolderGet]
	END
GO

PRINT 'Creating procedure pjm6FolderGet'
GO

/******************************************************************************
**		File: pjm6FolderGet.sql
**		Name: pjm6FolderGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 06/13/2006 16:59:46
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6FolderGet]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	IF dbo.adfHasAccessRight(dbo.adfGetRightID('AccessToPublicFolders')) = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	DECLARE @rv int
	EXEC @rv = pjm5FolderGet @ID, 0
	RETURN @rv
GO

GRANT EXECUTE ON [pjm6FolderGet] TO PUBLIC
GO

 