IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6FoldersCreateByCases]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6FoldersCreateByCases'
		DROP PROCEDURE [dbo].[pjm6FoldersCreateByCases]
	END
GO

PRINT 'Creating procedure pjm6FoldersCreateByCases'
GO


SET QUOTED_IDENTIFIER ON 
GO
/******************************************************************************
**		File: pjm6FoldersCreateByCases.sql
**		Name: pjm6FoldersCreateByCases
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 06/13/2006 16:59:46
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		27.06.11	SPV				Optimization
*******************************************************************************/
CREATE PROCEDURE [pjm6FoldersCreateByCases]
	@FolderID TIdentifier,
	@Year int,
	@Type int,
	@ResetNumbering TBool,
	@Xml xml
AS
	SET NOCOUNT ON
	DECLARE 
		@ID TIdentifier,
		@ID2 TIdentifier,
		@State TState,
		@FileAs TName,
		@CompanyID TIdentifier,
		@VersionControl TBool,
		@PublicationControl TBool,
		@Parameters xml,
		@UserID TIdentifier,
		@CaseID TIdentifier,
		@CaseFileAs TName
	
	SET @State = dbo.adfwfGetInitialState('be2f5d0b-64aa-497f-b761-fff3e7394e02')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
		
	SET @UserID = dbo.adfGetCurrentUserID()
	IF dbo.fnFolderHasRightAccess(@FolderID, @UserID, 'CreateSubfolder') = 0
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	SELECT 
		@CompanyID = [CompanyID],
		@VersionControl = [VersionControl],
		@PublicationControl = [PublicationControl],
		@Parameters = ISNULL([Parameters], CAST('<Parameters />' as xml))
	FROM 
		[Folder]
	WHERE 
		[ID] = @FolderID
	
	SET @FileAs = CAST(@Year as varchar(4))		

	DECLARE @ParentFolderID TIdentifier, @params XML, @params1 XML, @params2 XML
	SET @params1 = @Parameters
	SET @params1.modify('delete /Parameters/AllowClassFlag')
	SET @params1.modify('insert <AllowClassFlag>1</AllowClassFlag> into (/Parameters)[1]')
	SET @params1.modify('delete /Parameters/AllowFiles')
	SET @params1.modify('insert <AllowFiles>false</AllowFiles> into (/Parameters)[1]')

	SET @params2 = @Parameters
	SET @params2.modify('delete /Parameters/AllowClassFlag')
	SET @params2.modify('insert <AllowClassFlag>1</AllowClassFlag> into (/Parameters)[1]')
	SET @params2.modify('delete /Parameters/AllowFiles')
	SET @params2.modify('insert <AllowFiles>false</AllowFiles> into (/Parameters)[1]')
	
	DECLARE cases CURSOR FOR 
		SELECT 
			T.c.value('CaseID[1]', 'int'), 
			T.c.value('FileAs[1]', 'nvarchar(512)')
		FROM 
			@Xml.nodes('Cases/Case') T(c)

	BEGIN TRANSACTION
	IF @Type = 1
	BEGIN
		SELECT 
			@ParentFolderID = [ID]
		FROM
			[Folder]
		WHERE
			[FolderID] = @FolderID AND
			[FileAs] = CAST(@Year as varchar(4))
	END
	
	IF @Type = 1 AND @ParentFolderID IS NULL
	BEGIN
		INSERT INTO [Folder]
			([State], [Flag], [CompanyID], [FolderID], [FileAs], [VersionControl], [PublicationControl], [Parameters])
		VALUES
			(@State, 0, @CompanyID, @FolderID, @FileAs, @VersionControl, @PublicationControl, @params1)
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		SET @ParentFolderID = SCOPE_IDENTITY()

		INSERT INTO [FolderAccessControl] ([FolderID], [TrusteeID], [AccessRights])
		SELECT 
			@ParentFolderID, [TrusteeID], [AccessRights]
		FROM
			[FolderAccessControl]
		WHERE
			[FolderID] = @FolderID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		
		INSERT INTO [FolderNotificationSettings]
			([FolderID], [TrusteeID], [FolderSettings], [CardSettings], [FileSettings])
		SELECT
			@ParentFolderID, [TrusteeID], [FolderSettings], [CardSettings], [FileSettings]
		FROM
			[FolderNotificationSettings]
		WHERE
			[FolderNotificationSettings].[FolderID] = @FolderID
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		
		INSERT INTO [CaseOfFolder] ([FolderID], [CaseID], [Allowed], [MandatoryFields], [DefaultValues])
		SELECT
			@ParentFolderID, 
			[CaseOfFolder].[CaseID], 
			0, 
			[CaseOfFolder].[MandatoryFields],
			[CaseOfFolder].[DefaultValues]
		FROM
			[CaseOfFolder]
		WHERE
			[CaseOfFolder].[FolderID] = @FolderID AND
			[CaseOfFolder].[CaseID] IN
			(
				SELECT [ID] FROM [Case]
			)
		IF @@ERROR != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		
		EXEC pjm5FolderCreateSubfolderNotification @ParentFolderID
	END
	ELSE
	BEGIN
		SET @ParentFolderID = @FolderID
	END
	
	OPEN cases
	FETCH NEXT FROM cases INTO @CaseID, @CaseFileAs
	WHILE @@FETCH_STATUS = 0
	BEGIN
		IF @Type = 1 -- files are allowed
			SET @params = @params2
		ELSE
			SET @params = @params1
		SET @ID = NULL
		SELECT @ID = [ID] FROM [Folder] WHERE [FolderID] = @ParentFolderID AND [FileAs] = @CaseFileAs
		IF @ID IS NULL
		BEGIN
			INSERT INTO [Folder]
				([State], [Flag], [CompanyID], [FolderID], [FileAs], [VersionControl], [PublicationControl], [Parameters])
			VALUES
				(@State, 0, @CompanyID, @ParentFolderID, @CaseFileAs, @VersionControl, @PublicationControl, @params)
			IF @@ERROR != 0
			BEGIN
				CLOSE cases
				DEALLOCATE cases
				ROLLBACK TRANSACTION
				RETURN 1
			END
			SET @ID = SCOPE_IDENTITY()

			INSERT INTO [FolderAccessControl] ([FolderID], [TrusteeID], [AccessRights])
			SELECT 
				@ID, [TrusteeID], [AccessRights]
			FROM
				[FolderAccessControl]
			WHERE
				[FolderID] = @FolderID
			IF @@ERROR != 0
			BEGIN
				CLOSE cases
				DEALLOCATE cases
				ROLLBACK TRANSACTION
				RETURN 1
			END
			
			INSERT INTO [FolderNotificationSettings]
				([FolderID], [TrusteeID], [FolderSettings], [CardSettings], [FileSettings])
			SELECT
				@ID, [TrusteeID], [FolderSettings], [CardSettings], [FileSettings]
			FROM
				[FolderNotificationSettings]
			WHERE
				[FolderNotificationSettings].[FolderID] = @FolderID
			IF @@ERROR != 0
			BEGIN
				CLOSE cases
				DEALLOCATE cases
				ROLLBACK TRANSACTION
				RETURN 1
			END
			
			INSERT INTO [CaseOfFolder] ([FolderID], [CaseID], [Allowed], [MandatoryFields], [DefaultValues])
			SELECT
				@ID, 
				[CaseOfFolder].[CaseID], 
				CASE WHEN @Type = 1 AND [CaseOfFolder].[CaseID] = @CaseID THEN 1 ELSE 0 END, 
				[CaseOfFolder].[MandatoryFields], [CaseOfFolder].[DefaultValues]
			FROM
				[CaseOfFolder]
				INNER JOIN [Case]
					ON [Case].[ID] = [CaseOfFolder].[CaseID]
			WHERE
				[CaseOfFolder].[FolderID] = @FolderID
			IF @@ERROR != 0
			BEGIN
				CLOSE cases
				DEALLOCATE cases
				ROLLBACK TRANSACTION
				RETURN 1
			END

			EXEC pjm5FolderCreateSubfolderNotification @ID
		END
		
		IF @Type = 0
		BEGIN
			SET @ID2 = NULL
			SELECT @ID2 = [ID] FROM [Folder] WHERE [FolderID] = @ID AND [FileAs] = @FileAs
			IF @ID2 IS NULL
			BEGIN
				INSERT INTO [Folder]
					([State], [Flag], [CompanyID], [FolderID], [FileAs], [VersionControl], [PublicationControl], [Parameters])
				VALUES
					(@State, 0, @CompanyID, @ID, @FileAs, @VersionControl, @PublicationControl, @params2)
				IF @@ERROR != 0
				BEGIN
					CLOSE cases
					DEALLOCATE cases
					ROLLBACK TRANSACTION
					RETURN 1
				END
				SET @ID2 = SCOPE_IDENTITY()

				INSERT INTO [FolderAccessControl] ([FolderID], [TrusteeID], [AccessRights])
				SELECT 
					@ID2, [TrusteeID], [AccessRights]
				FROM
					[FolderAccessControl]
				WHERE
					[FolderID] = @FolderID
				IF @@ERROR != 0
				BEGIN
					CLOSE cases
					DEALLOCATE cases
					ROLLBACK TRANSACTION
					RETURN 1
				END
				
				INSERT INTO [FolderNotificationSettings]
					([FolderID], [TrusteeID], [FolderSettings], [CardSettings], [FileSettings])
				SELECT
					@ID2, [TrusteeID], [FolderSettings], [CardSettings], [FileSettings]
				FROM
					[FolderNotificationSettings]
				WHERE
					[FolderNotificationSettings].[FolderID] = @FolderID
				IF @@ERROR != 0
				BEGIN
					CLOSE cases
					DEALLOCATE cases
					ROLLBACK TRANSACTION
					RETURN 1
				END
				
				INSERT INTO [CaseOfFolder] ([FolderID], [CaseID], [Allowed], [MandatoryFields], [DefaultValues])
				SELECT
					@ID2, 
					[CaseOfFolder].[CaseID], 
					CASE WHEN [CaseOfFolder].[CaseID] = @CaseID THEN 1 ELSE 0 END, 
					[CaseOfFolder].[MandatoryFields], [CaseOfFolder].[DefaultValues]
				FROM
					[CaseOfFolder]
					INNER JOIN [Case]
						ON [Case].[ID] = [CaseOfFolder].[CaseID]
				WHERE
					[CaseOfFolder].[FolderID] = @FolderID
				IF @@ERROR != 0
				BEGIN
					CLOSE cases
					DEALLOCATE cases
					ROLLBACK TRANSACTION
					RETURN 1
				END
				EXEC pjm5FolderCreateSubfolderNotification @ID2
			END
		END
		
		IF @ResetNumbering = 1
		BEGIN
			UPDATE
				[Case]
			SET
				[CurrentNumber] = 1
			WHERE
				[ID] = @CaseID
			IF @@ERROR != 0
			BEGIN
				CLOSE cases
				DEALLOCATE cases
				ROLLBACK TRANSACTION
				RETURN 1
			END
		END
		FETCH NEXT FROM cases INTO @CaseID, @CaseFileAs
	END
	CLOSE cases
	DEALLOCATE cases

	COMMIT TRANSACTION
	--EXEC pjm5FolderGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm6FoldersCreateByCases TO PUBLIC
GO
 