IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5SearchFolderUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5SearchFolderUpdate'
		DROP PROCEDURE [dbo].[pjm5SearchFolderUpdate]
	END
GO

PRINT 'Creating procedure pjm5SearchFolderUpdate'
GO

/******************************************************************************
**		File: pjm5SearchFolderUpdate.sql
**		Name: pjm5SearchFolderUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 06/13/2006 16:59:46
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5SearchFolderUpdate]
	@ID TIdentifier OUTPUT,
	@FileAs TName,
	@Criteria XML
AS
	SET NOCOUNT ON
	DECLARE @UserID TIdentifier
	SET @UserID = dbo.adfGetCurrentUserID()
	IF EXISTS(SELECT * FROM [SearchFolder] WHERE [UserID] = @UserID AND [FileAs] = @FileAs AND [ID] != ISNULL(@ID, -1))
	BEGIN
		RAISERROR('#folderalreadyexists', 18, -1)
		RETURN 1
	END
	BEGIN TRANSACTION
	IF @ID IS NULL
	BEGIN
		INSERT INTO [SearchFolder] ([UserID], [FileAs], [Criteria]) VALUES (@UserID, @FileAs, @Criteria)
		IF @@error != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		SET @ID = SCOPE_IDENTITY()
	END
	ELSE
	BEGIN
		UPDATE 
			[SearchFolder]
		SET
			[FileAs] = @FileAs, 
			[Criteria] = @Criteria
		WHERE
			[ID] = @ID
		IF @@error != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	COMMIT TRANSACTION
	RETURN 0
GO

GRANT EXECUTE ON [pjm5SearchFolderUpdate] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5SearchFolderDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5SearchFolderDelete'
		DROP PROCEDURE [dbo].[pjm5SearchFolderDelete]
	END
GO

PRINT 'Creating procedure pjm5SearchFolderDelete'
GO

/******************************************************************************
**		File: pjm5SearchFolderDelete.sql
**		Name: pjm5SearchFolderDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 06/13/2006 16:59:46
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5SearchFolderDelete]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	DELETE FROM [SearchFolder] WHERE [ID] = @ID
	IF @@error != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON [pjm5SearchFolderDelete] TO PUBLIC
GO
