IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6AnnulPaymentByImport]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6AnnulPaymentByImport'
		DROP PROCEDURE [dbo].[pjm6AnnulPaymentByImport]
	END
GO

PRINT 'Creating procedure pjm6AnnulPaymentByImport'
GO

/******************************************************************************
**		File: pjm6AnnulPaymentByImport.sql
**		Name: pjm6AnnulPaymentByImport
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Pavel.Svintsov
**		Date: 02/19/2010 11:44:34
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		17.06.10	SPV				first version
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6AnnulPaymentByImport]
	@ID TIdentifier,
	@Flag int
AS
	DECLARE @PaymentID TIdentifier,
			@PaymentState smallint,
			@EmployeeID TIdentifier
	
	SET NOCOUNT ON
	
	
	
	SELECT
		@PaymentState = [Payment].[State]
	FROM
		[Payment]
	WHERE
		[Payment].[ID] = @ID
	
	IF @PaymentState = 3
	BEGIN
		EXEC adfPaymentChangeState @ID, 2
		SET @PaymentState = 2
	END
	
	UPDATE
		[Payment]
	SET
		[Payment].[Flag] = @Flag
	WHERE
		[Payment].[ID] = @ID
	
	
	IF @PaymentState IN (1, 2)
	BEGIN
		EXEC adfPaymentChangeState @ID, 4
	END
	
	RETURN 0
GO

GRANT EXECUTE ON [pjm6AnnulPaymentByImport] TO PUBLIC
GO