IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5IssueChangeState]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5IssueChangeState'
		DROP PROCEDURE [dbo].[pjm5IssueChangeState]
	END
GO

PRINT 'Creating procedure pjm5IssueChangeState'
GO

/******************************************************************************
**		File: pjm5IssueChangeState.sql
**		Name: pjm5IssueChangeState
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 03/18/2005 14:40:18
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    14.05.10		SYV				  pjm6DismissEventsOnObject    
**    24.08.10		SYV				  pjm6DismissEventsOnObject .. 
**									   
**	  08.05.2013	SAI				   
**									  
*******************************************************************************/
CREATE PROCEDURE pjm5IssueChangeState
	@ID TIdentifier,
	@ToState TState
AS
	SET NOCOUNT ON
	DECLARE @FromState TState,
			@TransitionTemplateID TIdentifier,
			@RightID TIdentifier,
			@Class TClass,
			@ProjectID TIdentifier,
			@ResolutionID TIdentifier,
			@ManHour TCount,
			@ActualManHour TCount,
			@rv int
	
	SELECT
		@Class = [Issue].[Class],
		@FromState = [Issue].[State],
		@ProjectID = [Issue].[ProjectID],
		@ResolutionID = [Issue].[ResolutionID],
		@ManHour = [Issue].[ManHour],
		@ActualManHour = [Issue].[ActualManHour]
	FROM
		[Issue]
	WHERE
		[Issue].[ID] = @ID
		
	IF @FromState = @ToState
	BEGIN
		RAISERROR('#invalidargument', 18, -1)
		RETURN 1
	END
	
	SELECT
		@TransitionTemplateID = [ID],
		@RightID = [RightID]
	FROM
		[TransitionTemplate]
	WHERE
		[TransitionTemplate].[FromState] = @FromState AND [TransitionTemplate].[ToState] = @ToState
	AND
		[TransitionTemplate].[Class] = @Class
		
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#invalidoperation', 18, -1)
		RETURN 1
	END
	
	SET @TransitionTemplateID = dbo.adfCheckTransitionRights(@TransitionTemplateID, @RightID, dbo.adfGetCurrentUserID())
	
	IF @TransitionTemplateID IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	DECLARE @ProjectState TState
	SELECT @ProjectState = [State] FROM [Project] WHERE [ID] = @ProjectID
	
	IF @FromState = 1 AND @ProjectState = 4 -- complete project
	BEGIN
		RAISERROR('#IssueChangeStateCompleteProject', 18, -1)
		RETURN 1
	END
		
	IF @ToState = 3
		SET @ResolutionID = NULL
		
	IF @ToState = 4 AND @ResolutionID IS NULL 
	BEGIN
		RAISERROR('#issueresolutionnotspecified', 18, -1)
		RETURN 1
	END
	/*
	IF @ToState = 4 AND @ManHour <> 0 AND @ActualManHour = 0 
	BEGIN
		RAISERROR('#issuefacttimenotspecified', 18, -1)
		RETURN 1
	END
	*/
	
	UPDATE [Issue]
	SET
		[Issue].[State] = @ToState,
		[Issue].[ResolutionID] = @ResolutionID,
		[Issue].[EndTime] = 
		CASE @ToState
			WHEN 4 THEN GETDATE()
			WHEN 5 THEN [Issue].[EndTime]
			ELSE NULL
		END,
		[Issue].[Modified] = DEFAULT,
		[Issue].[ModifiedBy] = DEFAULT
	WHERE
		[Issue].[ID] = @ID
	AND
		[Issue].[State] = @FromState

	IF @@ERROR != 0
		RETURN 1
	
	IF (@ToState = 5 OR @ToState = 4)
	BEGIN			
		EXEC @rv = pjm7AllDocumentReminderDismiss @Class, @ID
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN @rv
		END
	END
	IF(@ToState = 5)
	BEGIN
		DELETE [LastDocument]
		WHERE
			[LastDocument].[DocumentClass] = @Class
		AND
			[LastDocument].[DocumentID] = @ID
	END
	RETURN 0
GO

GRANT EXECUTE ON pjm5IssueChangeState TO PUBLIC
GO
 