IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5MeetingRequestSimpleUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5MeetingRequestSimpleUpdate'
		DROP PROCEDURE [dbo].[pjm5MeetingRequestSimpleUpdate]
	END
GO

PRINT 'Creating procedure pjm5MeetingRequestSimpleUpdate'
GO

/******************************************************************************
**		File: pjm5MeetingRequestSimpleUpdate.sql
**		Name: pjm5MeetingRequestSimpleUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 05/19/2006 12:50:39
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		18.04.13	SOV				. -   
*******************************************************************************/
CREATE PROCEDURE pjm5MeetingRequestSimpleUpdate
	@ID TIdentifier,
	@StartTime TDateTime,
	@EndTime TDateTime
AS
	
	DECLARE @CurrentEmployeeID TIdentifier, @CurrentUserID TIdentifier,
			@ProjectID TIdentifier, @IsManager TBool, @IsManagerAssistant TBool

	SET NOCOUNT ON
	
	SELECT 
		@ProjectID = [ProjectID] 
	FROM 
		[MeetingRequest] 
	WHERE 
		[ID]=@ID

	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @CurrentUserID = dbo.adfGetCurrentUserID()
	SET @IsManager = dbo.fnPjm5IsProjectManager(@ProjectID, @CurrentEmployeeID)
	SET @IsManagerAssistant = dbo.fnPjm7IsManagerAssistant(@ProjectID, @CurrentEmployeeID)

	IF @CurrentEmployeeID NOT IN (SELECT [OriginatorEmployeeID] FROM [MeetingRequest] WHERE [ID] = @ID)	AND
		@IsManager = 0 AND @IsManagerAssistant = 0
	BEGIN
		RAISERROR('#accessdenied', 16, -1)
		RETURN 1
	END
	
	BEGIN TRANSACTION
	
	UPDATE [MeetingRequest]
	SET
		[StartTime] = @StartTime,
		[Duration] = DATEDIFF(minute, @StartTime, @EndTime),
		[Modified] = DEFAULT,
		[ModifiedBy] = DEFAULT
	WHERE
		[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	DECLARE @State TState
	SET @State = (SELECT [State] FROM [MeetingRequest] WHERE [ID] = @ID)
	
	IF @State = 2
		UPDATE [MeetingRequest] SET [SendUpdate] = 1 WHERE [ID] = @ID

	DECLARE @ReminderState TState, @ReminderInterval TTimeSpan, @result INT
	

	SELECT 
		@ReminderState = ISNULL([UserReminder].[State], CAST(0 as int)),
		@ReminderInterval = ISNULL([UserReminder].[OriginalInterval], dbo.fnPjm5GetReminderInterval([MeetingRequest].[Class], 'MS', @CurrentUserID))
	FROM
		[MeetingRequest] LEFT OUTER JOIN [Reminder]
			ON ([Reminder].[DocumentClass] = [MeetingRequest].[Class] AND
				[Reminder].[DocumentID] = [MeetingRequest].[ID] AND
				[Reminder].[Subtype] = 'MS')
		LEFT OUTER JOIN [UserReminder]
			ON ([Reminder].[ID] = [UserReminder].[ReminderID] AND
				[UserReminder].[UserID] = @CurrentUserID)
	WHERE
		[MeetingRequest].[ID] = @ID
	
	EXEC @result = pjm7MeetingRequestReminderCreate @ID, @StartTime, @ReminderState, @ReminderInterval
	IF @result != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	COMMIT TRANSACTION

	EXEC pjm5MeetingRequestGet @ID

	RETURN 0
GO

 