IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'pjm7IsSyncSetByOriginator')
	BEGIN
		PRINT 'Dropping Procedure pjm7IsSyncSetByOriginator'
		DROP  Procedure  pjm7IsSyncSetByOriginator
	END
GO

PRINT 'Creating Procedure pjm7IsSyncSetByOriginator'
GO
/******************************************************************************
**		File: pjm7IsSyncSetByOriginator.sql
**		Name: pjm7IsSyncSetByOriginator
**		Desc: 
**              
**		Auth: SAP
**		Date: 26.07.13
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
*******************************************************************************/
CREATE PROCEDURE pjm7IsSyncSetByOriginator
	@MeetingRequestID int
	
AS
	DECLARE
		@MeetingRequestClass int = [dbo].[adfGetClassByName]('Pjm5.MeetingRequest'),		
		@OriginatorEmployeeID int,
		@SyncIsSetByOriginator bit

	SELECT
		@OriginatorEmployeeID = [MeetingRequest].[OriginatorEmployeeID]
	FROM
		[MeetingRequest]
	WHERE
		[MeetingRequest].[ID] = @MeetingRequestID
		
	
	DECLARE @t TABLE
	(
		EmployeeID int
	)
	
	INSERT INTO @t
	SELECT
		[Employee].[ID]	
	FROM
		[ExchangeDocumentSync]
			INNER JOIN [Employee]
				ON [Employee].[UserID] = [ExchangeDocumentSync].[UserID]
	WHERE
		[ExchangeDocumentSync].[DocumentClass] = @MeetingRequestClass
		AND
		[ExchangeDocumentSync].[DocumentID] = @MeetingRequestID

	IF EXISTS(SELECT * FROM @t WHERE [@t].[EmployeeID] = @OriginatorEmployeeID)
		SET @SyncIsSetByOriginator = 1
	ELSE
		SET @SyncIsSetByOriginator = 0

	SELECT
		@SyncIsSetByOriginator AS SyncIsSetByOriginator		
	
GO

GRANT EXEC ON pjm7IsSyncSetByOriginator TO PUBLIC
GO
