 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6MsResourceDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6MsResourceDelete'
		DROP PROCEDURE [dbo].[pjm6MsResourceDelete]
	END
GO

PRINT 'Creating procedure pjm6MsResourceDelete'
GO


CREATE PROCEDURE [pjm6MsResourceDelete] @ID TIdentifier
AS
	
	SET NOCOUNT ON

	DECLARE @AssignmentID TIdentifier,
			@ProjectState TState,
			@TaskID TIdentifier,
			@MsAssignmentID TIdentifier,
			@rv TVariant
			
	SELECT 
		@AssignmentID = [Assignment].[ID], 
		@ProjectState = [Project].[State]
	FROM
		[Assignment]
			INNER JOIN [Project]
				ON [Project].[ID] = [Assignment].[ProjectID]
	WHERE [Assignment].[MsResourceID] = @ID

	BEGIN TRANSACTION;
	
	DECLARE msAssignmentCursor CURSOR READ_ONLY FAST_FORWARD LOCAL FOR
		SELECT
			[MsAssignment].[ID]
		FROM
			[MsAssignment]
		WHERE
			[MsAssignment].[ResourceID] = @ID
			
	OPEN msAssignmentCursor
	FETCH NEXT FROM msAssignmentCursor INTO @MsAssignmentID
	
	WHILE @@FETCH_STATUS = 0
	BEGIN
		exec @rv = pjm6MsAssignmentDelete @MsAssignmentID
		IF @rv !=0
		BEGIN
			ROLLBACK TRANSACTION
			CLOSE msAssignmentCursor
			DEALLOCATE msAssignmentCursor
			RETURN 1
		END
	FETCH NEXT FROM msAssignmentCursor INTO @MsAssignmentID
	END
	CLOSE msAssignmentCursor
	DEALLOCATE msAssignmentCursor

	IF(@ProjectState = 1)
	BEGIN
		DELETE [Assignment] WHERE [MsResourceID] = @ID
		IF @@ERROR !=0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		
		DELETE [MsResource] WHERE [ID] = @ID
		IF @@ERROR !=0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	ELSE
	BEGIN
		UPDATE [Assignment]
		SET
			[Assignment].[State] = 2
		WHERE
			[Assignment].[MsResourceID] = @ID
			
		EXEC pjm6DeactivateTaskAssignments @AssignmentID
		
		IF @@ERROR !=0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
		UPDATE [TaskAssignment]
		SET [MsAvailable] = 0
		WHERE [TaskAssignment].[AssignmentID] = @AssignmentID 
	END
	COMMIT TRANSACTION;

RETURN 0
GO

GRANT EXECUTE ON [pjm6MsResourceDelete] TO PUBLIC
GO
  