IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm7NormCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm7NormCreate'
		DROP PROCEDURE [dbo].[pjm7NormCreate]
	END
GO

PRINT 'Creating procedure pjm7NormCreate'
GO

/******************************************************************************
**		File: pjm7NormCreate.sql
**		Name: pjm7NormCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Avgusta.Bekhtina
**		Date: 19/06/2014 12:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [dbo].[pjm7NormCreate]
		@Xml XML
AS
	DECLARE @State TState,
			@ID TIdentifier,
			@Code TCode,
			@FileAs TName,
			@Comments TNotes
	
	SET NOCOUNT ON
	
	SET @State = dbo.adfwfGetInitialState('a3262796-9a6b-4048-b08f-284c9420d1ad')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	SELECT
		@FileAs = T.c.value('FileAs[1]','nvarchar(256)'),
		@Code = T.c.value('Code[1]','varchar(32)'),
		@Comments = T.c.value('Comments[1]','nvarchar(max)')
	FROM
		@Xml.nodes('/pjm7NormGet/Norm') AS T(c)

	BEGIN TRANSACTION

	INSERT INTO [Norm]
		([Flag], [State], [Code], [FileAs], [Comments])
	VALUES
		(0, @State, @Code, @FileAs, @Comments)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()

	INSERT INTO [NormValue]
		([NormID], [Year], [UtilizationHours], [RealizationHours], [Revenue])
	SELECT
		@ID,
		T.c.value('Year[1]','varchar(4)') AS [Year],
		T.c.value('UtilizationHours[1]','int') AS [UtilizationHours],
		T.c.value('RealizationHours[1]','int') AS [RealizationHours],
		T.c.value('Revenue[1]','money') AS [Revenue]
	FROM
		@Xml.nodes('/pjm7NormGet/NormValue') AS T(c)

	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	COMMIT TRANSACTION

	EXEC pjm7NormGet @ID

	RETURN 0
GO

GRANT EXECUTE ON [pjm7NormCreate] TO PUBLIC
GO
