IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm7MeetingRequestReminderCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm7MeetingRequestReminderCreate'
		DROP PROCEDURE [dbo].[pjm7MeetingRequestReminderCreate]
	END
GO

PRINT 'Creating procedure pjm7MeetingRequestReminderCreate'
GO

/******************************************************************************
**		File: pjm7MeetingRequestReminderCreate.sql
**		Name: pjm7MeetingRequestReminderCreate
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 28.04.2012 13:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm7MeetingRequestReminderCreate]
	@DocumentID TIdentifier,
	@ReminderEventTime TDateTime,
	@ReminderState TState,
	@ReminderInterval TTimeSpan
AS
	SET NOCOUNT ON
	
	DECLARE
		@CurrentUserID			TIdentifier,
		@DocumentClass			TClass,
		@ReminderDescription	TName,
		@Lang					TLanguage,
		@rv						int
	
	SET @Lang = dbo.adfGetLanguage()
		
	SELECT
		@CurrentUserID = dbo.adfGetCurrentUserID(),
		@DocumentClass = dbo.adfGetClassByName('Pjm5.MeetingRequest')
	
	SELECT 
		@ReminderDescription = [Description] 
	FROM 
		[ReminderDescription] 
	WHERE 
		[Subtype] = 'MS'
		AND
		[Language] = @Lang

	EXEC @rv = dbo.pjm7ReminderForUserCreate	@DocumentClass,
												@DocumentID,
												@CurrentUserID,
												'MS',
												@ReminderEventTime,
												@ReminderState,
												@ReminderInterval,
												@ReminderDescription,
												1
	IF @rv != 0
	BEGIN
		RETURN @rv
	END
	
	IF @ReminderEventTime > GETDATE()
	BEGIN
		EXEC @rv = dbo.pjm7MeetingDocumentUserReminderCreate	@DocumentClass,
																@DocumentID,
																@ReminderEventTime,
																@ReminderState,
																@ReminderInterval
		IF @rv != 0
		BEGIN
			RETURN @rv
		END
	END
	
	RETURN 0
GO

GRANT EXECUTE ON [pjm7MeetingRequestReminderCreate] TO PUBLIC
GO  