﻿IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm7ReminderForUserCreateInternal]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm7ReminderForUserCreateInternal'
		DROP PROCEDURE [dbo].[pjm7ReminderForUserCreateInternal]
	END
GO

PRINT 'Creating procedure pjm7ReminderForUserCreateInternal'
GO

/******************************************************************************
**		File: pjm7ReminderForUserCreateInternal.sql
**		Name: pjm7ReminderForUserCreateInternal
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 12.04.2012 18:10:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm7ReminderForUserCreateInternal]
	@ID TIdentifier OUTPUT,
	@DocumentClass TClass,
	@DocumentID TIdentifier,
	@ReminderSubtype TCode2,
	@ReminderEventTime TDateTime
AS
	SET NOCOUNT ON
	
	IF @DocumentClass IS NULL OR @DocumentID IS NULL
	BEGIN
		RETURN 1
	END
	
	SET @ID = NULL
	
	SELECT @ID = [ID]
	FROM [Reminder]
	WHERE 
		[DocumentClass] = @DocumentClass AND [DocumentID] = @DocumentID AND
		[Subtype] = @ReminderSubtype
	
	IF @ID IS NULL OR @ReminderSubtype = 'UR'
	BEGIN
		INSERT INTO [Reminder] ([DocumentClass], [DocumentID], [Subtype], [EventTime])
		VALUES (@DocumentClass, @DocumentID, @ReminderSubtype, @ReminderEventTime)
		IF @@ERROR != 0
		BEGIN
			RETURN 1
		END
		SET @ID = SCOPE_IDENTITY()
	END
	ELSE IF @ID IS NOT NULL AND @ReminderSubtype != 'UR'
	BEGIN
		UPDATE [Reminder] 
		SET 
			[EventTime] = @ReminderEventTime,
			[Modified] = DEFAULT
		WHERE [ID] = @ID
		IF @@ERROR != 0
		BEGIN
			RETURN 1
		END
	END
	
	RETURN 0
GO

GRANT EXECUTE ON [pjm7ReminderForUserCreateInternal] TO PUBLIC
GO