IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm7ReminderUserSettingsGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm7ReminderUserSettingsGet'
		DROP PROCEDURE [dbo].[pjm7ReminderUserSettingsGet]
	END
GO

PRINT 'Creating procedure pjm7ReminderUserSettingsGet'
GO

/******************************************************************************
**		File: pjm7ReminderUserSettingsGet.sql
**		Name: pjm7ReminderUserSettingsGet
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 20/12/2005 13:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm7ReminderUserSettingsGet]
AS
	SET NOCOUNT ON
	
	DECLARE @UserID TIdentifier
	SET @UserID = dbo.adfGetCurrentUserID()
	
	SELECT 
		[ReminderType].[Class] AS [Class],
		ISNULL([ReminderSetting].[Subtype], [ReminderType].[Subtype]) AS [Subtype],
		ISNULL([ReminderSetting].[InitialState],[ReminderType].[DefaultState]) AS [InitialState],
		ISNULL([ReminderSetting].[InitialInterval], [ReminderType].[DefaultInterval]) AS [InitialInterval]
	FROM
		[ReminderType]
		Left outer JOIN [ReminderSetting] 
			ON [ReminderType].[Subtype] = [ReminderSetting].[Subtype] AND [UserID] = @UserID
	
	RETURN 0
GO

GRANT EXECUTE ON [pjm7ReminderUserSettingsGet] TO PUBLIC
GO   