IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm7TaskRequestReminderCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm7TaskRequestReminderCreate'
		DROP PROCEDURE [dbo].[pjm7TaskRequestReminderCreate]
	END
GO

PRINT 'Creating procedure pjm7TaskRequestReminderCreate'
GO

/******************************************************************************
**		File: pjm7TaskRequestReminderCreate.sql
**		Name: pjm7TaskRequestReminderCreate
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 28.04.2012 14:45:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm7TaskRequestReminderCreate]
	@DocumentID TIdentifier,
	@ReminderEventTime TDateTime,
	@ReminderState TState,
	@ReminderInterval TTimeSpan
AS
	SET NOCOUNT ON
	
	DECLARE
		@CurrentUserID			TIdentifier,
		@DocumentClass			TClass,
		@ReminderDescription	TName,
		@Lang					TLanguage,
		@rv						int
	
	SET @Lang = dbo.adfGetLanguage()	
	SELECT
		@CurrentUserID = dbo.adfGetCurrentUserID(),
		@DocumentClass = dbo.adfGetClassByName('Pjm5.TaskRequest')
	
	SELECT 
		@ReminderDescription = [Description] 
	FROM 
		[ReminderDescription] 
	WHERE 
		[Subtype] = 'RD'
		AND
		[Language] = @Lang

	EXEC @rv = dbo.pjm7ReminderForUserCreate	@DocumentClass,
												@DocumentID,
												@CurrentUserID,
												'RD',
												@ReminderEventTime,
												@ReminderState,
												@ReminderInterval,
												@ReminderDescription,
												1
	IF @rv != 0
	BEGIN
		RETURN @rv
	END

	EXEC @rv = dbo.pjm7DocumentUserReminderCreate	@DocumentClass,
													@DocumentID,
													@ReminderEventTime
	IF @rv != 0
	BEGIN
		RETURN @rv
	END
	
	EXEC @rv = dbo.pjm7DocumentSupervisorReminderCreate		@DocumentClass,
															@DocumentID,
															'RD',
															@ReminderDescription,
															@ReminderEventTime
	IF @rv != 0
	BEGIN
		RETURN @rv
	END
	
	RETURN 0
GO

GRANT EXECUTE ON [pjm7TaskRequestReminderCreate] TO PUBLIC
GO  