if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[fnPjm5GetExternalSubscription]') and xtype in (N'FN', N'IF', N'TF'))
drop function [dbo].[fnPjm5GetExternalSubscription]
go

create function fnPjm5GetExternalSubscription
(@DocumentClass TClass, @DocumentID TIdentifier, @SubscriptionCode TCode)
returns bit
as
begin
	DECLARE @res bit, @SubscriptionTypeID TIdentifier
	SET @res = 0
	SELECT @SubscriptionTypeID = dbo.fnPjm5GetSubscriptionTypeByCode(@SubscriptionCode)
	IF EXISTS (
		SELECT *
		FROM
			[DocumentSubscriptionRule]
			INNER JOIN [SubscriptionRule]
				ON [DocumentSubscriptionRule].[SubscriptionRuleID] = [SubscriptionRule].[ID]
			INNER JOIN [Subscription]
				ON [Subscription].[SubscriptionRuleID] = [SubscriptionRule].[ID]
			INNER JOIN [SubscriptionType]
				ON [Subscription].[SubscriptionTypeID] = [SubscriptionType].[ID]
		WHERE
			[DocumentSubscriptionRule].[DocumentClass] = @DocumentClass AND
			[DocumentSubscriptionRule].[DocumentID] = @DocumentID AND
			[SubscriptionRule].[ExternalInitiator] = 1 AND
			[SubscriptionType].[ID] = @SubscriptionTypeID AND
			[SubscriptionType].[ExternalInitiator] = 1
	)
	BEGIN
		SET @res = 1
	END
	RETURN @res
end
go

grant execute on [dbo].[fnPjm5GetExternalSubscription] to [public]
go   