IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5EventDismiss]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5EventDismiss'
		DROP PROCEDURE [dbo].[pjm5EventDismiss]
	END
GO

PRINT 'Creating procedure pjm5EventDismiss'
GO

/******************************************************************************
**		File: pjm5EventDismiss.sql
**		Name: pjm5EventDismiss
**		Desc: 
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 20/12/2005 13:00:00
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5EventDismiss]
	@EventID TIdentifier
AS
	SET NOCOUNT ON
	
	UPDATE [Event]
	SET [State] = dbo.fnPjm5GetDismissEventState()
	WHERE
		[ID] = @EventID
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END
	
	RETURN 0
GO

GRANT EXECUTE ON [pjm5EventDismiss] TO PUBLIC
GO


IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5MakeEventAlerted]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5MakeEventAlerted'
		DROP PROCEDURE [dbo].[pjm5MakeEventAlerted]
	END
GO

PRINT 'Creating procedure pjm5MakeEventAlerted'
GO

CREATE PROCEDURE [pjm5MakeEventAlerted]
	@EventID TIdentifier
AS
	SET NOCOUNT ON
	
	DECLARE @DismissState TState
	SET @DismissState = dbo.fnPjm5GetDismissEventState()
	
	UPDATE [Event]
	SET [State] = CASE WHEN [State] = @DismissState THEN @DismissState
					ELSE dbo.fnPjm5GetAlertedEventState() END
	WHERE
		[ID] = @EventID
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END
	
	RETURN 0
GO

GRANT EXECUTE ON [pjm5MakeEventAlerted] TO PUBLIC
GO