IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5PaymentLineAppend]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5PaymentLineAppend'
		DROP PROCEDURE [dbo].[pjm5PaymentLineAppend]
	END
GO

PRINT 'Creating procedure pjm5PaymentLineAppend'
GO

/******************************************************************************
**		File: pjm5PaymentLineAppend.sql
**		Name: pjm5PaymentLineAppend
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 01/21/2005 17:11:09
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5PaymentLineAppend]
	@PaymentID TIdentifier,
	@InvoiceID TIdentifier,
	@PaymentValue TMoney,
	@PaymentVAT TMoney,
	@CurrencyRate TAmount,
	@Value TMoney,
	@VAT TMoney,
	@Description TDescription 
	
AS
	SET NOCOUNT ON
	DECLARE
		@PValue TMoney,
		@PVAT TMoney,
		@PValueSum TMoney,
		@PVATSum TMoney,
		@PState TState,
		@InvoiceValue TMoney,
		@InvoiceVAT TMoney,
		@ProjectCurrencyCode TCode3,
		@InvoiceCurrencyRate TMoney,
		@InvoicePaymentCurrencyPoint TIdentifier,
		@ValueSum TMoney,
		@VATSum TMoney,
		@IState TState,
		@rv int
		
	SELECT
		@InvoiceValue = [Invoice].[TotalWithVAT],
		@InvoiceVAT = [Invoice].[VAT],
		@IState = [Invoice].[State],
		@InvoiceCurrencyRate = [Invoice].[CurrencyRate],
		@InvoicePaymentCurrencyPoint = [Invoice].[PaymentCurrencyPoint],
		@ProjectCurrencyCode = [Project].[CurrencyCode]
	FROM
		[Invoice]
		INNER JOIN [Project]
			ON [Project].[ID] = [Invoice].[ProjectID]
	WHERE
		[Invoice].[ID] = @InvoiceID

	SELECT 
		@InvoiceValue = @InvoiceValue - ISNULL(SUM([PaymentDetail].[PaymentValue]), 0),
		@InvoiceVAT = @InvoiceVAT - ISNULL(SUM([PaymentDetail].[PaymentVAT]), 0)
	FROM
		[PaymentDetail]
		INNER JOIN [Payment]
			ON [Payment].[ID] = [PaymentDetail].[PaymentID]
	WHERE
		[PaymentDetail].[InvoiceID] = @InvoiceID AND
		[Payment].[State] IN (2, 3)
		
	SELECT
		@InvoiceValue = @InvoiceValue - ISNULL(SUM([Invoice].[TotalWithVAT]), 0.0),
		@InvoiceVAT = @InvoiceVAT - ISNULL(SUM([Invoice].[VAT]), 0.0)
	FROM
		[AdvanceInvoice] 
		INNER JOIN [Invoice]
			ON [Invoice].[ID] = [AdvanceInvoice].[AdvanceInvoiceID]
	WHERE
		[AdvanceInvoice].[InvoiceID] = @InvoiceID

	SELECT
		@PValue = [Value],
		@PVAT = [VAT],
		@PState = [State]
	FROM
		[Payment]
	WHERE
		[ID] = @PaymentID

	DECLARE 
		@NationalCurrencyCode TCode3,
		@val TVariant
	
	EXEC adfParameterGet 'NationalCurrency', 'CommonBusiness', @val OUTPUT	
	SET @NationalCurrencyCode = CAST(@val AS varchar(3))

	BEGIN TRANSACTION
	
	INSERT INTO [PaymentDetail]
		(
		[PaymentID],
		[InvoiceID],
		[PaymentValue],
		[PaymentVAT],
		[CurrencyRate],
		[Value],
		[VAT],
		[Description]
		)
	VALUES
		(
		@PaymentID,
		@InvoiceID,
		@PaymentValue,
		@PaymentVAT,
		@CurrencyRate,
		@Value,
		@VAT,
		@Description
		)
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	SELECT
		@ValueSum = SUM([PaymentValue]), @VATSum = SUM([PaymentVAT])
	FROM
		[PaymentDetail]
	WHERE
		[InvoiceID] = @InvoiceID
	
	SELECT
		@PValueSum = SUM([PaymentValue]), @PVATSum = SUM([PaymentVAT])
	FROM
		[PaymentDetail]
	WHERE
		[PaymentID] = @PaymentID

	IF @PState != 3 AND ROUND(@PValueSum, 2) = ROUND(@PValue, 2) AND ROUND(@PVATSum, 2) = ROUND(@PVAT, 2)
	BEGIN
		EXEC @rv = adfPaymentChangeState @PaymentID, 3
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	COMMIT TRANSACTION
	RETURN 0
GO

GRANT EXECUTE ON pjm5PaymentLineAppend TO PUBLIC
GO
 
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5PaymentLineUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5PaymentLineUpdate'
		DROP PROCEDURE [dbo].[pjm5PaymentLineUpdate]
	END
GO

PRINT 'Creating procedure pjm5PaymentLineUpdate'
GO

/******************************************************************************
**		File: pjm5PaymentLineUpdate.sql
**		Name: pjm5PaymentLineUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 01/21/2005 17:11:09
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5PaymentLineUpdate]
	@ID TIdentifier,
	@PaymentID TIdentifier,
	@InvoiceID TIdentifier,
	@PaymentValue TMoney,
	@PaymentVAT TMoney,
	@CurrencyRate TAmount,
	@Value TMoney,
	@VAT TMoney,
	@Description TDescription 
	
AS
	SET NOCOUNT ON
	DECLARE
		@PValue TMoney,
		@PVAT TMoney,
		@PValueSum TMoney,
		@PVATSum TMoney,
		@PState TState,
		@InvoiceValue TMoney,
		@InvoiceVAT TMoney,
		@ProjectCurrencyCode TCode3,
		@InvoiceCurrencyRate TMoney,
		@InvoicePaymentCurrencyPoint TIdentifier,
		@ValueSum TMoney,
		@VATSum TMoney,
		@IState TState,
		@rv int
		
	SELECT @PaymentID = [PaymentID], @InvoiceID = [InvoiceID] FROM [PaymentDetail] WHERE [ID] = @ID
	SELECT
		@InvoiceValue = [Invoice].[TotalWithVAT],
		@InvoiceVAT = [Invoice].[VAT],
		@IState = [Invoice].[State],
		@InvoiceCurrencyRate = [Invoice].[CurrencyRate],
		@InvoicePaymentCurrencyPoint = [Invoice].[PaymentCurrencyPoint],
		@ProjectCurrencyCode = [Project].[CurrencyCode]
	FROM
		[Invoice]
		INNER JOIN [Project]
			ON [Project].[ID] = [Invoice].[ProjectID]
	WHERE
		[Invoice].[ID] = @InvoiceID

	SELECT 
		@InvoiceValue = @InvoiceValue - ISNULL(SUM([PaymentDetail].[PaymentValue]), 0),
		@InvoiceVAT = @InvoiceVAT - ISNULL(SUM([PaymentDetail].[PaymentVAT]), 0)
	FROM
		[PaymentDetail]
		INNER JOIN [Payment]
			ON [Payment].[ID] = [PaymentDetail].[PaymentID]
	WHERE
		[PaymentDetail].[InvoiceID] = @InvoiceID AND
		[PaymentDetail].[ID] != @ID AND
		[Payment].[State] IN (2, 3)
		
	SELECT
		@InvoiceValue = @InvoiceValue - ISNULL(SUM([Invoice].[TotalWithVAT]), 0.0),
		@InvoiceVAT = @InvoiceVAT - ISNULL(SUM([Invoice].[VAT]), 0.0)
	FROM
		[AdvanceInvoice] 
		INNER JOIN [Invoice]
			ON [Invoice].[ID] = [AdvanceInvoice].[AdvanceInvoiceID]
	WHERE
		[AdvanceInvoice].[InvoiceID] = @InvoiceID
		
	SELECT
		@PValue = [Value],
		@PVAT = [VAT],
		@PState = [State]
	FROM
		[Payment]
	WHERE
		[ID] = @PaymentID

	DECLARE 
		@NationalCurrencyCode TCode3,
		@val TVariant
		
	EXEC adfParameterGet 'NationalCurrency', 'CommonBusiness', @val OUTPUT	
	SET @NationalCurrencyCode = CAST(@val AS varchar(3))

	BEGIN TRANSACTION
	UPDATE
		[PaymentDetail]
	SET 
		[PaymentValue] = @PaymentValue,
		[PaymentVAT] = @PaymentVAT,
		[CurrencyRate] = @CurrencyRate,
		[Value] = @Value,
		[VAT] = @VAT,
		[Description] = @Description
	WHERE
		[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	SELECT
		@ValueSum = SUM([Value]), @VATSum = SUM([VAT])
	FROM
		[PaymentDetail]
	WHERE
		[InvoiceID] = @InvoiceID
	
	SELECT
		@PValueSum = SUM([PaymentValue]), @PVATSum = SUM([PaymentVAT])
	FROM
		[PaymentDetail]
	WHERE
		[PaymentID] = @PaymentID

	IF @PState = 3 AND (ROUND(@PValueSum, 2) != ROUND(@PValue, 2) OR ROUND(@PVATSum, 2) != ROUND(@PVAT, 2))
	BEGIN
		EXEC @rv = adfPaymentChangeState @PaymentID, 2
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	ELSE IF @PState != 3 AND ROUND(@PValueSum, 2) = ROUND(@PValue, 2) AND ROUND(@PVATSum, 2) = ROUND(@PVAT, 2)
	BEGIN
		EXEC @rv = adfPaymentChangeState @PaymentID, 3
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END

	COMMIT TRANSACTION
	RETURN 0
GO

GRANT EXECUTE ON pjm5PaymentLineUpdate TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5PaymentLineDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5PaymentLineDelete'
		DROP PROCEDURE [dbo].[pjm5PaymentLineDelete]
	END
GO

PRINT 'Creating procedure pjm5PaymentLineDelete'
GO

/******************************************************************************
**		File: pjm5PaymentLineDelete.sql
**		Name: pjm5PaymentLineDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: 
**		Date: 01/21/2005 17:11:09
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5PaymentLineDelete]
	@ID TIdentifier
AS
	SET NOCOUNT ON
	DECLARE
		@PaymentID TIdentifier,
		@InvoiceID TIdentifier,
		@PValue TMoney,
		@PVAT TMoney,
		@PValueSum TMoney,
		@PVATSum TMoney,
		@PState TState,
		@InvoiceValue TMoney,
		@InvoiceVAT TMoney,
		@ValueSum TMoney,
		@VATSum TMoney,
		@IState TState,
		@rv int
		
	SELECT @PaymentID = [PaymentID], @InvoiceID = [InvoiceID] FROM [PaymentDetail] WHERE [ID] = @ID
	SELECT
		@InvoiceValue = SUM(
			CASE
				WHEN [InvoiceLine].[VATIsIncluded] = 1
					THEN [InvoiceLine].[Amount] * [InvoiceLine].[Price]
				ELSE [InvoiceLine].[Amount] * [InvoiceLine].[Price] + [InvoiceLine].[VAT]
			END),
		@InvoiceVAT = SUM([InvoiceLine].[VAT]),
		@IState = [Invoice].[State]
	FROM
		[Invoice]
		INNER JOIN [InvoiceLine]
			ON [InvoiceLine].[InvoiceID] = [Invoice].[ID]
	WHERE
		[Invoice].[ID] = @InvoiceID
	GROUP BY
		[Invoice].[State]
		
	SELECT
		@PValue = [Value],
		@PVAT = [VAT],
		@PState = [State]
	FROM
		[Payment]
	WHERE
		[ID] = @PaymentID

	BEGIN TRANSACTION
	DELETE 
		[PaymentDetail]
	WHERE
		[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	SELECT
		@ValueSum = SUM([Value]), @VATSum = SUM([VAT])
	FROM
		[PaymentDetail]
	WHERE
		[InvoiceID] = @InvoiceID
	
	SELECT
		@PValueSum = SUM([PaymentValue]), @PVATSum = SUM([PaymentVAT])
	FROM
		[PaymentDetail]
	WHERE
		[PaymentID] = @PaymentID

	IF @PState = 3 AND (ROUND(@PValueSum, 2) != ROUND(@PValue, 2) OR ROUND(@PVATSum, 2) != ROUND(@PVAT, 2))
	BEGIN
		EXEC @rv = adfPaymentChangeState @PaymentID, 2
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN 1
		END
	END
	COMMIT TRANSACTION
	RETURN 0
GO

GRANT EXECUTE ON pjm5PaymentLineDelete TO PUBLIC
GO
