IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'UpdateContactLink')
	BEGIN
		PRINT 'Dropping Procedure UpdateContactLink'
		DROP  Procedure  UpdateContactLink
	END

GO

IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'UpdateExternalLink')
	BEGIN
		PRINT 'Dropping Procedure UpdateExternalLink'
		DROP  Procedure  UpdateExternalLink
	END

GO


IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'PjmSyncUpdateExternalLink')
	BEGIN
		PRINT 'Dropping Procedure PjmSyncUpdateExternalLink'
		DROP  Procedure  PjmSyncUpdateExternalLink
	END

GO

PRINT 'Creating Procedure PjmSyncUpdateExternalLink'
GO

--------------------------------------------------------------------------------------
CREATE Procedure PjmSyncUpdateExternalLink
	@DeviceID varchar(40),
	@ItemID varchar(32),
	@DocumentClass smallint,
	@DocumentID int

AS
	SET NOCOUNT ON
	
	IF @DocumentID IS NULL 
	BEGIN
		DELETE [ExternalLink] WHERE  [DeviceID] = @DeviceID AND [ItemID] = @ItemID
	END
	ELSE IF EXISTS(SELECT * FROM [ExternalLink] WHERE [DeviceID]=@DeviceID AND 
		[DocumentClass] = @DocumentClass AND [DocumentID]=@DocumentID)
	BEGIN
		UPDATE [ExternalLink]
		SET
			[ItemID] = @ItemID
		WHERE
			[DeviceID] = @DeviceID AND 
			[DocumentClass] = @DocumentClass AND 
			[DocumentID] = @DocumentID
	END
	ELSE
	BEGIN
		IF EXISTS(SELECT * FROM [ExternalLink] WHERE [DeviceID] = @DeviceID AND [ItemID] = @ItemID)
			UPDATE [ExternalLink]
			SET 
				[DocumentClass] = @DocumentClass,
				[DocumentID] = @DocumentID
			WHERE
				[DeviceID] = @DeviceID AND [ItemID] = @ItemID
		ELSE
			INSERT INTO [ExternalLink] 
				([DeviceID], [ItemID], [DocumentClass], [DocumentID]) 
			VALUES
				(@DeviceID, @ItemID, @DocumentClass, @DocumentID)
	END

	RETURN 0
GO

GRANT EXEC ON PjmSyncUpdateExternalLink TO PUBLIC
GO