IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ProjectTemplateUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ProjectTemplateUpdate'
		DROP PROCEDURE [dbo].[pjm5ProjectTemplateUpdate]
	END
GO

PRINT 'Creating procedure pjm5ProjectTemplateUpdate'
GO

/******************************************************************************
**		File: ProjectTemplateUpdate.sql
**		Name: pjm5ProjectTemplateUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 11:01:32
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		21.05.10	SYV		          [ExchangeSystemName]  
**		15.06.10	KOV				  [FolderID]
**		22.04.11	SYV				  GroupCalculationLines, ShowActivityTypes
**									GroupingAdvanceCalculations  
**		14.07.11	SYV				 UseSubProjects
**		25.02.13	SAP				  OPENXML
**		09.07.13	SOV				   . -  . -   
*******************************************************************************/
CREATE PROCEDURE pjm5ProjectTemplateUpdate
	@Xml	XML
AS
	DECLARE
		@ID TIdentifier,
		@AssignmentState TState,
		@CurrencyCode TCode3,
		@doc int,
		
		@AssignmentID TIdentifier,
		@EmployeeName TName,
		@QualificationID TIdentifier,
		@StandardRate TMoney,
		@OvertimeRate TMoney,
		@rv int,
		@InvoicePeriodType TCode,
		@InvoiceDayType TCode,
		@InvoiceNextPaymentDate TDate,
		@StatementPeriodType TCode,
		@StatementDayType TCode,
		@StatementNextPaymentDate TDate,
		@CalculationPeriodType TCode,
		@CalculationDayType TCode,
		@CalculationNextPaymentDate TDate,
		@BudgetTemplateID Tidentifier,
		@UseBudgetPlanning TBool,
		@value TVariant,

		@ExternalNotificationOpenIssue bit,
		@ExternalNotificationResolveIssue bit,
		@ExternalNotificationPostponeIssue bit,
		@ExternalNotificationCloseIssue bit,

		@DiscountTypeByTime					TIdentifier,
		@DiscountViewByTime					TBool,
		@DiscountByTime						TMoney,
		
		@DiscountTypeByExpense				TIdentifier,
		@DiscountViewByExpense				TBool,
		@DiscountByExpense					TMoney,
		
		@DiscountTypeByPhone				TIdentifier,
		@DiscountViewByPhone				TBool,
		@DiscountByPhone					TMoney,
		
		@DiscountTypeByServiceRequest		TIdentifier,
		@DiscountViewByServiceRequest		TBool,
		@DiscountByServiceRequest			TMoney

	SET NOCOUNT ON
	
	EXEC adfParameterGet @Name='UseBudgetPlanning', @Group='Pjm6', @Value = @value OUTPUT
	SET @UseBudgetPlanning = CAST(@value as bit)

	SELECT
		@ID = @Xml.value('(/pjm5ProjectTemplateGet/ProjectTemplate/ID)[1]','int'),
		@InvoicePeriodType = @Xml.value('(/pjm5ProjectTemplateGet/ProjectTemplate/InvoicePeriodType)[1]','varchar(32)'),
		@InvoiceDayType = @Xml.value('(/pjm5ProjectTemplateGet/ProjectTemplate/InvoiceDayType)[1]','varchar(32)'),
		@InvoiceNextPaymentDate = CAST(@Xml.value('(/pjm5ProjectTemplateGet/ProjectTemplate/InvoiceNextPaymentDate)[1]','varchar(19)') AS datetime),
		@StatementPeriodType = @Xml.value('(/pjm5ProjectTemplateGet/ProjectTemplate/StatementPeriodType)[1]','varchar(32)'),
		@StatementDayType = @Xml.value('(/pjm5ProjectTemplateGet/ProjectTemplate/StatementDayType)[1]','varchar(32)'),
		@StatementNextPaymentDate = CAST(@Xml.value('(/pjm5ProjectTemplateGet/ProjectTemplate/StatementNextPaymentDate)[1]','varchar(19)') AS datetime),
		@CalculationPeriodType = @Xml.value('(/pjm5ProjectTemplateGet/ProjectTemplate/CalculationPeriodType)[1]','varchar(32)'),
		@CalculationDayType = @Xml.value('(/pjm5ProjectTemplateGet/ProjectTemplate/CalculationDayType)[1]','varchar(32)'),
		@CalculationNextPaymentDate = CAST(@Xml.value('(/pjm5ProjectTemplateGet/ProjectTemplate/CalculationNextPaymentDate)[1]','varchar(19)') AS datetime),
		@BudgetTemplateID = @Xml.value('(/pjm5ProjectTemplateGet/ProjectTemplate/BudgetTemplateID)[1]','int'),
		@ExternalNotificationOpenIssue =
			CASE @Xml.value('(/pjm5ProjectTemplateGet/ProjectTemplate/ExternalNotificationOpenIssue)[1]','varchar(5)') 
				WHEN 'false' THEN 0 
				ELSE 1 
			END,
		@ExternalNotificationResolveIssue =
			CASE @Xml.value('(/pjm5ProjectTemplateGet/ProjectTemplate/ExternalNotificationResolveIssue)[1]','varchar(5)') 
				WHEN 'false' THEN 0 
				ELSE 1 
			END,
		@ExternalNotificationPostponeIssue =
			CASE @Xml.value('(/pjm5ProjectTemplateGet/ProjectTemplate/ExternalNotificationPostponeIssue)[1]','varchar(5)') 
				WHEN 'false' THEN 0 
				ELSE 1 
			END,
		@ExternalNotificationCloseIssue =
			CASE @Xml.value('(/pjm5ProjectTemplateGet/ProjectTemplate/ExternalNotificationCloseIssue)[1]','varchar(5)') 
				WHEN 'false' THEN 0 
				ELSE 1 
			END,
		@DiscountTypeByTime	= @Xml.value('(/pjm5ProjectTemplateGet/ProjectTemplate/DiscountTypeByTime)[1]','int'),
		@DiscountViewByTime	= @Xml.value('(/pjm5ProjectTemplateGet/ProjectTemplate/DiscountViewByTime)[1]','bit'),
		@DiscountByTime	= @Xml.value('(/pjm5ProjectTemplateGet/ProjectTemplate/DiscountByTime)[1]','decimal(18,4)'),
		
		@DiscountTypeByExpense = @Xml.value('(/pjm5ProjectTemplateGet/ProjectTemplate/DiscountTypeByExpense)[1]','int'),
		@DiscountViewByExpense = @Xml.value('(/pjm5ProjectTemplateGet/ProjectTemplate/DiscountViewByExpense)[1]','bit'),
		@DiscountByExpense = @Xml.value('(/pjm5ProjectTemplateGet/ProjectTemplate/DiscountByExpense)[1]','decimal(18,4)'),
		
		@DiscountTypeByPhone = @Xml.value('(/pjm5ProjectTemplateGet/ProjectTemplate/DiscountTypeByPhone)[1]','int'),
		@DiscountViewByPhone = @Xml.value('(/pjm5ProjectTemplateGet/ProjectTemplate/DiscountViewByPhone)[1]','bit'),
		@DiscountByPhone = @Xml.value('(/pjm5ProjectTemplateGet/ProjectTemplate/DiscountByPhone)[1]','decimal(18,4)'),
		
		@DiscountTypeByServiceRequest = @Xml.value('(/pjm5ProjectTemplateGet/ProjectTemplate/DiscountTypeByServiceRequest)[1]','int'),
		@DiscountViewByServiceRequest = @Xml.value('(/pjm5ProjectTemplateGet/ProjectTemplate/DiscountViewByServiceRequest)[1]','bit'),
		@DiscountByServiceRequest = @Xml.value('(/pjm5ProjectTemplateGet/ProjectTemplate/DiscountByServiceRequest)[1]','decimal(18,4)')

	BEGIN TRANSACTION
	UPDATE
		[PaymentPeriod]
	SET
		[InvoicePeriodType] = @InvoicePeriodType,
		[InvoiceDayType] = @InvoiceDayType,
		[InvoiceNextPaymentDate] = @InvoiceNextPaymentDate,
		[StatementPeriodType] = @StatementPeriodType,
		[StatementDayType] = @StatementDayType,
		[StatementNextPaymentDate] = @StatementNextPaymentDate,
		[CalculationPeriodType] = @CalculationPeriodType,
		[CalculationDayType] = @CalculationDayType,
		[CalculationNextPaymentDate] = @CalculationNextPaymentDate
	WHERE
		[ProjectID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	UPDATE 
		[Project]
	SET
		@ID = [XmlTable].[ID],
		@CurrencyCode = [XmlTable].[CurrencyCode],
		[Project].[Date] = [XmlTable].[Date],
		[Project].[Number] = [XmlTable].[Number],
		[Project].[FileAs] = [XmlTable].[FileAs],
		[Project].[ProjectTypeID] = [XmlTable].[ProjectTypeID],
		[Project].[SupplierCompanyID] = [XmlTable].[SupplierCompanyID],
		[Project].[ManagerAssistantEmployeeID] = [XmlTable].[ManagerAssistantEmployeeID],
		[Project].[FinanceManagerEmployeeID] = [XmlTable].[FinanceManagerEmployeeID],
		[Project].[CustomerCompanyID] = [XmlTable].[CustomerCompanyID],
		[Project].[CustomerFinanceManagerID] = [XmlTable].[CustomerFinanceManagerID],
		[Project].[ResponsiblePersonEmployeeID] = [XmlTable].[ResponsiblePersonEmployeeID],
		[Project].[PriorityID] = [XmlTable].[PriorityID],
		[Project].[ProjectLanguageCode] = [XmlTable].[ProjectLanguageCode],
		[Project].[CurrencyCode] = [XmlTable].[CurrencyCode],
		[Project].[CostCenterID] = [XmlTable].[CostCenterID],
		[Project].[Budget] = [XmlTable].[Budget],
		[Project].[ContractNumber] = [XmlTable].[ContractNumber],
		[Project].[ContractDate] = [XmlTable].[ContractDate],
		[Project].[ContractEndDate] = [XmlTable].[ContractEndDate],
		[Project].[ContractSubject] = [XmlTable].[ContractSubject],
		[Project].[ApplyVAT] = [XmlTable].[ApplyVAT],
		[Project].[InvoiceExpirationPeriod] = [XmlTable].[InvoiceExpirationPeriod],
		[Project].[InvoiceExpirationPeriodType] = [XmlTable].[InvoiceExpirationPeriodType],
		[Project].[Comments] = [XmlTable].[Comments],
		[Project].[ContractComments] = [XmlTable].[ContractComments],
		[Project].[RoundingMode] = [XmlTable].[RoundingMode],
		[Project].[RoundingInterval] = [XmlTable].[RoundingInterval],
		[Project].[Billable] = [XmlTable].[Billable],
		[Project].[Modified] = GETDATE(),
		[Project].[ModifiedBy] = dbo.adfGetCurrentUserID(),
		[Project].[SupportsRequestManagement] = [XmlTable].[SupportsRequestManagement],
		[Project].[RatesWithVAT] = CASE [XmlTable].[ApplyVAT]
				WHEN 1 THEN [XmlTable].[RatesWithVAT]
				ELSE 0
			END,
		[Project].[PaymentCurrencyPoint] = [XmlTable].[PaymentCurrencyPoint],
		[Project].[InitialBalance] = [XmlTable].[InitialBalance],
		[Project].[BaseInitialBalance] = [XmlTable].[BaseInitialBalance],
		[Project].[InvoiceCurrency] = [XmlTable].[InvoiceCurrency],
		[Project].[StatementCurrency] = [XmlTable].[StatementCurrency],
		[Project].[FactureCurrency] = [XmlTable].[FactureCurrency],
		[Project].[Scale] = [XmlTable].[Scale],
		[Project].[FolderID] = [XmlTable].[FolderID],
		[Project].[ExchangeSystemName] = [XmlTable].[ExchangeSystemName],
		[Project].[GroupingAdvanceCalculations] = [XmlTable].[GroupingAdvanceCalculations],
		[Project].[ShowActivityTypes] = [XmlTable].[ShowActivityTypes],
		[Project].[GroupCalculationLines] = [XmlTable].[GroupCalculationLines],
		[Project].[ShowPrice] = [XmlTable].[ShowPrice],
		[Project].[UseSubProjects] = [XmlTable].[UseSubProjects],
		[Project].[Color] = [XmlTable].[Color],
		[Project].[GroupByProjects] = [XmlTable].[GroupByProjects]
	FROM
		[Project] INNER JOIN
	(
		SELECT
			T.c.value('ID[1]','int') AS [ID],
			CAST(T.c.value('Date[1]','varchar(19)') as datetime) AS [Date],
			T.c.value('Number[1]','varchar(32)') AS [Number],
			T.c.value('FileAs[1]','nvarchar(256)') AS [FileAs],
			T.c.value('ProjectTypeID[1]','int') AS [ProjectTypeID],
			T.c.value('SupplierCompanyID[1]','int') AS [SupplierCompanyID],
			T.c.value('ManagerAssistantEmployeeID[1]','int') AS [ManagerAssistantEmployeeID],
			T.c.value('FinanceManagerEmployeeID[1]','int') AS [FinanceManagerEmployeeID],
			T.c.value('CustomerCompanyID[1]','int') AS [CustomerCompanyID],
			T.c.value('CustomerFinanceManagerID[1]','int') AS [CustomerFinanceManagerID],
			T.c.value('ResponsiblePersonEmployeeID[1]','int') AS [ResponsiblePersonEmployeeID],
			T.c.value('PriorityID[1]','int') AS [PriorityID],
			T.c.value('ProjectLanguageCode[1]','varchar(32)') AS [ProjectLanguageCode],
			T.c.value('CurrencyCode[1]','char(3)') AS [CurrencyCode],
			T.c.value('CostCenterID[1]','int') AS [CostCenterID],
			T.c.value('ManHour[1]','int') AS [ManHour],
			T.c.value('Budget[1]','money') AS [Budget],
			T.c.value('ContractNumber[1]','varchar(32)') AS [ContractNumber],
			CAST(T.c.value('ContractDate[1]','varchar(19)') as datetime) as [ContractDate],
			CAST(T.c.value('ContractEndDate[1]','varchar(19)') as datetime) as [ContractEndDate],
			T.c.value('ContractSubject[1]','nvarchar(256)') AS [ContractSubject],
			(CASE T.c.value('ApplyVAT[1]','varchar(5)') 
				WHEN 'false' THEN 0 
				ELSE 1 
			 END) as [ApplyVAT],
			T.c.value('InvoiceExpirationPeriod[1]','int') AS [InvoiceExpirationPeriod],
			T.c.value('InvoiceExpirationPeriodType[1]','int') AS [InvoiceExpirationPeriodType],
			T.c.value('WSSDocumentsURL[1]','varchar(512)') AS [WSSDocumentsURL],
			T.c.value('Comments[1]','nvarchar(max)') AS [Comments],
			T.c.value('ContractComments[1]','nvarchar(max)') AS [ContractComments],
			T.c.value('RoundingInterval[1]','int') AS [RoundingInterval],
			T.c.value('RoundingMode[1]','int') AS [RoundingMode],
			(CASE  
				WHEN T.c.value('ProjectTypeID[1]','int') IN (1) THEN 1 
				ELSE 0 
				END) AS [Billable],
			(CASE T.c.value('SupportsRequestManagement[1]','varchar(5)') 
				WHEN 'false' THEN 0 
				ELSE 1 
			 END) AS [SupportsRequestManagement],
			(CASE T.c.value('RatesWithVAT[1]','varchar(5)')
				WHEN 'false' THEN 0 
				ELSE 1 
			 END) AS [RatesWithVAT],
			T.c.value('PaymentCurrencyPoint[1]','int') AS [PaymentCurrencyPoint],
			T.c.value('InitialBalance[1]','money') AS [InitialBalance],
			T.c.value('BaseInitialBalance[1]','money') AS [BaseInitialBalance],
			T.c.value('InvoiceCurrency[1]','int') AS [InvoiceCurrency],
			T.c.value('StatementCurrency[1]','int') AS [StatementCurrency],
			T.c.value('FactureCurrency[1]','int') AS [FactureCurrency],
			T.c.value('Scale[1]','int') AS [Scale],
			T.c.value('FolderID[1]','int') AS [FolderID],
			T.c.value('ExchangeSystemName[1]','nvarchar(256)') AS [ExchangeSystemName],
			T.c.value('GroupingAdvanceCalculations[1]','int') AS [GroupingAdvanceCalculations],
			(CASE T.c.value('ShowActivityTypes[1]','varchar(5)') 
				WHEN 'false' THEN 0 
				ELSE 1 
			 END) AS [ShowActivityTypes],
			(CASE T.c.value('GroupCalculationLines[1]','varchar(5)') 
				WHEN 'false' THEN 0 
				ELSE 1 
			 END) AS [GroupCalculationLines],
			(CASE T.c.value('ShowPrice[1]','varchar(5)') 
				WHEN 'false' THEN 0 
				ELSE 1 
			 END) AS [ShowPrice],
			T.c.value('UseSubProjects[1]','bit') AS [UseSubProjects],
			T.c.value('Color[1]','int') AS [Color],
			T.c.value('GroupByProjects[1]','bit') AS [GroupByProjects]
		FROM
			@Xml.nodes('/pjm5ProjectTemplateGet/ProjectTemplate') AS T(c)
		WHERE
			T.c IS NOT NULL) 
			AS [XmlTable]
				ON ([Project].[ID] = [XmlTable].[ID])
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	UPDATE [ProjectDetail]
	SET
		[DiscountTypeByTime] = @DiscountTypeByTime,
		[DiscountViewByTime] = @DiscountViewByTime,
		[DiscountByTime] = @DiscountByTime,
		
		[DiscountTypeByExpense] = @DiscountTypeByExpense,
		[DiscountViewByExpense] = @DiscountViewByExpense,
		[DiscountByExpense] = @DiscountByExpense,
		
		[DiscountTypeByPhone] = @DiscountTypeByPhone,
		[DiscountViewByPhone] = @DiscountViewByPhone,
		[DiscountByPhone] = @DiscountByPhone,
		
		[DiscountTypeByServiceRequest] = @DiscountTypeByServiceRequest,
		[DiscountViewByServiceRequest] = @DiscountViewByServiceRequest,
		[DiscountByServiceRequest] = @DiscountByServiceRequest
	FROM
		[ProjectDetail]
		INNER JOIN
		(
		SELECT
			@Xml.value('(/pjm5ProjectTemplateGet/ProjectTemplate/ID)[1]','int') AS [ID]
		) AS [XmlTable] ON
			[ProjectDetail].[ID] = [XmlTable].[ID]
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	DELETE FROM [ProjectActivityType] WHERE [ProjectActivityType].[ProjectID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	INSERT INTO [ProjectActivityType]
			([ProjectID], [ActivityTypeID], [Billable], [Actively])
	SELECT
		@ID,
		T.c.value('ID[1]','int'),
		(CASE T.c.value('Billable[1]','varchar(5)') WHEN 'false' THEN 0 ELSE 1 END),
		(CASE T.c.value('Actively[1]','varchar(5)') WHEN 'false' THEN 0 ELSE 1 END)
	FROM
		@Xml.nodes('/pjm5ProjectTemplateGet/ProjectActivityType') AS T(c)
	WHERE
		T.c IS NOT NULL

	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	DELETE FROM [ProjectExpenseCode] WHERE [ProjectExpenseCode].[ProjectID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END
	
	INSERT INTO [ProjectExpenseCode]
			([ProjectID], [ExpenseCodeID], [Billable], [Actively])
	SELECT
		@ID,
		T.c.value('ID[1]','int'),
		(CASE T.c.value('Billable[1]','varchar(5)') WHEN 'false' THEN 0 ELSE 1 END),
		(CASE T.c.value('Actively[1]','varchar(5)') WHEN 'false' THEN 0 ELSE 1 END)
	FROM
		@Xml.nodes('/pjm5ProjectTemplateGet/ProjectExpenseCode') AS T(c)
	WHERE
		T.c IS NOT NULL

	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	DECLARE @TemplateClass TClass
	SET @TemplateClass = dbo.adfGetClassByName('Pjm5.ProjectTemplate')
	UPDATE 
		[Document]
	SET 
		[Flag] = [Project].[Flag], 
		[FileAs] = [Project].[FileAs], 
		[Modified] = [Project].[Modified], 
		[ModifiedBy] = [Project].[ModifiedBy]
	FROM
		[Document]
		INNER JOIN [Project]
			ON [Document].[ID] = [Project].[ID] AND
				[Document].[Class] = @TemplateClass
	WHERE
		[Project].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN 1
	END

	IF @UseBudgetPlanning = 0
		SET @BudgetTemplateID = NULL


	UPDATE
		[ProjectTemplate]
	SET
		[BudgetTemplateID] = @BudgetTemplateID
	WHERE
		[ProjectTemplate].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END

	DECLARE 
			@SubscriptionRuleID TIdentifier,
			@UserID TIdentifier,
			@OpenIssueID TIdentifier,
			@ResolveIssueID TIdentifier,
			@PostponeIssueID TIdentifier,
			@CloseIssueID TIdentifier

	SELECT
		@UserID = dbo.adfGetCurrentUserID(),
		@OpenIssueID = dbo.fnPjm5GetSubscriptionTypeByCode('ExternalOpenIssue'),
		@ResolveIssueID = dbo.fnPjm5GetSubscriptionTypeByCode('ExternalResolveIssue'),
		@PostponeIssueID = dbo.fnPjm5GetSubscriptionTypeByCode('ExternalPostponeIssue'),
		@CloseIssueID = dbo.fnPjm5GetSubscriptionTypeByCode('ExternalCloseIssue')
	
	EXEC @rv = dbo.pjm5ExternalSubscriptionRuleCreate @SubscriptionRuleID OUTPUT, @ID, @UserID
	IF @rv != 0 OR @SubscriptionRuleID IS NULL
	BEGIN
		ROLLBACK TRANSACTION
		RETURN @rv
	END
	
	IF @ExternalNotificationOpenIssue = 1
	BEGIN
		EXEC @rv = dbo.pjm5ExternalSubscriptionCreate @SubscriptionRuleID, @OpenIssueID
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN @rv
		END
	END
	
	IF @ExternalNotificationResolveIssue = 1
	BEGIN
		EXEC @rv = dbo.pjm5ExternalSubscriptionCreate @SubscriptionRuleID, @ResolveIssueID
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN @rv
		END
	END
	
	IF @ExternalNotificationPostponeIssue = 1
	BEGIN
		EXEC @rv = dbo.pjm5ExternalSubscriptionCreate @SubscriptionRuleID, @PostponeIssueID
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN @rv
		END
	END
	
	IF @ExternalNotificationCloseIssue = 1
	BEGIN
		EXEC @rv = dbo.pjm5ExternalSubscriptionCreate @SubscriptionRuleID, @CloseIssueID
		IF @rv != 0
		BEGIN
			ROLLBACK TRANSACTION
			RETURN @rv
		END
	END
	COMMIT TRANSACTION

	EXEC pjm5ProjectTemplateGet @ID
GO

GRANT EXECUTE ON pjm5ProjectTemplateUpdate TO PUBLIC
GO
 