IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6GetProjectStatementCurrency]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6GetProjectStatementCurrency'
		DROP PROCEDURE [dbo].[pjm6GetProjectStatementCurrency]
	END
GO

PRINT 'Creating procedure pjm6GetProjectStatementCurrency'
GO

/******************************************************************************
**		File: pjm6GetProjectStatementCurrency.sql
**		Name: pjm6GetProjectStatementCurrency
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 10/05/2004 18:09:19
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm6GetProjectStatementCurrency
	@ProjectID TIdentifier
AS
BEGIN
	DECLARE
		@BankAccountID TIdentifier,
		@CurrencyCode TCode3,
		@StatementCurrencyPoint TBool
		
	SELECT
		@BankAccountID = [Project].[BankAccountID],
		@StatementCurrencyPoint = [Project].[StatementCurrencyPoint],
		@CurrencyCode = [Project].[CurrencyCode]
	FROM
		[Project]
	WHERE
		[Project].[ID] = @ProjectID
	
	IF @StatementCurrencyPoint = 0
	BEGIN
		SELECT @CurrencyCode
		RETURN 0
	END
		
	IF(@BankAccountID IS NULL)
	BEGIN
		SELECT
			@BankAccountID = [Company].[BankAccountID]
		FROM
			[Project]
			INNER JOIN [Company]
				ON [Project].[SupplierCompanyID] = [Company].[ID]
		WHERE
			[Project].[ID] = @ProjectID
	END
	
	SELECT
		@CurrencyCode = [BankAccount].[CurrencyCode]
	FROM
		[BankAccount]
	WHERE
		[BankAccount].[ID] = @BankAccountID
	
	SELECT @CurrencyCode
	RETURN 0
END
GO

GRANT EXECUTE ON pjm6GetProjectStatementCurrency TO PUBLIC
GO


  