IF EXISTS (SELECT * FROM sysobjects WHERE type = 'P' AND name = 'ReportProjectTimeAllocationByEmployeeHeader')
	BEGIN
		PRINT 'Dropping Procedure ReportProjectTimeAllocationByEmployeeHeader'
		DROP  Procedure  ReportProjectTimeAllocationByEmployeeHeader
	END
GO

PRINT 'Creating Procedure ReportProjectTimeAllocationByEmployeeHeader'
GO
/******************************************************************************
**		File: ReportProjectTimeAllocationByEmployeeHeader.sql
**		Name: ReportProjectTimeAllocationByEmployeeHeader
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: MAN
**		Date: 18/11/2010 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		18.11.2010	MAN				First Version
*******************************************************************************/
CREATE PROCEDURE [dbo].[ReportProjectTimeAllocationByEmployeeHeader]
        @CompanyID TIdentifier,
        @DivisionID TIdentifier,
        @PeriodName TName,
        @PeriodStart TDateTime,
        @PeriodEnd TDateTime,
        @RoundedType TIdentifier
AS
SET NOCOUNT ON
DECLARE
	@CompanyName TName,
	@DivisionName TName,
	@WorkingDays	decimal(18,2),
	@UserName TName,
	@UserID TIdentifier,
	@RoundedTypeName TName

SET @CompanyName = '()'

SELECT 
	@CompanyName = [Company].[FileAs]
FROM
    [Company]
WHERE 
    [Company].[ID] = @CompanyID   

SELECT 
	@DivisionName = [Division].[FileAs]
FROM
   [Division]
WHERE 
   [Division].[ID] = @DivisionID
  	
   SET DATEFIRST 7
   SET @WorkingDays = dbo.fnPjm5GetWorkingDays(@PeriodStart,DATEADD(day, -1, @PeriodEnd))
   SET DATEFIRST 1

   SET @UserID = dbo.adfGetCurrentUserID()
	
SELECT
	@UserName = [Trustee].[DisplayName]
FROM 
	[Trustee]
WHERE 
	[Trustee].[ID] = @UserID

SET @RoundedTypeName =
	CASE @RoundedType
		WHEN 1 THEN ' '
		WHEN 0 THEN '   ' 
	END

SELECT
     @CompanyName  AS [CompanyName],
     @DivisionName AS [DivisionName],
     @WorkingDays AS [WorkingDays],
     @WorkingDays*8 as [WorkingHours],
     @UserName as [UserName],
     @PeriodName AS [PeriodName],
     @RoundedTypeName AS [RoundedTypeName]
     


RETURN 0
GO

GRANT EXEC ON ReportProjectTimeAllocationByEmployeeHeader TO PUBLIC
GO
