IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5ServiceSelectorBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5ServiceSelectorBrowse'
		DROP PROCEDURE [dbo].[pjm5ServiceSelectorBrowse]
	END
GO

PRINT 'Creating procedure pjm5ServiceSelectorBrowse'
GO

/******************************************************************************
**		File: pjm5ServiceSelectorBrowse.sql
**		Name: pjm5ServiceSelectorBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/18/2005 20:56:48
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5ServiceSelectorBrowse]
	@ProjectID INT,
	@Assigned bit
AS
	DECLARE
		@CurrencyCode TCode
	
	SET NOCOUNT ON
	SELECT @CurrencyCode = [CurrencyCode] FROM [Project] WHERE [ID] = @ProjectID
	IF @Assigned = 0
	BEGIN
		SELECT
			[Service].[Class],
			[Service].[ID],
			[Service].[State],
			[Service].[Flag],
			[Service].[Code],
			[Service].[FileAs],
			[Service].[PaymentTermID],
			[PaymentTerm].[FileAs] AS [PaymentTerm],
			CAST(NULL AS int) AS [Amount],
			[ServicePrice].[Price],
			[Service].[Created],
			[Service].[CreatedBy],
			[Service].[Modified],
			[Service].[ModifiedBy],
			[Service].[Timestamp],
			[ServiceType].[Code]
		FROM
			[Service]
			INNER JOIN [ServiceType]
				ON [ServiceType].[ID] = [Service].[ServiceTypeID]
			LEFT OUTER JOIN [ServicePrice]
				ON ([Service].[ID] = [ServicePrice].[ServiceID] AND
					[ServicePrice].[CurrencyCode] = @CurrencyCode)
			LEFT OUTER JOIN [PaymentTerm]
				ON [PaymentTerm].[ID] = [Service].[PaymentTermID]
		WHERE
			([Service].[State] = 1)
	END
	ELSE
	BEGIN
		SELECT
			[ServiceAssignment].[Class],
			[ServiceAssignment].[ID],
			[ServiceAssignment].[State],
			[ServiceAssignment].[Flag],
			[Service].[Code],
			[ServiceAssignment].[FileAs],
			[Service].[PaymentTermID],
			[PaymentTerm].[FileAs] AS [PaymentTerm],
			[ServiceAssignment].[RateMultiplier] AS [Amount],
			[ServiceAssignment].[Price],
			[ServiceAssignment].[Created],
			[ServiceAssignment].[CreatedBy],
			[ServiceAssignment].[Modified],
			[ServiceAssignment].[ModifiedBy],
			[ServiceAssignment].[Timestamp],
			[ServiceType].[Code]
		FROM
			[ServiceAssignment]
			INNER JOIN [Service] 
				ON [Service].[ID] = [ServiceAssignment].[ServiceID]
			INNER JOIN [ServiceType]
				ON [ServiceType].[ID] = [ServiceAssignment].[ServiceTypeID]
			LEFT OUTER JOIN [PaymentTerm]
				ON [PaymentTerm].[ID] = [Service].[PaymentTermID]
		WHERE
			[ServiceAssignment].[ProjectID] = @ProjectID AND
			[ServiceAssignment].[State] = 1
	END		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5ServiceSelectorBrowse] TO PUBLIC
GO
 