 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TaskBrowseMyTimeLine]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5TaskBrowseMyTimeLine'
		DROP PROCEDURE [dbo].[pjm5TaskBrowseMyTimeLine]
	END
GO

PRINT 'Creating procedure pjm5TaskBrowseMyTimeLine'
GO

/******************************************************************************
**		File: pjm5TaskBrowseMyTimeLine.sql
**		Name: pjm5TaskBrowseMyTimeLine
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 13:49:21
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    	01.09.2011	MAN	Cast to DateTime
*******************************************************************************/
CREATE PROCEDURE [pjm5TaskBrowseMyTimeLine]
	@StateSelector	INT,
	@PeriodStart	TDateTime = NULL,
	@PeriodEnd		TDateTime = NULL,
	@Milestone		int
AS
	SET NOCOUNT ON
	DECLARE
		@today datetime,
		@ViewAllFinance TBool,
		@CurrentEmployeeID TIdentifier
		
	IF @PeriodStart IS NULL
		SET @PeriodStart = CAST('17530101' as Datetime)
	IF @PeriodEnd IS NULL
		SET @PeriodEnd = CAST('99991231' as DateTime)

	SET @today = GETDATE()
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @ViewAllFinance = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllFinance'))
		
	SELECT
		[Task].[Class],
		[Task].[ID],
		[Task].[State],
		[Task].[Flag],
		[Task].[FileAs],
		[Task].[ProjectID],
		[Task].[PriorityID],
		[Task].[ParentID],
		[Task].[StartDate],
		[Task].[DueDate],
		DATEADD(hour, 24, [Task].[DueDate]) as [DueDateTL],
		[Task].[EndDate],
		[Task].[Duration],
		[Task].[PercentComplete],
		[Task].[Milestone],
		dbo.fnPjm5GetWorkingDays(@today, [Task].[DueDate]) AS [RestDays],
		[Task].[PlanPercent],
		[Task].[ManHour] / 60.0 AS [ManHour],
		CASE 
			WHEN @ViewAllFinance = 1 OR [Project].[ProjectManagerEmployeeID] = @CurrentEmployeeID
				THEN [Task].[Budget]
			ELSE -1
		END AS [Budget],
		[Task].[RealManHour],
		CASE
			WHEN [Task].[ManHour] != 0 THEN
				CAST([Task].[RealManHour] as decimal(18,2))/[Task].[ManHour]
			ELSE 0
		END AS [RealManHourPercent],
		CASE 
			WHEN @ViewAllFinance = 1 OR [Project].[ProjectManagerEmployeeID] = @CurrentEmployeeID
				THEN [Task].[TimeRealBudget]+[Task].[ExpenseRealBudget]
			ELSE -1
		END AS [RealBudget],
		CASE
			WHEN [Task].[Budget] != 0 THEN
				CAST([Task].[TimeRealBudget]+[Task].[ExpenseRealBudget] as decimal(18,2))/[Task].[Budget]
			ELSE 0
		END AS [RealBudgetPercent],
		[Task].[Comments],
		[Task].[Created],
		[Task].[CreatedBy],
		[Task].[Modified],
		[Task].[ModifiedBy],
		[Task].[Timestamp],
		[Project].[Number] AS [Project],
		[Priority].[FileAs] AS [Priority],
		CAST([Task].[Milestone] as tinyint) as M,
		(CAST([Task].[PercentComplete] * 100 as int) / 25) * 25 as PC,
		(SELECT COUNT([Sub].[ID]) FROM [Task] AS [Sub] WHERE [Sub].[ParentID] = [Task].[ID] ) AS [SubCount]
	FROM
		[pjm5vwTask] AS [Task]
		INNER JOIN [Project]
			ON [Task].[ProjectID] = [Project].[ID]
		INNER JOIN [Priority]
			ON [Priority].[ID] = [Task].[PriorityID]
		INNER JOIN [Class]
			ON [Class].[Class] = [Task].[Class]
	WHERE
		([Task].[DueDate] >= @PeriodStart) AND
		([Task].[StartDate] < @PeriodEnd) AND
		([Task].[State] <>7) AND
		(
			@StateSelector = 0 OR 
			(@StateSelector = 1 AND [Task].[State] IN (1,2,8)) 
		) AND
		(
			ISNULL(@Milestone, 0) != 1 OR [Task].[Milestone] = 1
		) AND
		(
			(
			EXISTS(
				SELECT * 
				FROM
					[TaskAssignment]
					INNER JOIN [vwAssignment] AS [Assignment]
						ON [TaskAssignment].[AssignmentID] = [Assignment].[ID]
				WHERE
					[TaskAssignment].[TaskID] = [Task].[ID] AND
					[Assignment].[EmployeeID] = @CurrentEmployeeID
					AND [TaskAssignment].[MsAvailable] = 1
				)
			)	
		) AND [Task].[SubprojectID] IS NULL

		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5TaskBrowseMyTimeLine] TO PUBLIC
GO
 