 IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6TaskBudgetOverdraftBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6TaskBudgetOverdraftBrowse'
		DROP PROCEDURE [dbo].[pjm6TaskBudgetOverdraftBrowse]
	END
GO

PRINT 'Creating procedure pjm6TaskBudgetOverdraftBrowse'
GO

/******************************************************************************
**		File: pjm6TaskBudgetOverdraftBrowse.sql
**		Name: pjm6TaskBudgetOverdraftBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 13:49:21
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm6TaskBudgetOverdraftBrowse]
AS
	SET NOCOUNT ON
	DECLARE
		@ViewAllTasks bit,
		@today datetime,
		@ViewAllFinance TBool,
		@CurrentEmployeeID TIdentifier
		
	SET @today = GETDATE()	
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @ViewAllFinance = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllFinance'))
	SET @ViewAllTasks = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllTasks'))

	DECLARE
		@PeriodStart TDate,
		@PeriodEnd TDate
	SELECT
		@PeriodStart = CAST(CONVERT(varchar(8), GETDATE(), 112) AS datetime),
		@PeriodEnd = DATEADD(day, 1, @PeriodStart)
	;
	WITH [Tasks] ([ID], [RealManHour], [RealBudget], [EstimatedBudget]) AS (
		SELECT
			[Task].[ID],
			[Task].[RealManHour],
			CAST([Task].[TimeRealBudget]+[Task].[ExpenseRealBudget] as decimal(18,2)),
			SUM(
				(ISNULL([BusyEntry].[Planned], 0) - ISNULL([BusyEntry].[OvertimeWork], 0)) * ISNULL([Assignment].[StandardRate], 0) +
				ISNULL([BusyEntry].[OvertimeWork], 0) * COALESCE([Assignment].[OvertimeRate], [Assignment].[StandardRate], 0)
			) / 60.0
		FROM
			[pjm5vwTask] AS [Task]
			INNER JOIN [Project]
				ON [Task].[ProjectID] = [Project].[ID]
			LEFT OUTER JOIN [BusyEntry]
				ON [BusyEntry].[TaskID] = [Task].[ID] AND [BusyEntry].[Date] <= @today
			LEFT OUTER JOIN [Assignment]
				ON [Assignment].[ID] = [BusyEntry].[AssignmentID]
		WHERE
			[Task].[State] = 2 AND
			[Task].[SubprojectID] IS NULL AND
			(
				@ViewAllTasks = 1 OR 
				[Project].[ProjectManagerEmployeeID] = @CurrentEmployeeID
			)
		GROUP BY 
			[Task].[ID],
			[Task].[RealManHour],
			[Task].[TimeRealBudget],
			[Task].[ExpenseRealBudget]
		HAVING
			CAST([Task].[TimeRealBudget]+[Task].[ExpenseRealBudget] as decimal(18,2)) >
			SUM(
				(ISNULL([BusyEntry].[Planned], 0) - ISNULL([BusyEntry].[OvertimeWork], 0)) * ISNULL([Assignment].[StandardRate], 0) +
				ISNULL([BusyEntry].[OvertimeWork], 0) * COALESCE([Assignment].[OvertimeRate], [Assignment].[StandardRate], 0)
			) / 60.0
	)
	SELECT
		[Task].[Class],
		[Task].[ID],
		[Task].[State],
		[Task].[Flag],
		[Task].[FileAs],
		[Task].[ProjectID],
		[Task].[PriorityID],
		[Task].[ParentID],
		[Task].[StartDate],
		[Task].[DueDate],
		[Task].[EndDate],
		[Task].[Duration],
		[Task].[PercentComplete],
		[Task].[Milestone],
		[Task].[ManHour] / 60.0 AS [ManHour],
		[Tasks].[RealManHour],
		[Task].[Budget],
		[Tasks].[EstimatedBudget],
		[Tasks].[RealBudget],
		CASE
			WHEN [Task].[Budget] != 0 THEN
				CAST([Tasks].[EstimatedBudget] as decimal(18,2))/[Task].[Budget]
			ELSE 0
		END AS [EstimatedBudgetPercent],
		CASE
			WHEN [Task].[Budget] != 0 THEN
				CAST([Tasks].[RealBudget] as decimal(18,2))/[Task].[Budget]
			ELSE 0
		END AS [RealBudgetPercent],
		[Task].[Comments],
		[Task].[Created],
		[Task].[CreatedBy],
		[Task].[Modified],
		[Task].[ModifiedBy],
		[Task].[Timestamp],
		CAST([Task].[Milestone] as tinyint) as M,
		(CAST([Task].[PercentComplete] * 100 as int) / 25) * 25 as PC
	FROM
		[Tasks]
		INNER JOIN [Task]
			ON [Task].[ID] = [Tasks].[ID]

	RETURN 0
GO

GRANT EXECUTE ON [pjm6TaskBudgetOverdraftBrowse] TO PUBLIC
GO
    
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6TaskMyBudgetOverdraftBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
BEGIN
	PRINT 'Dropping procedure pjm6TaskMyBudgetOverdraftBrowse'
	DROP PROCEDURE [dbo].[pjm6TaskMyBudgetOverdraftBrowse]
END
GO

PRINT 'Creating procedure pjm6TaskMyBudgetOverdraftBrowse'
GO

/******************************************************************************
**		File: pjm6TaskMyBudgetOverdraftBrowse.sql
**		Name: pjm6TaskMyBudgetOverdraftBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Andrew.Maklakov
**		Date: 01/20/2005 13:49:21
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**		15.08.11	SYV				    
*******************************************************************************/
CREATE PROCEDURE [pjm6TaskMyBudgetOverdraftBrowse]
AS
	SET NOCOUNT ON
	DECLARE
		@ViewAllTasks bit,
		@today datetime,
		@ViewAllFinance TBool,
		@CurrentEmployeeID TIdentifier
		
	SET @today = GETDATE()	
	SET @CurrentEmployeeID = dbo.adfGetCurrentEmployeeID()
	SET @ViewAllFinance = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllFinance'))
	SET @ViewAllTasks = dbo.adfHasAccessRight(dbo.adfGetRightID('ViewAllTasks'))

	DECLARE
		@PeriodStart TDate,
		@PeriodEnd TDate
	SELECT
		@PeriodStart = CAST(CONVERT(varchar(8), GETDATE(), 112) AS datetime),
		@PeriodEnd = DATEADD(day, 1, @PeriodStart)
	;
	WITH [Tasks] ([ID], [RealManHour], [RealBudget], [EstimatedBudget]) AS (
		SELECT
			[Task].[ID],
			[Task].[RealManHour],
			CAST([Task].[TimeRealBudget]+[Task].[ExpenseRealBudget] as decimal(18,2)),
			SUM(
				(ISNULL([BusyEntry].[Planned], 0) - ISNULL([BusyEntry].[OvertimeWork], 0)) * ISNULL([Assignment].[StandardRate], 0) +
				ISNULL([BusyEntry].[OvertimeWork], 0) * COALESCE([Assignment].[OvertimeRate], [Assignment].[StandardRate], 0)
			)
		FROM
			[pjm5vwTask] AS [Task]
			LEFT OUTER JOIN [BusyEntry]
				ON [BusyEntry].[TaskID] = [Task].[ID] AND [BusyEntry].[Date] <= @today
			LEFT OUTER JOIN [Assignment]
				ON [Assignment].[ID] = [BusyEntry].[AssignmentID]
		WHERE
			[Task].[State] = 2 AND
			[Task].[SubprojectID] IS NULL AND
			(
				EXISTS(
					SELECT * 
					FROM
						[TaskAssignment] INNER JOIN [vwAssignment] AS [Assignment]
							ON [TaskAssignment].[AssignmentID] = [Assignment].[ID]
					WHERE
						[TaskAssignment].[TaskID] = [Task].[ID] AND
						[Assignment].[EmployeeID] = @CurrentEmployeeID
					)
			)
		GROUP BY 
			[Task].[ID],
			[Task].[RealManHour],
			[Task].[TimeRealBudget],
			[Task].[ExpenseRealBudget]
		HAVING
			CAST([Task].[TimeRealBudget]+[Task].[ExpenseRealBudget] as decimal(18,2)) >
			SUM(
				(ISNULL([BusyEntry].[Planned], 0) - ISNULL([BusyEntry].[OvertimeWork], 0)) * ISNULL([Assignment].[StandardRate], 0) +
				ISNULL([BusyEntry].[OvertimeWork], 0) * COALESCE([Assignment].[OvertimeRate], [Assignment].[StandardRate], 0)
			) / 60.0
	)
	SELECT
		[Task].[Class],
		[Task].[ID],
		[Task].[State],
		[Task].[Flag],
		[Task].[FileAs],
		[Task].[ProjectID],
		[Task].[PriorityID],
		[Task].[ParentID],
		[Task].[StartDate],
		[Task].[DueDate],
		[Task].[EndDate],
		[Task].[Duration],
		[Task].[PercentComplete],
		[Task].[Milestone],
		[Task].[ManHour] / 60.0 AS [ManHour],
		[Tasks].[RealManHour],
		CASE 
			WHEN @ViewAllFinance = 1 OR [Project].[ProjectManagerEmployeeID] = @CurrentEmployeeID
				THEN [Task].[Budget]
			ELSE -1
		END AS [Budget],
		CASE 
			WHEN @ViewAllFinance = 1 OR [Project].[ProjectManagerEmployeeID] = @CurrentEmployeeID
				THEN [Tasks].[EstimatedBudget]
			ELSE -1
		END AS [EstimatedBudget],
		CASE 
			WHEN @ViewAllFinance = 1 OR [Project].[ProjectManagerEmployeeID] = @CurrentEmployeeID
				THEN [Tasks].[RealBudget]
			ELSE -1
		END AS [RealBudget],
		CASE
			WHEN [Task].[Budget] != 0 THEN
				CAST([Tasks].[EstimatedBudget] as decimal(18,2))/[Task].[Budget]
			ELSE 0
		END AS [EstimatedBudgetPercent],
		CASE
			WHEN [Task].[Budget] != 0 THEN
				CAST([Tasks].[RealBudget] as decimal(18,2))/[Task].[Budget]
			ELSE 0
		END AS [RealBudgetPercent],
		[Task].[Comments],
		[Task].[Created],
		[Task].[CreatedBy],
		[Task].[Modified],
		[Task].[ModifiedBy],
		[Task].[Timestamp],
		CAST([Task].[Milestone] as tinyint) as M,
		(CAST([Task].[PercentComplete] * 100 as int) / 25) * 25 as PC
	FROM
		[Tasks]
		INNER JOIN [Task]
			ON [Task].[ID] = [Tasks].[ID]
		INNER JOIN [Project]
			ON [Task].[ProjectID] = [Project].[ID]
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm6TaskMyBudgetOverdraftBrowse] TO PUBLIC
GO
    