IF EXISTS (SELECT * FROM sysobjects WHERE type = 'TR' AND name = 'pjm6trTaskInsert')
	BEGIN
		PRINT 'Dropping Trigger pjm6trTaskInsert'
		DROP  Trigger pjm6trTaskInsert
	END
GO

/******************************************************************************
**		File: 
**		Name: pjm6trTaskInsert
**		Desc: 
**
**		This template can be customized:
**              
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:				Description:
**		--------		--------				-------------------------------------------
**    
*******************************************************************************/

PRINT 'Creating Trigger pjm6trTaskInsert'
GO
CREATE TRIGGER pjm6trTaskInsert ON [Task] FOR INSERT
AS
	IF @@rowcount = 0
		RETURN;

	INSERT INTO [TaskWbs] ([TaskID], [TaskIndex]) SELECT [ID], 0 FROM [inserted]
	IF @@error != 0
	BEGIN
		ROLLBACK TRANSACTION
		RETURN
	END
		
	RETURN
GO

  
 IF EXISTS (SELECT * FROM sysobjects WHERE type = 'TR' AND name = 'pjm5trTaskCloseProject')
	BEGIN
		PRINT 'Dropping Trigger pjm5trTaskCloseProject'
		DROP  Trigger pjm5trTaskCloseProject
	END
GO

/******************************************************************************
**		File: 
**		Name: pjm5trTaskCloseProject
**		Desc: 
**
**		This template can be customized:
**              
**
**		Auth: 
**		Date: 
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:				Description:
**		--------		--------				-------------------------------------------
**    
*******************************************************************************/

PRINT 'Creating Trigger pjm5trTaskCloseProject'
GO
CREATE TRIGGER pjm5trTaskCloseProject ON [Task] FOR INSERT, DELETE, UPDATE
AS
	IF @@rowcount = 0 
		RETURN

	SET NOCOUNT ON
	IF (EXISTS (
			SELECT * FROM [inserted]
			INNER JOIN [Project] ON [Project].[ID] = [inserted].[ProjectID]
			WHERE [Project].[State] = 4
		)
	)
	BEGIN
		RAISERROR('#TaskFailedInCompleteProject', 16, -1)
		ROLLBACK TRANSACTION
	END
	
	IF (EXISTS (
			SELECT * FROM [deleted]
			INNER JOIN [Project] ON [Project].[ID] = [deleted].[ProjectID]
			WHERE [Project].[State] = 4
		)
	)
	BEGIN
		RAISERROR('#TaskFailedInCompleteProject', 16, -1)
		ROLLBACK TRANSACTION
	END
	
	RETURN
GO

  