IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm6TaskRequestApproved]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm6TaskRequestApproved'
		DROP PROCEDURE [dbo].[pjm6TaskRequestApproved]
	END
GO

PRINT 'Creating procedure pjm6TaskRequestApproved'
GO

/******************************************************************************
**		File: pjm6TaskRequestApproved.sql
**		Name: pjm6TaskRequestApproved
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 01/21/2006 18:26:20
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm6TaskRequestApproved
	@ID TIdentifier
AS
	SET NOCOUNT ON
	DECLARE 
		@FromID TIdentifier,
		@Language TCode,
		@Class TClass,
		@FileAs TName
		
	SET @FromID = dbo.adfGetCurrentUserID()
	SET @Language = dbo.adfGetLanguage()
	SET @Class = dbo.adfGetClassByName('Pjm5.TaskRequest')
	SELECT @FileAs = [FileAs] FROM [TaskRequest] WHERE [ID] = @ID
	
	INSERT INTO [MailItem]
		([State], [Flag], [FileAs], [EventType], [FromID], [ToID], [DocumentClass], [DocumentID], [Read], [Data], [Comments])
	SELECT
		1,
		0,
		@FileAs,
		N'TaskRequestAppointed',
		@FromID,
		[Employee].[UserID],
		@Class,
		@ID,
		0,
		NULL, --@FileAs,
		CASE @Language 
			WHEN 'en' THEN 'You have been assigned to Task Request "' + @FileAs + '".' 
			ELSE '    "' + @FileAs + '".'
		END
	FROM 
		[TaskRequestAssignment]
		INNER JOIN [Employee] 
			ON [TaskRequestAssignment].[EmployeeID] = [Employee].[ID]
	WHERE
		[TaskRequestAssignment].[TaskRequestID] = @ID AND 
		[Employee].[UserID] IS NOT NULL AND
		[Employee].[UserID] != @FromID


	INSERT INTO [MailItem]
		([State], [Flag], [FileAs], [EventType], [FromID], [ToID], [DocumentClass], [DocumentID], [Read], [Data], [Comments])
	SELECT
		1,
		0,
		@FileAs,
		N'TaskRequestSupervisorAssigned',
		@FromID,
		[Employee].[UserID],
		@Class,
		@ID,
		0,
		NULL, --@FileAs,
		CASE @Language 
			WHEN 'en' THEN 'You have been assigned as Task Request "' + @FileAs + '" Supervisor.'
			ELSE '    "' + @FileAs + '".'
		END
	FROM 
		[TaskRequest]
		INNER JOIN [Employee] 
			ON [TaskRequest].[SupervisorEmployeeID] = [Employee].[ID]
	WHERE
		[TaskRequest].[ID] = @ID AND 
		[Employee].[UserID] IS NOT NULL AND
		[Employee].[UserID] != @FromID

	RETURN 0
GO

GRANT EXECUTE ON pjm6TaskRequestApproved TO PUBLIC
GO
