IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TimeEntryImport]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5TimeEntryImport'
		DROP PROCEDURE [dbo].[pjm5TimeEntryImport]
	END
GO

PRINT 'Creating procedure pjm5TimeEntryImport'
GO

/******************************************************************************
**		File: pjm5TimeEntryImport.sql
**		Name: pjm5TimeEntryImport
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: pavel.boruroev
**		Date: 01/20/2005 16:11:01
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5TimeEntryImport]
	@FileAs TName,
	@ProjectCode TCode,
	@StartTime TDateTime,
	@Duration TCount,
	@EmployeeEmail TName,
	@Comments TNotes	
AS	
	SET NOCOUNT ON
	
	DECLARE 
			@BusinessCardClass	TClass,
			@State				TState,
			@ProjectID			TIdentifier,
			@EmployeeID			TIdentifier,
			@AssignmentID		TIdentifier,
			@ID					TIdentifier,
			@ActivityTypeID		TIdentifier,
			@RoundedDuration	TCount,
			@CurrencyCode		TCode3,
			@Rate				TMoney,
			@ActivityTypeIsMandatory bit,
			@VATRate			TPercent,
			@rv int,
			@value TVariant,
			@sendToApprove bit
	
	IF @Duration IS NULL OR @Duration < 0
	BEGIN
		RAISERROR('#DurationIsInvalid', 18, -1)
		RETURN 1
	END
			
	SELECT
		@ProjectID = [ID],
		@CurrencyCode = [CurrencyCode],
		@RoundedDuration = dbo.fnPjm5RoundedDuration(@Duration, [RoundingInterval], [RoundingMode])
	FROM
		[Project]
	WHERE
		[Number] = @ProjectCode AND [State] = 2 

	IF @ProjectID IS NULL
	BEGIN
		RAISERROR('#invalidprojectcode', 18, -1)
		RETURN 1
	END
			
	SET @BusinessCardClass = dbo.adfGetClassByName('Adf.Employee')
	
	SELECT
		@EmployeeID = [Employee].[ID]
	FROM
		[Employee]
		INNER JOIN [BusinessCard]
			ON ([BusinessCard].[Class] = @BusinessCardClass AND
			 [Employee].[ID] = [BusinessCard].[ID])
		INNER JOIN [Email]
			ON [Email].[BusinessCardID] = [BusinessCard].[ID]
	WHERE
		[Email].[Email] = @EmployeeEmail
	
	IF @EmployeeID IS NULL
	BEGIN
		RAISERROR('#EmployeeNotFound', 18, -1)
		RETURN 1
	END
	
	SET @Rate = dbo.fnPjm5GetEmployeeRate(@EmployeeID, @ProjectID, 0, NULL, 0)

	SET @VATRate = dbo.fnPjm5GetVATRate()
	
	SET @State = dbo.adfwfGetInitialState('6719512d-42ee-4848-a57e-f76500e67ee7')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END
	
	EXEC adfParameterGet @Name='TimeEntrySendForApproving', @Group='Pjm5', @Value = @value OUTPUT
	SET @sendToApprove = ISNULL(CAST(@value as bit), 0)

	DECLARE @var sql_variant

	EXEC adfParameterGet 'ActivityTypeIsMandatory', 'Pjm5', @var OUTPUT
	IF @var IS NULL
		SET @ActivityTypeIsMandatory = 1
	ELSE
		SET @ActivityTypeIsMandatory = CAST(@var as BIT)
	
	IF @ActivityTypeID IS NULL AND @ActivityTypeIsMandatory = 1
	BEGIN
		RAISERROR('#activitytypecannotbenull', 18, -1)
		RETURN 1
	END
	
	INSERT INTO [TimeEntry]
		([Flag], [State], [FileAs], [ActivityTypeID], [EmployeeID], [ProjectID], [TaskID], 
		[StartTime], [Duration], [RoundedDuration], [Billable], 
		[Overtime], [Rate], [CurrencyCode], [VATRate], 
		[Comments])
	VALUES
		(0, @State, ISNULL(@FileAs, ''), @ActivityTypeID, @EmployeeID, @ProjectID, NULL, 
		 @StartTime, @Duration, @RoundedDuration, 0, 
		 0, @Rate, @CurrencyCode, @VATRate, 
		 @Comments)
			
	IF @@ERROR != 0
	BEGIN
		RAISERROR('#InsertTimeEntryFailed', 18, -1)
		RETURN 1
	END
	SET @ID = SCOPE_IDENTITY()
	
	IF @sendToApprove = 1
	BEGIN
		EXEC @rv = pjm5TimeEntryImportChangeState @ID, 2
		IF @rv != 0
		BEGIN
			RAISERROR('#ChangeStateTimeEntryFailed', 18, -1)
			RETURN @rv
		END
	END

	RETURN 0
GO

GRANT EXECUTE ON pjm5TimeEntryImport TO PUBLIC
GO
   