IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TimerBrowse]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5TimerBrowse'
		DROP PROCEDURE [dbo].[pjm5TimerBrowse]
	END
GO

PRINT 'Creating procedure pjm5TimerBrowse'
GO

/******************************************************************************
**		File: pjm5TimerBrowse.sql
**		Name: pjm5TimerBrowse
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 03/01/2005 19:12:20
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5TimerBrowse]
AS
	DECLARE @EmployeeID TIdentifier
		
	SET NOCOUNT ON
	
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	
	SELECT
		[Timer].[Class],
		[Timer].[ID],
		[Timer].[State],
		[Timer].[Flag],
		[Timer].[FileAs],
		[Timer].[ProjectID],
		[Timer].[TaskID],
		[Timer].[ActivityTypeID],
		@EmployeeID as [EmployeeID],
		[Timer].[Comments],
		[Timer].[Created],
		[Timer].[CreatedBy],
		[Timer].[Modified],
		[Timer].[ModifiedBy],
		[Timer].[Timestamp]
	FROM
		[Timer]
	WHERE
		[Timer].[CreatedBy] = (SELECT [UserID] FROM [Employee] WHERE [ID] = @EmployeeID)
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5TimerBrowse] TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TimerGet]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5TimerGet'
		DROP PROCEDURE [dbo].[pjm5TimerGet]
	END
GO

PRINT 'Creating procedure pjm5TimerGet'
GO

/******************************************************************************
**		File: pjm5TimerGet.sql
**		Name: pjm5TimerGet
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 03/01/2005 19:12:20
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5TimerGet]
	@ID TIdentifier
AS
	DECLARE @EmployeeID TIdentifier
		
	SET NOCOUNT ON
	
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	
	SELECT
		[Timer].[Class],
		[Timer].[ID],
		[Timer].[State],
		[Timer].[Flag],
		[Timer].[FileAs],
		[Timer].[ProjectID],
		[Timer].[TaskID],
		[Timer].[ActivityTypeID],
		@EmployeeID as [EmployeeID],
		[Timer].[Comments],
		[Timer].[Created],
		[Timer].[CreatedBy],
		[Timer].[Modified],
		[Timer].[ModifiedBy],
		[Timer].[Timestamp]
	FROM
		[Timer]
	WHERE
		[Timer].[ID] = @ID
	AND
		[Timer].[CreatedBy] = (SELECT [UserID] FROM [Employee] WHERE [ID] = @EmployeeID)
		
	RETURN 0
GO

GRANT EXECUTE ON [pjm5TimerGet] TO PUBLIC
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TimerCreate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5TimerCreate'
		DROP PROCEDURE [dbo].[pjm5TimerCreate]
	END
GO

PRINT 'Creating procedure pjm5TimerCreate'
GO

/******************************************************************************
**		File: pjm5TimerCreate.sql
**		Name: pjm5TimerCreate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 03/01/2005 19:12:20
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE [pjm5TimerCreate]
	@FileAs TName,
	@ProjectID TIdentifier,
	@TaskID TIdentifier,
	@ActivityTypeID TIdentifier,
	@Comments TNotes
AS
	DECLARE @State TState,
			@ID TIdentifier
	
	SET NOCOUNT ON
	
	SET @State = dbo.adfwfGetInitialState('66ba2ab0-9a47-4f4c-a601-130ac6131ded')
	IF @State IS NULL
	BEGIN
		RAISERROR('#accessdenied', 18, -1)
		RETURN 1
	END

	INSERT INTO [Timer]
		([Flag], [State], [FileAs], [ProjectID], [TaskID], [ActivityTypeID], [Comments])
	VALUES
		(0, @State, @FileAs, @ProjectID, @TaskID, @ActivityTypeID, @Comments)
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	SET @ID = SCOPE_IDENTITY()

	EXEC pjm5TimerGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5TimerCreate TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TimerUpdate]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5TimerUpdate'
		DROP PROCEDURE [dbo].[pjm5TimerUpdate]
	END
GO

PRINT 'Creating procedure pjm5TimerUpdate'
GO

/******************************************************************************
**		File: pjm5TimerUpdate.sql
**		Name: pjm5TimerUpdate
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 03/01/2005 19:12:20
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5TimerUpdate
	@ID TIdentifier,
	@FileAs TName,
	@ProjectID TIdentifier,
	@TaskID TIdentifier,
	@ActivityTypeID TIdentifier,
	@Comments TNotes
AS
	
	SET NOCOUNT ON
	
	UPDATE 
		[Timer]
	SET
		[Timer].[FileAs] = @FileAs,
		[Timer].[ProjectID] = @ProjectID,
		[Timer].[TaskID] = @TaskID,
		[Timer].[ActivityTypeID] = @ActivityTypeID,
		[Timer].[Comments] = @Comments,
		[Timer].[Modified] = GETDATE(),
		[Timer].[ModifiedBy] = dbo.adfGetCurrentUserID()
	WHERE
		[Timer].[ID] = @ID
	IF @@ERROR != 0
	BEGIN
		RETURN 1
	END

	EXEC pjm5TimerGet @ID

	RETURN 0
GO

GRANT EXECUTE ON pjm5TimerUpdate TO PUBLIC
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[pjm5TimerDelete]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	BEGIN
		PRINT 'Dropping procedure pjm5TimerDelete'
		DROP PROCEDURE [dbo].[pjm5TimerDelete]
	END
GO

PRINT 'Creating procedure pjm5TimerDelete'
GO

/******************************************************************************
**		File: pjm5TimerDelete.sql
**		Name: pjm5TimerDelete
**		Desc: this procedure automatically generated by Avicom.Adf.Generator
**
**              
**		Return values:
** 
**		Called by:   
**              
**		Parameters:
**		Input							Output
**      ----------						-----------
**
**		Auth: Dmitry.Kolchev
**		Date: 03/01/2005 19:12:20
*******************************************************************************
**		Change History
*******************************************************************************
**		Date:		Author:			Description:
**		--------	--------		-------------------------------------------
**    
*******************************************************************************/
CREATE PROCEDURE pjm5TimerDelete
	@ID TIdentifier
AS
	DECLARE @EmployeeID TIdentifier
		
	SET NOCOUNT ON
	
	SET @EmployeeID = dbo.adfGetCurrentEmployeeID()
	
	DELETE FROM [Timer] 
	WHERE 
		[Timer].[ID] = @ID
	AND
		[Timer].[CreatedBy] = (SELECT [UserID] FROM [Employee] WHERE [ID] = @EmployeeID)

	IF @@ERROR != 0
		RETURN 1

	RETURN 0
GO

GRANT EXECUTE ON pjm5TimerDelete TO PUBLIC
GO
